
c compute energy difference between different vp's or nuclear positions
c  using direct (brute force) method

      subroutine ediff(nsteps,nblocks,
     >                npos1,epos1,centers1,rotmat1,vp1,mup1,mdown1,nac1,
     >                npos2,epos2,centers2,rotmat2,vp2,mup2,mdown2,nac2,
     >                ed,err,e1,err1,e2,err2,
     >                ke2,ke_err2,pe2,pe_err2)
         implicit none
         include 'param.h'
         integer nsteps,nblocks
         real*8 mup1(nup,nup),mdown1(ndown,ndown)
         real*8 epos1(ndim,nelec),npos1(ndim,nelec),centers1(ndim,npair)
         real*8 rotmat1(ndim,ndim,npair),vp1(nvp)
         real*8 mup2(nup,nup),mdown2(ndown,ndown)
         real*8 epos2(ndim,nelec),npos2(ndim,nelec),centers2(ndim,npair)
         real*8 rotmat2(ndim,ndim,npair),vp2(nvp)
         integer nac1,nac2
         real*8 ed,err,e1,err1,e2,err2
         real*8 ke2,ke_err2,pe2,pe_err2
         real*8 tke1,tpe1,tke2,tpe2,lpsi,det
      
         

         

         integer ns,nb,n1,n2,inb
         real*8 en1,en2
         real*8 nuc_e1,nuc_e2

         real*8 sum_e1,sum_e2,ssq_e1,ssq_e2,v1,v2,vk,vp
         real*8 sum_ke2,ssq_ke2,sum_pe2,ssq_pe2

       
         call total_nuclear_potential(npos1,nuc_e1)
         call total_nuclear_potential(npos2,nuc_e2)

         sum_e1 = 0.d0
         ssq_e1 = 0.d0
         det = 0.d0
         if (group1) then
         do nb=1,nblocks
            do ns=1,nsteps
               call metropolis(mup1,mdown1,npos1,epos1,centers1,
     >                         rotmat1,vp1,det,n1)
               nac1 = nac1 + n1
            enddo
            call local_energy(npos1,epos1,mup1,mdown1,centers1,rotmat1,
     >                        vp1,en1,tke1,tpe1,lpsi)
            sum_e1 = sum_e1 + en1
            ssq_e1 = ssq_e1 + en1*en1
         enddo
         endif ! group1

         sum_e2 = 0.d0
         ssq_e2 = 0.d0
         sum_ke2 = 0.d0
         ssq_ke2 = 0.d0
         sum_pe2 = 0.d0
         ssq_pe2 = 0.d0
         if (group2) then
         do nb=1,nblocks
            do ns=1,nsteps
               call metropolis(mup2,mdown2,npos2,epos2,centers2,
     >                         rotmat2,vp2,det,n2)
               nac2 = nac2 + n2
            enddo
            call local_energy(npos2,epos2,mup2,mdown2,centers2,rotmat2,
     >                        vp2,en2,tke2,tpe2,lpsi)
            sum_e2 = sum_e2 + en2
            ssq_e2 = ssq_e2 + en2*en2
            sum_ke2 = sum_ke2 + tke2
            ssq_ke2 = ssq_ke2 + tke2*tke2
            sum_pe2 = sum_pe2 + tpe2
            ssq_pe2 = ssq_pe2 + tpe2*tpe2
         enddo
         endif ! group2


         sum_e1 = sum_e1/nblocks
         sum_e2 = sum_e2/nblocks
         sum_ke2 = sum_ke2/nblocks
         sum_pe2 = sum_pe2/nblocks


         ssq_e1 = sum_e1*sum_e1
         ssq_e2 = sum_e2*sum_e2
         ssq_ke2 = sum_ke2*sum_ke2
         ssq_pe2 = sum_pe2*sum_pe2

         call sum_reduce(sum_e1)
         call sum_reduce(sum_e2)
         call sum_reduce(sum_ke2)
         call sum_reduce(sum_pe2)
         

         call sum_reduce(ssq_e1)
         call sum_reduce(ssq_e2)
         call sum_reduce(ssq_ke2)
         call sum_reduce(ssq_pe2)

c         inb = nblocks*nproc/2
         inb = nproc/2

         e1 = sum_e1/real(inb)
         e2 = sum_e2/real(inb) 
         ke2 = sum_ke2/real(inb) 
         pe2 = sum_pe2/real(inb)

         v1 = ssq_e1/real(inb) - e1*e1
         v2 = ssq_e2/real(inb) - e2*e2
         vk = ssq_ke2/real(inb) - ke2*ke2
         vp = ssq_pe2/real(inb) - pe2*pe2

         if (inb.gt.1) then
            err1 = sqrt(abs(v1)/real(inb-1))
            err2 = sqrt(abs(v2)/real(inb-1))
            ke_err2 = sqrt(abs(vk)/real(inb-1))
            pe_err2 = sqrt(abs(vp)/real(inb-1))
         endif

         e1 = e1 + nuc_e1
         e2 = e2 + nuc_e2
         pe2 = pe2 + nuc_e2

         ed = e1 - e2
         err = sqrt(err1**2 + err2**2)

      end
