
c compute energy difference between different vp's or nuclear positions
c  using direct (brute force) method

      subroutine ediff_dmc(nsteps,nblocks,nerrblocks,
     >                dmc_neq,dmc_nsteps,dmc_nblocks,
     >                npos1,epos1,centers1,rotmat1,vp1,mup1,mdown1,nac1,
     >                npos2,epos2,centers2,rotmat2,vp2,mup2,mdown2,nac2,
     >                ed,err,e1,err1,e2,err2,
     >                press,pr_err,ierr,ngood)
         implicit none
         include 'param.h'
         include 'dmc_inc.h'

         integer nsteps,nblocks,nerrblocks,dmc_nsteps,dmc_nblocks
         integer dmc_neq,ngood
         real*8 mup1(nup,nup),mdown1(ndown,ndown)
         real*8 epos1(ndim,nelec),npos1(ndim,nelec),centers1(ndim,npair)
         real*8 rotmat1(ndim,ndim,npair),vp1(nvp)
         real*8 mup2(nup,nup),mdown2(ndown,ndown)
         real*8 epos2(ndim,nelec),npos2(ndim,nelec),centers2(ndim,npair)
         real*8 rotmat2(ndim,ndim,npair),vp2(nvp)
         integer nac1,nac2,ierr
         real*8 ed,err,e1,err1,e2,err2
         real*8 ke2,pe2,ke_err2,pe_err2
         real*8 press,pr_err
         real*8 tke1,tpe1,tke2,tpe2,lpsi,det

c DMC vars
         integer k,j,dmc_nac1,dmc_nac2,iexit,nw,n
         real*8 dmc_en1,dmc_en2,dmc_err1,dmc_err2
         real*8 dmc_press1,dmc_pr_err1
         real*8 dmc_press2,dmc_pr_err2
         real*8 dmc_config(ndim,nelec,max_nwalker)
  
         real*8 rng
         external rng

         integer ns,nb,n1,n2,neb,data_good1,data_good2
         real*8 en1,en2,au_to_mbar
         real*8 nuc_e1,nuc_e2

         real*8 sum_e1,sum_e2,ssq_e1,ssq_e2,v1,v2,vk,vp
         real*8 sum_ke2,ssq_ke2,sum_pe2,ssq_pe2,esum,psum,ksum
         real*4 etime,tme,tme1(2),tme2(2),vmc_time
         external etime

         au_to_mbar = 294.215d0
       
         call total_nuclear_potential(npos1,nuc_e1)
         call total_nuclear_potential(npos2,nuc_e2)

c  generate some VMC configurations, as well as VMC est. of energy
         tme = etime(tme1)
         sum_e1 = 0.d0
         ssq_e1 = 0.d0
         det = 0.d0
         do neb=1,nerrblocks
            esum = 0.d0
            do nb=1,nblocks
               do ns=1,nsteps
                  call metropolis(mup1,mdown1,npos1,epos1,centers1,
     >                            rotmat1,vp1,det,n1)
                  nac1 = nac1 + n1
               enddo
               call local_energy(npos1,epos1,mup1,mdown1,centers1,
     >                           rotmat1,vp1,en1,tke1,tpe1,lpsi)
               esum = esum + en1
            enddo
            en1 = esum/nblocks
            sum_e1 = sum_e1 + en1
            ssq_e1 = ssq_e1 + en1*en1
            do k=1,nelec
               do j=1,ndim
                  dmc_config(j,k,neb) = epos1(j,k)
               enddo
            enddo

         enddo  !nerrblocks
         tme = etime(tme2)
         vmc_time = tme2(1)-tme1(1)

         call sum_reduce(sum_e1)
         call sum_reduce(ssq_e1)
c         e1 = sum_e1/dble(nerrblocks)
         n = nproc*nerrblocks
         e1 = sum_e1/dble(n)
         e1 = e1 + nuc_e1
         nw = nerrblocks

         call run_dmc(dmc_neq,dmc_nsteps,dmc_nblocks,nw,
     >                npos1,centers1,rotmat1,vp1,mup1,mdown1,dmc_nac1,
     >                dmc_config,e1,nuc_e1,dmc_en1,dmc_err1,
     >                dmc_press1,dmc_pr_err1,
     >                data_good1)

c         if (iexit.ne.0) then
cc            ierr = 1
cc            return
c         else
c             data_good1 = 1
c         endif




c generate VMC configurations, as well as est. of energy

         tme = etime(tme1)
         sum_e2 = 0.d0
         ssq_e2 = 0.d0
         sum_ke2 = 0.d0
         ssq_ke2 = 0.d0
         sum_pe2 = 0.d0
         ssq_pe2 = 0.d0
         do neb=1,nerrblocks
            esum = 0.d0
            psum = 0.d0
            ksum = 0.d0
            do nb=1,nblocks
               do ns=1,nsteps
                  call metropolis(mup2,mdown2,npos2,epos2,centers2,
     >                            rotmat2,vp2,det,n2)
                  nac2 = nac2 + n2
               enddo
               call local_energy(npos2,epos2,mup2,mdown2,centers2,
     >                           rotmat2,vp2,en2,tke2,tpe2,lpsi)
               esum = esum + en2
               psum = psum + tpe2
               ksum = ksum + tke2
            enddo
            en2 = esum/nblocks
            tpe2 = psum/nblocks
            tke2 = ksum/nblocks
            sum_e2 = sum_e2 + en2
            ssq_e2 = ssq_e2 + en2*en2
            sum_ke2 = sum_ke2 + tke2
            ssq_ke2 = ssq_ke2 + tke2*tke2
            sum_pe2 = sum_pe2 + tpe2
            ssq_pe2 = ssq_pe2 + tpe2*tpe2
            do k=1,nelec
               do j=1,ndim
                  dmc_config(j,k,neb) = epos1(j,k)
               enddo
            enddo
         enddo
         tme = etime(tme2)
         vmc_time = vmc_time + tme2(1)-tme1(1)

         call sum_reduce(sum_e2)
         call sum_reduce(ssq_e2)
         call sum_reduce(sum_ke2)
         call sum_reduce(ssq_ke2)
         call sum_reduce(sum_pe2)
         call sum_reduce(ssq_pe2)

         n = nproc*nerrblocks
c         e2 = sum_e2/real(nerrblocks)
         e2 = sum_e2/dble(n)
         e2 = e2 + nuc_e2

 

         nw = nerrblocks
         call run_dmc(dmc_neq,dmc_nsteps,dmc_nblocks,nw,
     >                npos2,centers2,rotmat2,vp2,mup2,mdown2,dmc_nac2,
     >                dmc_config,e2,nuc_e2,dmc_en2,dmc_err2,
     >                dmc_press2,dmc_pr_err2,
     >                data_good2)

c         if (iexit.ne.0) then
cc            ierr = 1
cc            return
c            data_good2 = 0
c         else
c            data_good2 = 1
c         endif


         ierr = 0


c  VMC results

c         e1 = sum_e1/real(nerrblocks)
c         e2 = sum_e2/real(nerrblocks) 
c         ke2 = sum_ke2/real(nerrblocks) 
c         pe2 = sum_pe2/real(nerrblocks) 
         n = nproc*nerrblocks
         e1 = sum_e1/dble(n)
         e2 = sum_e2/dble(n) 
         ke2 = sum_ke2/dble(n) 
         pe2 = sum_pe2/dble(n) 

c         v1 = ssq_e1/real(nerrblocks) - e1*e1
c         v2 = ssq_e2/real(nerrblocks) - e2*e2
c         vk = ssq_ke2/real(nerrblocks) - ke2*ke2
c         vp = ssq_pe2/real(nerrblocks) - pe2*pe2

         v1 = ssq_e1/dble(n) - e1*e1
         v2 = ssq_e2/dble(n) - e2*e2
         vk = ssq_ke2/dble(n) - ke2*ke2
         vp = ssq_pe2/dble(n) - pe2*pe2

         if (nb.gt.1) then
c            err1 = sqrt(abs(v1)/real(nerrblocks-1))
c            err2 = sqrt(abs(v2)/real(nerrblocks-1))
c            ke_err2 = sqrt(abs(vk)/real(nerrblocks-1))
c            pe_err2 = sqrt(abs(vp)/real(nerrblocks-1))
            err1 = sqrt(abs(v1)/dble(n-1))
            err2 = sqrt(abs(v2)/dble(n-1))
            ke_err2 = sqrt(abs(vk)/dble(n-1))
            pe_err2 = sqrt(abs(vp)/dble(n-1))
         endif

         e1 = e1 + nuc_e1
         e2 = e2 + nuc_e2
         pe2 = pe2 + nuc_e2

         ed = e1 - e2
         err = sqrt(err1**2 + err2**2)
         if (root) then
         print*,'vmcE1 = ',e1,err1
         print*,'vmcE2 = ',e2,err2
         print*,'vmcDE = ',e1-e2,err
         print*,'vmcKEPE = ',ke2,pe2
         print*,'vmcP = ',au_to_mbar*(2*ke2 + pe2)/(3.d0*box_vol)
         print*,'vmc time = ',vmc_time
         endif


c DMC results
c         call sum_reduce_int(data_good1)
c         call sum_reduce_int(data_good2)
         ngood = min(data_good1,data_good2)
         if (root) print*,'ngood:',data_good1,data_good2
         ngood = ngood*nerrblocks

         e1 = dmc_en1
         e2 = dmc_en2

         press = dmc_press2
         pr_err = dmc_pr_err2

         ed = e1 - e2
         err1 = dmc_err1
         err2 = dmc_err2
         
         err = sqrt(err1**2 + err2**2)





      end
