
c compute gradient wrt variational parameters

      subroutine compute_gradient(npos,epos,mup,mdown,centers,rotmat,
     >                            vp,det,dr,en,grad)
         implicit none
         include 'param.h'
         real*8 epos(ndim,nelec),npos(ndim,nnuclei)
         real*8 mup(nup,nup),mdown(ndown,ndown)
         real*8 centers(ndim,npair),rotmat(ndim,ndim,npair),vp(nvp)
c det is an input 
         real*8 det,dr 
         real*8 en,grad(nvp)


         real*8 ovp,det1

         call local_energy_vp(npos,epos,mup,mdown,centers,rotmat,vp,
     >                        en,grad(1),grad(ien))

         call fermion_vp_deriv(mup,mdown,epos,centers,rotmat,vp,
     >                         grad(id))

c  orbital cutoff parameter needs FD evaluation

          ovp = vp(nvp)

          vp(nvp) = vp(nvp) + dr
          call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
          call fermion_det_only(mup,mdown,det1)

          grad(nvp) = (det1/det-1.d0)/dr
          vp(nvp) = ovp
  
      end


      subroutine estimate_gradient(npos,epos,mup,mdown,centers,rotmat,
     >                             vp,dr,ns,nb,en,grad)
         implicit none
         include 'param.h'
         real*8 epos(ndim,nelec),npos(ndim,nnuclei)
         real*8 mup(nup,nup),mdown(ndown,ndown)
         real*8 centers(ndim,npair),rotmat(ndim,ndim,npair),vp(nvp)
c det is an input 
         real*8 dr 
         integer ns,nb
         real*8 en,grad(nvp)
         

         real*8 ave_psi(nvp),ave_en,ave_epsi(nvp),grad1(nvp)
         real*8 det,en1
         integer i,ins,inb,nac,nacc

         do i=1,nvp
            ave_psi(i) = 0.d0
            ave_epsi(i) = 0.d0
         enddo
         ave_en = 0.d0

         nacc = 0.d0

         do inb=1,nb
            call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
            call fermion_det(mup,mdown,det)
            do ins=1,ns
               call metropolis(mup,mdown,npos,epos,centers,rotmat,vp,
     >                         det,nac)
               nacc = nacc + nac
            enddo
            do i=1,nvp
               grad1(i) = 0.d0
            enddo
c            call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
c            call fermion_det(mup,mdown,det)
            call compute_gradient(npos,epos,mup,mdown,centers,rotmat,
     >                            vp,det,dr,en1,grad1)

            ave_en = ave_en + en1 
            do i=1,nvp
               ave_psi(i) = ave_psi(i) + grad1(i) 
               ave_epsi(i) = ave_epsi(i) + en1*grad1(i) 
            enddo
         enddo
         en = ave_en/nb
         do i=1,nvp
            grad(i) = 2.d0*(ave_epsi(i)-en*ave_psi(i))/nb
         enddo

         end
          
