
      subroutine optimize(nsteps,nblocks,nerrblocks,itmax,
     >                    npos1,epos1,mup1,mdown1,centers1,rotmat1,vp1,
     >                    scale)

      implicit none
      include 'param.h'
      integer nsteps,nerrblocks,nblocks,itmax
      real*8 epos1(ndim,nelec),npos1(ndim,nnuclei)
      real*8 mup1(nup,nup),mdown1(ndown,ndown)
      real*8 centers1(ndim,npair),rotmat1(ndim,ndim,npair),vp1(nvp)
      real*8 scale(nvp)

      real*8 epos2(ndim,nelec)
      real*8 mup2(nup,nup),mdown2(ndown,ndown)

      real*8 sum_b(nvp),ssq_b(nvp),b(nvp),err_b(nvp),newvp(nvp)
      real*8 tmp(nvp)
      real*8 en,v,dr,r,ed,err,e1,err1,e2,err2,ke,kerr,pe,perr
      real*8 gs,norm_b,nm_rel_b,sum_en,ssq_en,nuc_e
      integer i,j,neb,its,nac1,nac2,n_min_acc,inb

      real*4 etime,tme1(2),tme2(2),tme,grad_time,de_time
      external etime
      real*8 rng_cm
      external rng_cm

      dr = 1.0d-3
      gs = 1.d0

      n_min_acc = 0.d0

      do i=1,nelec
         do j=1,ndim
            epos2(j,i) = epos1(j,i)
         enddo
      enddo
 
      call total_nuclear_potential(npos1,nuc_e)

      grad_time = 0.d0
      de_time = 0.d0
 

      do its=1,itmax


c  compute gradient and its error
         do i=1,nvp
            sum_b(i) = 0.d0 
            ssq_b(i) = 0.d0 
         enddo
         sum_en = 0.d0
         ssq_en = 0.d0
         tme = etime(tme1)
         do neb=1,nerrblocks
            call estimate_gradient(npos1,epos1,mup1,mdown1,centers1,
     >             rotmat1,vp1,dr,nsteps,nblocks,en,b)
            do i=1,nvp
               sum_b(i) = sum_b(i) + b(i)
               ssq_b(i) = ssq_b(i) + b(i)**2
            enddo
            sum_en = sum_en + en
            ssq_en = ssq_en + en*en
         enddo
         call sum_reduce(sum_en)
         call sum_reduce(ssq_en)
         call sum_reduce_array(sum_b,tmp,nvp)
         call sum_reduce_array(ssq_b,tmp,nvp)
         inb = nerrblocks*nproc
         do i=1,nvp
            b(i) =  sum_b(i)/inb
            v = ssq_b(i)/inb - b(i)*b(i)
            if (inb.gt.1) err_b(i) = sqrt(v/(inb-1))
         enddo
         tme = etime(tme2)
         grad_time = grad_time + tme2(1)-tme1(1)

         en = sum_en/inb
         v = ssq_en/inb - en*en
         if (inb.gt.1) err1 = sqrt(v/(inb-1))
         if (root) write(*,*) 'ave e',en+nuc_e,err1

         norm_b = 0.d0
         nm_rel_b = 0.d0
         do i=1,nvp
            norm_b = norm_b + abs(b(i))
            nm_rel_b = nm_rel_b + abs(b(i)/err_b(i))
         enddo
         if (root) write(*,*) 'grad norm',norm_b/nvp,nm_rel_b/nvp

c  make a random, downhill-ish move

         r = rng_cm()
         do i=1,nvp
             newvp(i) = vp1(i) - gs*scale(i)*b(i)*r
         enddo
      do i=1,nelec
         do j=1,ndim
            epos2(j,i) = epos1(j,i)
         enddo
      enddo


c  compute energy difference
         if (root) tme = etime(tme1)
         call ts_diff(nsteps,nerrblocks,
     >                 npos1,epos1,centers1,rotmat1,newvp,mup1,mdown1,
     >                 nac1,
     >                 npos1,epos2,centers1,rotmat1,vp1,mup2,mdown2,
     >                 nac2,
     >                 ed,err,e1,err1,e2,err2,
     >                 ke,kerr,pe,perr)
         if (root) then
         tme = etime(tme2)

         write(*,*) 'ts ediff',ed,err
         write(*,'(''ts brute'',f12.6,e12.4,f12.6,3e12.4)') 
     >             e1,err1,e2,err2,e1-e2,sqrt(err1**2+err2**2)
         de_time = de_time + tme2(1)-tme1(1)
         endif

c  accept/reject
         if (ed.lt.0.d0) then
            if (root) write(*,*) '-------accept------'
            do i=1,nvp
               vp1(i) = newvp(i)
            enddo
            n_min_acc = n_min_acc + 1
         else
            if (root) write(*,*) '-------reject------'
            gs = gs*0.6d0
         endif

      enddo !itmax

      if (root) then
       write(*,*) 'min acc ratio',real(n_min_acc)/itmax
       write(*,*) 'grad time',grad_time/itmax,' de time',de_time/itmax
      endif

      end
