
c various parallel routines

      subroutine parallel_init()
         implicit none
         include 'param.h'
         include 'mpif.h'
         integer ierr,icolor,ikey

         call MPI_Init(ierr)
         call MPI_COMM_RANK(MPI_COMM_WORLD,myrank,ierr)
         call MPI_COMM_SIZE(MPI_COMM_WORLD,nproc,ierr)
         root= .false.
         if (myrank.eq.0) root = .true.
         group1 = .false.
         group2 = .false.
         if (myrank.lt.(nproc/2)) then
               icolor = 1
               ikey = myrank
               group1 = .true.
         endif
         if (myrank.ge.(nproc/2)) then
               icolor = 2
               ikey = myrank - nproc/2
               group2 = .true.
         endif
         call MPI_COMM_SPLIT(MPI_COMM_WORLD,icolor,ikey,my_comm,ierr)
 
      end 

      subroutine parallel_end()
         integer ierr
         call MPI_Finalize(ierr)
      end 

c ---------------------------------------------------------
      subroutine read_integer_par(n,c)
         implicit none
         include 'param.h'
         include 'mpif.h'
         integer n,ierr
         character*(*) c
         if (root) then
            print*,c
            read(5,*) n
            print*,c,' = ',n
         endif
c         if (root) read*, n
         call MPI_BCast(n,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
      end 

      subroutine read_double_par(r,c)
         implicit none
         include 'param.h'
         include 'mpif.h'
         integer ierr
         real*8 r
         character*(*) c
         if (root) then
            print*,c
            read(5,*) r
            print*,c,' = ',r
         endif
c         if (root) read*,r
         call MPI_BCast(r,1,MPI_DOUBLE,0,MPI_COMM_WORLD,ierr)
      end 
c ---------------------------------------------------------
      subroutine bcast_array(a,n)
         implicit none
         include 'param.h'
         include 'mpif.h'
         integer n
         real*8 a(n)
         integer ierr

         call MPI_BCast(a,n,MPI_DOUBLE,0,MPI_COMM_WORLD,ierr)
      end 

      subroutine sum_reduce(r)
         implicit none
         include 'param.h'
         include 'mpif.h'
         integer ierr
         real*8 r,temp
         temp =r
         call MPI_AllReduce(temp,r,1,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,
     >                      ierr)
      end

      subroutine sum_reduce_int(i)
         implicit none
         include 'param.h'
         include 'mpif.h'
         integer ierr
         integer i,temp
         temp =i
         call MPI_AllReduce(temp,i,1,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,
     >                      ierr)
      end

      subroutine sum_reduce_array(v,tmp,n)
         implicit none
         include 'param.h'
         include 'mpif.h'
         integer ierr,n,i
         real*8 v(n),tmp(n)
         do i=1,n
            tmp(i) =v(i)
         enddo
         call MPI_AllReduce(tmp,v,n,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,
     >                      ierr)
      end
