
c Sivera-Goldman potential
c  modified by Ross-Ree-Young

      subroutine rry_pot(npos,pot)
         implicit none 
         include 'param.h'
         real*8 npos(ndim,nnuclei)
         real*8 pot

c SG parameters
         real*8 c6,c8,c10,c9
         parameter (c6 = 12.14d0, c8 = 215.2d0, c10 = 4813.9d0)
         parameter (c9 = 143.1d0)
         real*8 alpha,beta,gamma
         parameter (alpha = 1.713d0, beta = 1.5671d0, gamma = 0.00993d0)
         real*8 rm
         parameter (rm = 6.44610)
        
c RRY parameters
         real*8 a,b,c,d,e,r1,rrc
         parameter(a = 9.1482d-4, b= 2.5230d0, c=0.63092)
         parameter(d = 0.14140d0, e = 0.019433d0)
         parameter(r1=2.26843, rrc = 4.8204)

 
         
         integer np,i,j
         real*8 cmdist,cmd(3),cm(3),cm2(3),cm1(3)
         real*8 r,rsq,r6,r8,r10,fc,p_att,p_rep,r9
         real*8 rmrc,rmrc2,rmrc3,rmr1,arg,p_rry

         pot = 0.d0
         do np=2,npair
            call box_dist(npos(1,2*np-1),npos(1,2*np),cmdist,cmd)
            do j=1,ndim
               cm1(j) = npos(j,2*np) + .5d0*cmd(j) 
            enddo
            call box_move(cm1,cm)
            do i=1,np-1
               call box_dist(npos(1,2*i-1),npos(1,2*i),cmdist,cmd)
               do j=1,ndim
                  cm1(j) = npos(j,2*i) + .5d0*cmd(j) 
               enddo
               call box_move(cm1,cm2)
               call box_dist(cm,cm2,r,cmd)
               if (r.gt.rrc) then
                  rsq = r*r
                  r6 = rsq*rsq*rsq
                  r8 = r6*rsq
                  r9 = r8*r 
                  r10 = r8*rsq
                  if (r.lt.1.28d0*rm) then
                     fc = exp(-(1.28d0*rm/r-1.d0)**2)
                  else
                     fc = 1.d0
                  endif
                  p_rep = exp(alpha-beta*r-gamma*rsq)
                  p_att = -(c6/r6 + c8/r8 + c10/r10)*fc + c9/r9*fc
                  pot = pot + p_rep + p_att
               else
                  rmrc = r-rrc 
                  rmrc2 = rmrc**2
                  rmrc3 = rmrc2*rmrc
                  rmr1 = r-r1
                  arg= -b*rmrc - c*rmrc2 - d*rmrc3 - e*rmrc3*rmr1
                  p_rry = a*exp(arg)
                  pot = pot + p_rry
               endif
            enddo
         enddo


      end
   
