
      subroutine run_dmc(neq,nsteps,nblocks,nwalker,
     >                npos,centers,rotmat,vp,mup,mdown,nac,
     >                dmc_config,vmc_en,nuc_pot,
     >                en,err,press,pr_err,ngood)

      implicit none
      include 'param.h'
      include 'dmc_inc.h'
      

c these are inputs (nac,nwalker are in/out)
      integer neq,nsteps,nblocks,nwalker,nac
      real*8 npos(ndim,nnuclei)
      real*8 centers(ndim,npair),rotmat(ndim,ndim,npair)
      real*8 mup(nup,nup),mdown(ndown,ndown)
      real*8 vp(nvp)
      real*8 dmc_config(ndim,nelec,max_nwalker)   
      real*8 vmc_en,nuc_pot
c outputs
      real*8 en,err,press,pr_err
      integer ngood  ! # of proc with good data
c      integer iexit   ! if .eq.0 okay, .ne.0 walkers exploded


c local vars
      real*8 dmc_config2(ndim,nelec,max_nwalker)
      real*8 config_en(max_nwalker)
      real*8 config_en2(max_nwalker)

      real*8 pr_list(n_project,max_nwalker)  ! for forward walking 
      real*8 pr_list2(n_project,max_nwalker)  !  the pressure


      integer i,j,k,ntry,ntarget,m,nb,ns,n
      integer ierr,icnt
      real*8 sum_en,ssq_en,ave,sum_bl,ssq_bl,sum_t,au_to_mbar
      real*8 pr_sum(n_project),pr_ssq(n_project)
      real*8 pr_tot_sum(n_project),pr_tot_ssq(n_project),pr_tmp
      real*8 base_etrial, var,kappa,pr_tmp_sq,mix_pr_err
      integer pr_norm(n_project),mix_p_n,nw
      integer data_good

      real*4 etime,tme1(2),tme2(2),tme
      external etime
     
       
      au_to_mbar = 294.215d0
      
      kappa  = dble(npair)

c let's do  some equilibration
       ntry = 0
       ntarget = nwalker
       dmc_etrial = vmc_en
       base_etrial = dmc_etrial
       if (root) print*,'first etrial=',base_etrial
       sum_bl = 0.d0
       ssq_bl = 0.d0
       icnt = 0
       i_fw_pos = n_project
       
 
       do i=1,max_nwalker
          config_en(i) = 0.d0
          config_en2(i) = 0.d0
       enddo
c  set if err in fermion inversion routines
       lapack_info = 0

c  set to zero if walkers explode.
c   make sure any contribution to sum is also set to zero
       data_good = 1
c

       tme = etime(tme1)
       do ns=1,neq
c          if (ixplod.ne.0) then
c             print*,'new etrial ',ns,dmc_etrial,kappa,nwalker
c          endif
          call dmc_advance(dmc_config,dmc_config2,npos,centers,rotmat,
     >                     vp,config_en,config_en2,nwalker,
     >                     nuc_pot,ntry,nac,pr_list,pr_list2,ierr)
          if (lapack_info.ne.0) then
             if (root) print*,'lapack info = ',lapack_info
             lapack_info = 0
          endif
          if (ierr.ne.0) then
             data_good = 0
             goto 10
          endif

          sum_en = 0.d0
          ssq_en = 0.d0
          do i=1,nwalker
             sum_en = sum_en  + config_en2(i)
             ssq_en = ssq_en  + config_en2(i)**2
          enddo
          en = sum_en/nwalker
          var = ssq_en/nwalker-en*en
          sum_bl = sum_bl + en
          ssq_bl = ssq_bl + en*en
          icnt = icnt+1
c          write(41,'(i4,2e20.11,i5)') icnt,en,sqrt(var/(nwalker-1)),
c     >             nwalker
          dmc_etrial = base_etrial + 
     >                   kappa*log(dble(ntarget)/dble(nwalker))
c          if (ixplod.ne.0) then
c             print*,'energy',en,sqrt(var/(nwalker-1))
c             print*,'new etrial ',dmc_etrial,kappa,nwalker
c          endif

          
          call dmc_advance(dmc_config2,dmc_config,npos,centers,rotmat,
     >                     vp,config_en2,config_en,nwalker,
     >                     nuc_pot,ntry,nac,pr_list2,pr_list,ierr)
          if (lapack_info.ne.0) then
             if (root) print*,'lapack info = ',lapack_info
             lapack_info = 0
          endif
          if (ierr.ne.0) then
             data_good = 0
             goto 10
          endif

c          print*,'nwalker',nwalker
          sum_en = 0.d0
          ssq_en = 0.d0
          do i=1,nwalker
             sum_en = sum_en  + config_en(i)
             ssq_en = ssq_en  + config_en(i)**2
          enddo
          en = sum_en/nwalker
          sum_bl = sum_bl + en
          ssq_bl = ssq_bl + en*en
          var = ssq_en/nwalker-en*en
c          print*,'energy',en,sqrt(var/(nwalker-1))
c          write(41,'(2e20.11,i5)') en,sqrt(var/(nwalker-1)),nwalker
          icnt = icnt+1
c          write(41,'(i4,2e20.11,i5)') icnt,en,sqrt(var/(nwalker-1)),
c     >             nwalker

          dmc_etrial = base_etrial + 
     >                   kappa*log(dble(ntarget)/dble(nwalker))
c          if (ixplod.ne.0) then
c             print*,'energy',en,sqrt(var/(nwalker-1))
c             print*,'new etrial ',dmc_etrial,kappa,nwalker
c          endif

       enddo


10     continue  ! wind up here good or not

       tme = etime(tme2)
       ngood = data_good
       call sum_reduce_int(ngood)
       nw = nwalker
       if (data_good.eq.0) nw = 0
       call sum_reduce_int(nw) 
       if (root) then
       print*,'equilbration dmc time = ',tme2(1)-tme1(1),ngood
       print*,'ave no. of walkers,target = ',nw/dble(ngood),ntarget
       endif



c  okay, we have the equilbrated DMC configurations, do some DMC
       ntry = 0
c       ntarget = nwalker
       if (data_good.eq.0) sum_bl = 0.d0
       call sum_reduce(sum_bl)
       base_etrial = sum_bl/dble(2*neq*ngood)
       if (root) print*,'new etrial=',base_etrial
       dmc_etrial = base_etrial
       sum_bl = 0.d0
       ssq_bl = 0.d0

c   set up for forward walking
       i_fw_pos = n_project
       do j=1,max_nwalker
          do i=1,n_project
             pr_list(i,j) = 0.d0
             pr_list2(i,j) = 0.d0
          enddo
       enddo
       do i=1,n_project
          pr_tot_sum(i) = 0.d0
          pr_tot_ssq(i) = 0.d0
          pr_norm(i) = 0
       enddo
       tme = etime(tme1)

       if (data_good.eq.0) goto 20  ! if equilibration failed, skip data taking

       do nb=1,nblocks
         sum_t = 0.d0
       do ns=1,nsteps
          call dmc_advance(dmc_config,dmc_config2,npos,centers,rotmat,
     >                     vp,config_en,config_en2,nwalker,
     >                     nuc_pot,ntry,nac,pr_list,pr_list2,ierr)
          if (lapack_info.ne.0) then
             if (root) print*,'1lapack info,ns,nb = ',lapack_info,ns,nb
             lapack_info = 0
          endif
          if (ierr.ne.0) then
             data_good = 0
             goto 20
          endif

c          print*,'nwalker',nwalker
          sum_en = 0.d0
          ssq_en = 0.d0
          do i=1,nwalker
             sum_en = sum_en  + config_en2(i)
             ssq_en = ssq_en  + config_en2(i)**2
          enddo
          en = sum_en/nwalker
          sum_t = sum_t + en
          var = ssq_en/nwalker-en*en
c          if (root) print*,'energy',en,sqrt(var/(nwalker-1))
c          write(41,'(2e20.11,i5)') en,sqrt(var/(nwalker-1)),nwalker
          icnt = icnt+1
c          write(41,'(i4,2e20.11,i5)') icnt,en,sqrt(var/(nwalker-1)),
c     >             nwalker
          dmc_etrial = base_etrial + 
     >                   kappa*log(dble(ntarget)/dble(nwalker))

          do i=1,n_project
             pr_sum(i) = 0.d0
             pr_ssq(i) = 0.d0
          enddo
          
c          do j=1,nwalker
c             m = n_project - i_fw_pos + 1
c             do i=1,m
c                pr_sum(i) = pr_sum(i) + pr_list2(i+i_fw_pos-1,j)
c                pr_ssq(i) = pr_ssq(i) + pr_list2(i+i_fw_pos-1,j)**2
c             enddo
c             do i=1,i_fw_pos-1
c                pr_sum(i+m) = pr_sum(i+m) + pr_list2(i,j)
c                pr_ssq(i+m) = pr_ssq(i+m) + pr_list2(i,j)**2
c             enddo
cc              do i=1,n_project
cc                pr_sum(i) = pr_sum(i) + pr_list2(i,j)
cc                pr_ssq(i) = pr_ssq(i) + pr_list2(i,j)**2
cc              enddo
c          enddo

c          do i=1,n_project
c             ave = pr_sum(i)/nwalker
c             var = pr_ssq(i)/nwalker - ave*ave
c             write(51,'(i4,2e20.11)') i,au_to_mbar*ave,
c     >                  au_to_mbar*sqrt(var/(nwalker-1))
cc             write(51,'(i4,2e20.11)') i,ave, var
c          enddo
c          write(51,'("")')

c          i_fw_pos = i_fw_pos - 1
c          if (i_fw_pos.lt.1) i_fw_pos = n_project



          call dmc_advance(dmc_config2,dmc_config,npos,centers,rotmat,
     >                     vp,config_en2,config_en,nwalker,
     >                     nuc_pot,ntry,nac,pr_list2,pr_list,ierr)
          if (lapack_info.ne.0) then
             if (root) print*,'2lapack info,ns,nb = ',lapack_info,ns,nb
             lapack_info = 0
          endif
          if (ierr.ne.0) then
             data_good = 0
             goto 20
          endif

c          print*,'nwalker',nwalker
          sum_en = 0.d0
          ssq_en = 0.d0
          do i=1,nwalker
             sum_en = sum_en  + config_en(i)
             ssq_en = ssq_en  + config_en(i)**2
          enddo
          en = sum_en/nwalker
          sum_t = sum_t + en
          var = ssq_en/nwalker-en*en
c          print*,'energy',en,sqrt(var/(nwalker-1))
c          write(41,'(2e20.11,i5)') en,sqrt(var/(nwalker-1)),nwalker
          icnt = icnt+1
c          write(41,'(i4,2e20.11,i5)') icnt,en,sqrt(var/(nwalker-1)),
c     >             nwalker

          dmc_etrial = base_etrial + 
     >                   kappa*log(dble(ntarget)/dble(nwalker))

          do i=1,n_project
             pr_sum(i) = 0.d0
             pr_ssq(i) = 0.d0
          enddo
          do j=1,nwalker
             m = n_project - i_fw_pos + 1
             do i=1,m
                pr_sum(i) = pr_sum(i) + pr_list(i+i_fw_pos-1,j)
                pr_ssq(i) = pr_ssq(i) + pr_list(i+i_fw_pos-1,j)**2
             enddo
             do i=1,i_fw_pos-1
                pr_sum(i+m) = pr_sum(i+m) + pr_list(i,j)
                pr_ssq(i+m) = pr_ssq(i+m) + pr_list(i,j)**2
             enddo
c             do i=1,n_project
c                pr_sum(i) = pr_sum(i) + pr_list(i,j)
c                pr_ssq(i) = pr_ssq(i) + pr_list(i,j)**2
c             enddo
          enddo

          do i=1,n_project
             ave = pr_sum(i)/nwalker
             var = pr_ssq(i)/nwalker - ave*ave
             pr_tot_sum(i) = pr_tot_sum(i) + ave
             pr_tot_ssq(i) = pr_tot_ssq(i) + ave*ave
             if (ave.ne.0.d0) pr_norm(i) = pr_norm(i) + 1
c             write(51,'(i4,2e20.11)') i,au_to_mbar*ave,
c     >                  au_to_mbar*sqrt(var/(nwalker-1))
c             write(51,'(i4,2e20.11)') i,ave var
          enddo
c          write(51,'("")')

c          if (mod(nb,1).eq.0) then
             i_fw_pos = i_fw_pos - 1
             if (i_fw_pos.le.0) i_fw_pos = n_project
c          endif
       enddo ! nsteps
          en = sum_t/(2*nsteps)
          sum_bl = sum_bl + en
          ssq_bl = ssq_bl + en*en
       enddo ! nblocks

20     continue  ! wind up here if data good or bad

       ngood = data_good
       call sum_reduce_int(ngood)

       nw = nwalker
       if (data_good.eq.0) nw = 0
       call sum_reduce_int(nw) 
       if (root) then
          print*,'final no. of walkers = ',nw/dble(ngood)
       endif

       if (data_good.eq.0) then
          sum_bl = 0.d0
          ssq_bl = 0.d0
       endif

       call sum_reduce(sum_bl)
       call sum_reduce(ssq_bl)
       
       n = ngood*nblocks

       en = sum_bl/n
       var = ssq_bl/n - en*en
       err = sqrt(var/(n-1))

c       print*,'press:',pr_tot_sum(n_project),pr_norm(n_project)
c       press = pr_tot_sum(n_project)/pr_norm(n_project)
       pr_tmp = pr_tot_sum(n_project)
       mix_p_n = pr_norm(n_project)
       pr_tmp_sq = pr_tot_ssq(n_project)
      
       if (data_good.eq.0) then
          pr_tmp = 0.d0
          pr_tmp_sq = 0.d0
          mix_p_n = 0
       endif

       call sum_reduce(pr_tmp)
       call sum_reduce(pr_tmp_sq)
       call sum_reduce_int(mix_p_n)

       press = pr_tmp/mix_p_n
       var = pr_tmp_sq/mix_p_n - press*press
       if (mix_p_n.gt.1) then
          pr_err = sqrt(var/(mix_p_n-1))
       else
          pr_err = 0.d0
       endif

       pr_tmp = pr_tot_sum(1)
       pr_tmp_sq = pr_tot_ssq(1)
       mix_p_n = pr_norm(1)

       if (data_good.eq.0) then
          pr_tmp = 0.d0
          pr_tmp_sq = 0.d0
          mix_p_n = 0
       endif
        
       call sum_reduce(pr_tmp)
       call sum_reduce(pr_tmp_sq)
       call sum_reduce_int(mix_p_n)

       pr_tmp = pr_tmp/mix_p_n
       var = pr_tmp_sq/mix_p_n - pr_tmp*pr_tmp
       if (mix_p_n.gt.1) then
          mix_pr_err = sqrt(var/(mix_p_n-1))
       else
         mix_pr_err = 0.d0
       endif
       if (root) print*,'DMC mixed press:',au_to_mbar*pr_tmp,
     >                   au_to_mbar*mix_pr_err


       tme = etime(tme2)
       if (root) print*,'dmc time = ',tme2(1)-tme1(1)

c      write(41,'("")') 



      end
      
