
c Sivera-Goldman potential

      subroutine sg_pot(npos,pot)
         implicit none 
         include 'param.h'
         real*8 npos(ndim,nnuclei)
         real*8 pot

         real*8 c6,c8,c10
         parameter (c6 = 12.14d0, c8 = 215.2d0, c10 = 4813.9d0)
         real*8 alpha,beta,gamma
         parameter (alpha = 1.713d0, beta = 1.5671d0, gamma = 0.00993d0)
         real*8 rm
         parameter (rm = 6.44610)
         
         integer np,i,j
         real*8 cmdist,cmd(3),cm(3),cm2(3),cm1(3)
         real*8 r,rsq,r6,r8,r10,fc,p_att,p_rep

         pot = 0.d0
         do np=2,npair
            call box_dist(npos(1,2*np-1),npos(1,2*np),cmdist,cmd)
            do j=1,ndim
               cm1(j) = npos(j,2*np) + .5d0*cmd(j) 
            enddo
            call box_move(cm1,cm)
            do i=1,np-1
               call box_dist(npos(1,2*i-1),npos(1,2*i),cmdist,cmd)
               do j=1,ndim
                  cm1(j) = npos(j,2*i) + .5d0*cmd(j) 
               enddo
               call box_move(cm1,cm2)
               call box_dist(cm,cm2,r,cmd)
               rsq = r*r
               r6 = rsq*rsq*rsq
               r8 = r6*rsq
               r10 = r8*rsq
               if (r.lt.1.28d0*rm) then
                  fc = exp(-(1.28d0*rm/r-1.d0)**2)
               else
                  fc = 1.d0
               endif
               p_rep = exp(alpha-beta*r-gamma*rsq)
               p_att = -(c6/r6 + c8/r8 + c10/r10)*fc
    
               pot = pot + p_rep + p_att
            enddo
         enddo


      end
   
