

      subroutine wf_test(npos,epos,mup,mdown,centers,rotmat,vp,dr)
         implicit none
         include 'param.h'
         real*8 epos(ndim,nelec),npos(ndim,nnuclei)
         real*8 mup(nup,nup),mdown(ndown,ndown)
         real*8 centers(ndim,npair),rotmat(ndim,ndim,npair),vp(nvp)
         real*8 dr

         integer i,np,idim,j
         real*8 orig_pos(3),det,gd(ndim,nelec),sum_gdd,det_orig
         real*8 lpsi,je,jn
         real*8 tve(nelec),tve3(ndim,nelec)
         real*8 tvn(nnuclei),tvn3(ndim,nnuclei)
         real*8 je_dd,jn_dd,je_du(nelec),jn_du(nelec)
         real*8 ee_ke,en_ke,ee_g(3),en_g(3)
         real*8 n_ee_ke,n_en_ke,ddf,gradd(3),gradu(3)
         real*8 n_ee_grad(3),n_en_grad(3)
         real*8 err_gradd,err_en_gradu,err_ee_gradu
         real*8 err_ddf,err_ee_ke,err_en_ke

         err_gradd = 0.d0
         err_ee_gradu = 0.d0
         err_en_gradu = 0.d0
         err_ee_ke = 0.d0
         err_en_ke = 0.d0

      
         call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
         call fermion_det(mup,mdown,det_orig)
         print*,'det orig',det_orig
         call fermion_grad(mup,mdown,epos,centers,rotmat,vp,gd,sum_gdd)
         err_ddf = -sum_gdd

         do np=1,nelec
            do i=1,ndim
               orig_pos(i) = epos(i,np)
            enddo
            call psi_sq(npos,epos,vp,lpsi)

            call ee_dist(np,epos,epos(1,np),tve,tve3)
            call ee_jastrow_d(tve,vp,je,je_dd,je_du)
 
            call en_dist(npos,epos(1,np),tvn,tvn3)
            call en_jastrow_d(tvn,vp,jn,jn_dd,jn_du)
         
            ee_ke = je_dd
            do j=1,nelec-1
               ee_ke = ee_ke +  2*je_du(j)/tve(j)
            enddo
c            print*,'np,ed',np,tve(1),je,ee_ke
            en_ke = jn_dd
            do j=1,nelec
               en_ke = en_ke +  2*jn_du(j)/tvn(j)
            enddo
            do i=1,ndim
               ee_g(i) = 0.d0
               en_g(i) = 0.d0
            enddo
            do j=1,nelec-1
               do i=1,ndim
                  ee_g(i) = ee_g(i) +  je_du(j)*tve3(i,j)/tve(j)
               enddo
            enddo
            do j=1,nelec
               do i=1,ndim
                  en_g(i) = en_g(i) +  jn_du(j)*tvn3(i,j)/tvn(j)
               enddo
            enddo

            n_ee_ke = -6.d0*je 
            n_en_ke = -6.d0*jn
            ddf = -6.d0
            do i=1,3
               gradd(i) = 0.d0
               gradu(i) = 0.d0
               n_ee_grad(i) = 0.d0
               n_en_grad(i) = 0.d0
            enddo

            do idim=1,3
               epos(idim,np) = orig_pos(idim) + dr
               call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
               call fermion_det(mup,mdown,det)
               call ee_dist(np,epos,epos(1,np),tve,tve3)
               call ee_jastrow(tve,vp,je)
               call en_dist(npos,epos(1,np),tvn,tvn3)
               call en_jastrow(tvn,vp,jn)

               ddf = ddf + det/det_orig

               n_ee_ke = n_ee_ke +je
               n_en_ke = n_en_ke +jn
               gradd(idim) = det/det_orig
               n_ee_grad(idim) = je
               n_en_grad(idim) = jn

               epos(idim,np) = orig_pos(idim) - dr
               call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
               call fermion_det(mup,mdown,det)
               call ee_dist(np,epos,epos(1,np),tve,tve3)
               call ee_jastrow(tve,vp,je)
               call en_dist(npos,epos(1,np),tvn,tvn3)
               call en_jastrow(tvn,vp,jn)

               ddf = ddf + det/det_orig
               n_ee_ke = n_ee_ke +je
               n_en_ke = n_en_ke +jn
               gradd(idim) = gradd(idim) - det/det_orig
               n_ee_grad(idim) = n_ee_grad(idim) - je
               n_en_grad(idim) = n_en_grad(idim) - jn
               epos(idim,np) = orig_pos(idim) 
            enddo
            do i=1,3
               err_gradd = err_gradd + 
     >                  (gd(i,np)- gradd(i)/(2*dr))**2
               err_ee_gradu = err_ee_gradu + 
     >                  (ee_g(i) - n_ee_grad(i)/(2*dr))**2
               err_en_gradu = err_en_gradu + 
     >                  (en_g(i) - n_en_grad(i)/(2*dr))**2
            enddo
  
            err_ddf = err_ddf + ddf/dr**2
            err_ee_ke = err_ee_ke + (ee_ke - n_ee_ke/dr**2)**2
            err_en_ke = err_en_ke + (en_ke - n_en_ke/dr**2)**2

c            print*,'np ee',np,ee_g(1),n_ee_grad(1)/(2*dr)
c            print*,'np edd',np,ee_ke,n_ee_ke/(dr**2)

         enddo

        print*,'err in orbital',sqrt(err_gradd),err_ddf
        print*,'err in ee',sqrt(err_ee_gradu),sqrt(err_ee_ke)
        print*,'err in en',sqrt(err_en_gradu),sqrt(err_en_ke)
      end

      subroutine psi_sq(npos,epos,vp,log_psi)
         implicit none
         include 'param.h'
         real*8 npos(ndim,nnuclei),epos(ndim,nelec),vp(nvp)
         real*8 log_psi

         integer np
         real*8 tv(nelec),tv3(ndim,nelec)
         real*8 eej,enj,sum

         sum = 0.d0
         do np=1,nelec
            call ee_dist(np,epos,epos(1,np),tv,tv3)
            call ee_jastrow(tv,vp,eej)

            call en_dist(npos,epos(1,np),tv,tv3)
            call en_jastrow(tv,vp,enj)
            sum = sum + eej + enj
         enddo
         log_psi = -2*sum
      end
