

      subroutine classical_move(npos,index,itype,samp_prob)
         implicit none
         include 'param.h'
         real*8 npos(ndim,nnuclei),samp_prob
         integer index,itype

c itype - 0- all, 1-CM, 2-rotate, 3-bond stretch

         real*8 rng_cm
         external rng_cm

         real*8 tr(ndim),tmp(ndim),tmp2(ndim),td,v1(ndim),v2(ndim)
         real*8 theta,cn,sn,qx,qy,cm(ndim),dist
         real*8 scale,mp,d,sm,new_bl
         integer i,j,axis1,axis2,axis3


         samp_prob=1.d0
         if ((itype.eq.0).or.(itype.eq.1)) then
c   center of mass move
         do i=1,3
            tr(i) = cm_delta*(rng_cm()-0.5d0)
         enddo

         do i=1,3
           tmp(i) = npos(i,2*index-1) + tr(i)
           tmp2(i) = npos(i,2*index)  + tr(i)
         enddo

         call box_move(tmp,npos(1,2*index-1))
         call box_move(tmp2,npos(1,2*index))
         endif


c         if ((itype.eq.0).or.(itype.eq.3)) then 
cc   Bond stretching move
cc        scale = 1.d0 + scale_max*(rng_cm()-0.5d0)
c         sm = scale_max/2.d0
c         d = 1.d0 + sm - 1.d0/(1.d0+sm)
c         mp = (1.d0 + sm + 1.d0/(1.d0+sm))/2.d0
c         scale = mp + d*(rng_cm()-0.5d0)
c
c         else
c            scale = 1.d0
c         endif


         if  ((itype.eq.0).or.(itype.eq.2)) then
c   Rotational move
         theta = theta_max*(rng_cm()-0.5d0)
c         theta = theta_max
         axis1 = int(3*rng_cm())+1
         axis2 = mod(axis1,3)+1
         axis3 = mod(axis2,3)+1
c         print*,'theta',myrank,theta,theta*180.d0/3.14159d0
c         print*,'axis',axis1,axis2,axis3

         else
            axis1 = 1
            axis2 = 2
            axis3 = 3
            theta = 0.d0
         endif

         call box_dist(npos(1,2*index),npos(1,2*index-1),td,tmp)
c         print*,'initial dist',td
         do j=1,ndim
            tmp2(j) = npos(j,2*index-1) + .5d0*tmp(j)
         enddo
         call box_move(tmp2,cm)

         call box_dist(npos(1,2*index-1),cm,dist,v1)
         call box_dist(npos(1,2*index),cm,dist,v2)

         cn = cos(theta)
         sn = sin(theta)

         qx = cn*v1(axis1) + sn*v1(axis2)
         qy = -sn*v1(axis1) + cn*v1(axis2)

         tr(axis1) = qx
         tr(axis2) = qy
         tr(axis3) = v1(axis3) 
c   try a different method for choosing a new bond length scale factor
         if ((itype.eq.0).or.(itype.eq.3)) then 
            new_bl = td + scale_max*(rng_cm()-0.5d0)
            scale = new_bl/td
            samp_prob = scale**2
         else
            scale = 1.d0
         endif


         do i=1,ndim
            tmp(i) = cm(i) + scale*tr(i)
         enddo

         call box_move(tmp,npos(1,2*index-1))

         qx = cn*v2(axis1) + sn*v2(axis2)
         qy = -sn*v2(axis1) + cn*v2(axis2)

         tr(axis1) = qx
         tr(axis2) = qy
         tr(axis3) = v2(axis3) 

         do i=1,ndim
            tmp(i) = cm(i) + scale*tr(i)
         enddo

         call box_move(tmp,npos(1,2*index))


c         call box_dist(npos(1,2*index),npos(1,2*index-1),td,tmp)
c         if (root) print*,'new bond length',td
         

      end
