

      subroutine classical_move(npos,index)
         implicit none
         include 'param.h'
         real*8 npos(ndim,nnuclei)
         integer index

         real*8 rng
         external rng

         real*8 tr(ndim),tmp(ndim),tmp2(ndim),td,v1(ndim),v2(ndim)
         real*8 theta,cn,sn,qx,qy,cm(ndim),dist
         real*8 scale,mp,d,sm
         integer i,j,axis1,axis2,axis3


c   center of mass move
         do i=1,3
            tr(i) = cm_delta*(rng()-0.5d0)
         enddo

         do i=1,3
           tmp(i) = npos(i,2*index-1) + tr(i)
           tmp2(i) = npos(i,2*index)  + tr(i)
         enddo

         call box_move(tmp,npos(1,2*index-1))
         call box_move(tmp2,npos(1,2*index))


c   Bond streching move
c        scale = 1.d0 + scale_max*(rng()-0.5d0)
         sm = scale_max/2.d0
         d = 1.d0 + sm - 1.d0/(1.d0+sm)
         mp = (1.d0 + sm + 1.d0/(1.d0+sm))/2.d0
         scale = mp + d*(rng()-0.5d0)
c   Rotational move
         theta = theta_max*(rng()-0.5d0)
c         theta = theta_max
         axis1 = int(3*rng())+1
         axis2 = mod(axis1,3)+1
         axis3 = mod(axis2,3)+1
c         print*,'theta',myrank,theta,theta*180.d0/3.14159d0
c         print*,'axis',axis1,axis2,axis3


         call box_dist(npos(1,2*index),npos(1,2*index-1),td,tmp)
c         print*,'initial dist',td
         do j=1,ndim
            tmp2(j) = npos(j,2*index-1) + .5d0*tmp(j)
         enddo
         call box_move(tmp2,cm)

         call box_dist(npos(1,2*index-1),cm,dist,v1)
         call box_dist(npos(1,2*index),cm,dist,v2)

         cn = cos(theta)
         sn = sin(theta)

         qx = cn*v1(axis1) + sn*v1(axis2)
         qy = -sn*v1(axis1) + cn*v1(axis2)

         tr(axis1) = qx
         tr(axis2) = qy
         tr(axis3) = v1(axis3) 

         do i=1,ndim
            tmp(i) = cm(i) + scale*tr(i)
         enddo

         call box_move(tmp,npos(1,2*index-1))

         qx = cn*v2(axis1) + sn*v2(axis2)
         qy = -sn*v2(axis1) + cn*v2(axis2)

         tr(axis1) = qx
         tr(axis2) = qy
         tr(axis3) = v2(axis3) 

         do i=1,ndim
            tmp(i) = cm(i) + scale*tr(i)
         enddo

         call box_move(tmp,npos(1,2*index))

         call box_dist(npos(1,2*index),npos(1,2*index-1),td,tmp)
c         if (root) print*,'new bond length',td
         

      end
