
c Classical/Quantum simulation, version 2
c  this is from the parallel version (cause it has the most features)
      implicit none
      include 'param.h'

c storage created here
      real*8 epos1(ndim,nelec),npos1(ndim,nnuclei)
      real*8 centers1(ndim,npair)
      real*8 mup1(nup,nup),mdown1(ndown,ndown)
      real*8 rotmat1(ndim,ndim,npair),vp1(nvp)

      real*8 epos2(ndim,nelec),npos2(ndim,nnuclei)
      real*8 centers2(ndim,npair)
      real*8 mup2(nup,nup),mdown2(ndown,ndown)
      real*8 rotmat2(ndim,ndim,npair),vp2(nvp)


c local vars
      integer ns,j,np,nac,nacc,nb,i,k,idx,n
      real*8 det,en,nuc_pot,pt
      real*8 rng,rng_cm
      external rng,rng_cm
      real*8 tv(nnuclei),tv3(ndim,nnuclei)
      real*8 ed,err,e1,err1,e2,err2
      real*8 pe,ke,pe_err,ke_err,press,press_err
      real*8 au_to_mbar,au_to_kelvin
      real*8 beta,temp,prob,ran,arg
      real*8 scale(nvp),sca,sb,rs
      real*8 cen1,cen2,t_ar,ben1,ben2,cl_ed,sen1,sen2
      real*8 sp,samp_prob,aprob
      real*8 a1,a2,a3,a4,x
      real*8 preprob
     
      real*4 etime,tme1(2),tme2(2),tme
      external etime
      
      integer nac1,nac2
      integer cl_nac,cl_nsteps,cl_ns,nmover
      integer nrun_reject,cl_pre_acc
      integer n_add_rej
      integer itype, nac_type(0:3),npreac_type(0:3),ntype(0:3)
      integer fno_e,fno_p
      logical accept,pre_reject,do_prerej
      character*40 vp_file,pos_file,vp_log_file,infile
      character*40 config_file,pos_out,vp_out,curr_file
      character*40 energy_file,press_file
   
 
c simulation variables
      integer nsteps,iseed,nblocks,nerrblocks,itmax,vmc_nblocks
     
      call parallel_init()
      au_to_mbar = 294.215d0
      au_to_kelvin  = 315642.397d0



      if (root) then
         call getarg(1,infile)
         curr_file = infile
         open(5,file=infile,err=911)
      endif
      if (root) print*,'nproc = ',nproc

      iseed = 100
      call read_integer_par(iseed,'iseed')
      call easy_init_rng(iseed)

c use prerejection w/ classical pot?
      do_prerej = .false.
      if (root) print*,'do_prerej = ',do_prerej

      call read_integer_par(nsteps,'quantum nsteps')
      call read_integer_par(nblocks,'quantum nblocks')
      call read_integer_par(nerrblocks,'quantum nerrblocks')
      call read_integer_par(vmc_nblocks,'quantum vmc nblocks')
      call read_integer_par(itmax,'opt itmax')

      call read_integer_par(cl_nsteps,'classical nsteps')

      temp = 4530.d0 
      call read_double_par(temp,'temperature')
      beta = au_to_kelvin/temp

c set vp's and sim parameters

      pi = 4.d0*atan(1.d0)
      call read_double_par(rs,'rs')
c      rs = 2.6465d0
      density = 3.d0/(4.d0*pi*rs**3)
      box_len = ( (2*npair)/density)**(1.d0/3.d0)
      recip_box_len = 1.d0/box_len
      box_vol = box_len**3

      if (root) print*,'box_len = ',box_len

      if (root) then
         print*,'inital vp file'
         read(5,'(a40)') vp_file
         print*,'inital vp file = ',vp_file

         print*,'log vp file'
         read(5,'(a40)') vp_log_file
         print*,'log vp file = ',vp_log_file

         print*,'output vp file'
         read(5,'(a40)') vp_out
         print*,'output vp file = ',vp_out

         curr_file = vp_file
         open(15,file=vp_file,status='OLD',err=911)
         do i=1,nvp
            read(15,*) vp1(i)
         enddo
         close(15)
      endif
      call bcast_array(vp1,nvp)

      do i=1,nvp
         vp2(i)= vp1(i)
      enddo
      curr_file = vp_log_file
      if (root) open(16,file=vp_log_file,err=911)
      call read_double_par(sca,'optimizer scale factor')
      do i=1,nvp
         scale(i) = sca
      enddo
c      scale(1) = .1d0
c      scale(ien) = .1d0
     

      nmover =1
      call read_integer_par(nmover,'nmover')

      delta = 4.0d0
c      print*,'delta'
c      read*,delta

      call read_double_par(cm_delta,'CM delta')

      call read_double_par(theta_max,'CM theta max')
      call read_double_par(scale_max,'Bond scaling max')
      
 
c set up intial positions

c      xpos = 1.4d0
c      ypos = 1.4d0
c      do i=1,npair
c         do j=1,ndim
c           npos(j,2*i-1) = 0.d0
c           npos(j,2*i) = 0.d0
c         enddo
c      enddo
c      do j=1,npair
c         npos(1,2*j) = xpos
c         npos(2,2*j-1) = (j-1)*ypos
c         npos(2,2*j) = (j-1)*ypos
c      enddo
      if (root) then
         print*,'initial nuc pos file'
         read(5,'(a40)') pos_file
         print*,'initial nuc pos file = ',pos_file
         print*,'configuration log file'
         read(5,'(a40)') config_file
         print*,'configuration log file = ',config_file
         print*,'final nuc pos file'
         read(5,'(a40)') pos_out
         print*,'final nuc pos file = ',pos_out
         curr_file = pos_file
         open(10,file=pos_file,status='OLD',err=911)
         do i=1,npair
             read(10,*) (npos1(j,2*i-1),j=1,ndim)
             read(10,*) (npos1(j,2*i),j=1,ndim)
         enddo
         close(10)
         curr_file = config_file
         open(39,file=config_file,err=911)
      endif
      call bcast_array(npos1,ndim*nnuclei)

      do i=1,2*npair
         do j=1,ndim 
               npos2(j,i) = npos1(j,i)
         enddo
      enddo
c       npos1(1,1) = npos1(1,1) + cm_delta

       if (root) then
          print*,'energy file'
          read(5,'(a40)') energy_file
          print*,'energy file = ',energy_file
          fno_e = 43
          curr_file = energy_file
          open(fno_e,file=energy_file)

    
          print*,'pressure file'
          read(5,'(a40)') press_file
          print*,'pressure file = ',press_file
          fno_p = 44
          curr_file = press_file
          open(fno_p,file=press_file)
       endif

c make trial move
c      call classical_move(npos1,1,0)

      call set_centers(npos1,centers1,rotmat1)
      call set_centers(npos2,centers2,rotmat2)

 
c      print*,'center',centers(1,1),centers(2,1),centers(3,1)

      sb = 2.d0
      do np=1,npair
         do j=1,ndim
c            epos(j,np) = box_len*(rng()-.5d0)
            epos1(j,np) = centers1(j,np) + sb*(rng()-.5d0)
            epos1(j,np+npair) = centers1(j,np) + sb*(rng()-.5d0)
            epos2(j,np) = centers2(j,np) + sb*(rng()-.5d0)
            epos2(j,np+npair) = centers2(j,np) + sb*(rng()-.5d0)
         enddo
      enddo

c      nuc_pot = 0.d0
c      do j=1,nnuclei
c         call nn_dist(j,npos,npos(1,j),tv,tv3)
c         call nn_potential(tv,pt)
c         nuc_pot = nuc_pot + 0.5d0*pt
c      enddo
c      print*,'Nuclear potential ',nuc_pot
c set up fermion matrices

      call fermion_fill(mup1,mdown1,centers1,rotmat1,vp1,epos1)
      call fermion_det(mup1,mdown1,det)

      call fermion_fill(mup2,mdown2,centers2,rotmat2,vp2,epos2)
      call fermion_det(mup2,mdown2,det)

c  Bessel expansion
c      n = nproc/2
      n = vmc_nblocks*nproc
      a1 = 0.5d0
      a2 = 1.d0/(4.d0*(n+1))
      a3 = 1.d0/(3.d0*(n+1)*(n+3))
      a4 = (5*n+7.d0)/(8.d0*(n+3)*(n+5)*(n+1)**2)

      cl_nac = 0
      cl_pre_acc = 0
      nrun_reject = 1
      preprob=1.d0

      n_add_rej = 0
      do i=1,3
         nac_type(i) = 0
         npreac_type(i) = 0
         ntype(i) = 0
      enddo
     


c -----------------------------------------------
c  beginning of classical loop
c -----------------------------------------------
      do cl_ns = 1,cl_nsteps
         nac1 = 0
         nac2 = 0
c          do np = 1,npair
         do np= 1,npair/nmover
            itype = 0
c            itype = int(3.d0*rng_cm()) + 1
            ntype(itype) = ntype(itype) + 1
            samp_prob = 1.d0
            do i=1,nmover
c               call classical_move(npos1,np+(i-1)*(npair/nmover))
               call classical_move(npos1,np+(i-1)*(npair/nmover),itype,
     >                             sp)
               samp_prob = samp_prob*sp
            enddo
            call set_centers(npos1,centers1,rotmat1)
c compute the classical energy difference
      if (root) then
         print*,''
         print*,'----Step ',cl_ns, '  Particle ',np,' ------'
         print*,'itype = ',itype
      endif
      call kolos_pot(npos1,ben1)
      call kolos_pot(npos2,ben2)
      if (root) 
     >    write(*,'("cl kolos ediff",3e20.10)') ben1,ben2,ben1-ben2
      call dj_pot(npos1,cen1)
      call dj_pot(npos2,cen2)
      if (root) write(*,'("cl dj ediff",3e20.10)') cen1,cen2,cen1-cen2
      call rry_pot(npos1,cen1)
      call rry_pot(npos2,cen2)
      if (root) write(*,'("cl rry ediff",3e20.10)') cen1,cen2,cen1-cen2
      call sg_pot(npos1,cen1)
      call sg_pot(npos2,cen2)
      if (root) write(*,'("cl sg ediff",3e20.10)') cen1,cen2,cen1-cen2
c      write(*,'("cl sg ediff",i4,3e20.10)') myrank,cen1,cen2,cen1-cen2
c      call sch_pot(npos1,sen1)
c      call sch_pot(npos2,sen2)
c      if (root) write(*,'("cl sch ediff",3e20.10)') sen1,sen2,sen1-sen2

     
c pre-rejection 
c      if (itype.eq.2) then
c         cl_ed = 10.d0*(sen1-sen2) + ben1-ben2
c      else
         cl_ed = cen1-cen2 + ben1-ben2
c      endif
      if (do_prerej) then 
         arg = -beta*(cl_ed)
         preprob = exp(arg)
         aprob = preprob*samp_prob
      else
         aprob = 1.d0
      endif
      pre_reject = .false.
      if (aprob.lt.1.d0) then
         ran = rng_cm()
         if (aprob.lt.ran) then
            nrun_reject = nrun_reject+1
            pre_reject=.true.
            if (root) print*,'pre-accpt: ',.not.pre_reject
            goto 30 
         endif
      endif
      cl_pre_acc = cl_pre_acc + 1
      npreac_type(itype) = npreac_type(itype) + 1
      if (root) print*,'pre-accpt: ',.not.pre_reject

c   move the affected electrons to be near their centers
c   reset all the electrons
         do idx=1,npair
            do j=1,ndim
               epos1(j,idx) = centers1(j,idx) + sb*(rng()-.5d0)
               epos1(j,idx+npair) = centers1(j,idx) + sb*(rng()-.5d0)
            enddo
         enddo
c thermalize
c      call fermion_fill(mup1,mdown1,centers1,rotmat1,vp1,epos1)
c      call fermion_det(mup1,mdown1,det)

c  optimize vp's for the trial position
      if (itmax.ne.0) then
      if (root) tme = etime(tme1)
      call optimize(nsteps,nblocks,nerrblocks,itmax,
     >              npos1,epos1,mup1,mdown1,centers1,rotmat1,vp1,
     >              scale)
      if (root) then
         tme = etime(tme2)
         print*,'optimize time',tme2(1)-tme1(1)
c         do i=1,nvp
c            write(16,*) vp1(i)
c         enddo
c         write(16,'("")')
      endif
      endif

      call fermion_fill(mup1,mdown1,centers1,rotmat1,vp1,epos1)
      call fermion_det(mup1,mdown1,det)


      if (root) tme = etime(tme1)
c regular energy difference method
c      call ediff(nsteps,vmc_nblocks,
c     >           npos1,epos1,centers1,rotmat1,vp1,mup1,mdown1,nac1,
c     >           npos2,epos2,centers2,rotmat2,vp2,mup2,mdown2,nac2,
c     >           ed,err,e1,err1,e2,err2,
c     >           ke,ke_err,pe,pe_err)
 
c      print*,'double check the rotmat arg'
c      stop
c two-sided energy difference method
      call ts_diff(nsteps,vmc_nblocks,
     >           npos1,epos1,centers1,rotmat1,vp1,mup1,mdown1,nac1,
     >           npos2,epos2,centers2,rotmat2,vp2,mup2,mdown2,nac2,
     >           ed,err,e1,err1,e2,err2,
     >           ke,ke_err,pe,pe_err)
       
      if (root) then
         tme = etime(tme2)
         print*,'ediff time',tme2(1)-tme1(1)
      endif

c regular penalty method
c             arg = -beta*ed - .5d0*(beta*err)**2
c  bessel expansion penalty method
             x = (beta*err)**2
             arg = -beta*ed - x*(a1 + x*(a2 + x*(a3 + x*a4)))
             if (do_prerej) then
c w/pre-rejection
                prob = exp(arg)/preprob
             else
c no pre-rejection
                prob = exp(arg)
             endif
             accept = .false.
             if (prob.lt.1.d0) then
                ran=rng_cm()
                if (prob.lt.ran) goto 20
             endif
c ---- accept
             accept = .true.
             cl_nac = cl_nac + 1
             nac_type(itype) = nac_type(itype) + 1
             do i=1,2*npair
                do j=1,ndim
                   npos2(j,i) = npos1(j,i)
                   epos2(j,i) = epos1(j,i)
                enddo
              enddo
              do i=1,npair
                do j=1,ndim
                   centers2(j,i) = centers1(j,i)
                enddo
              enddo
              do i=1,npair
                do j=1,npair
                   mup2(j,i) = mup1(j,i)
                   mdown2(j,i) = mdown1(j,i)
                enddo
              enddo
              do i=1,npair
                 do j=1,ndim
                    do k=1,ndim
                       rotmat2(k,j,i) = rotmat1(k,j,i)
                    enddo
                 enddo
              enddo
              do i=1,nvp
                 vp2(i) = vp1(i)
              enddo
   
c ---- reject (also fall through from accept)
20           continue

c         compute if this rejection was due to the noise term
             if (.not.accept) then
                prob = exp(-beta*ed)/preprob 
                if (prob.gt.ran) then
                   n_add_rej = n_add_rej + 1
                endif
             endif

c          clean up  after rejection
             if (.not.accept) then
                do i=1,nvp
                   vp1(i) = vp2(i)
                enddo
                do i=1,nnuclei
                   do j=1,ndim
                      npos1(j,i) = npos2(j,i)
                   enddo
                enddo
             endif
        if (root) then
             print*,'accept: ',accept

       print*,'--final ediff',ed,err
       print*,'e1 = ',e1,err1
       print*,'e2 = ',e2,err2
       print*,'brute ediff',e1-e2,sqrt(err1**2+err2**2)
       print*,'ke2 = ',ke,ke_err
       print*,'pe2 = ',pe,pe_err
       press = density/(2.d0*npair)*(2*ke+pe)/3.d0
       press_err = density/(2.d0*npair)*sqrt(4*ke_err**2+pe_err**2)/3.d0
c       print*,'pressure = ',press,press_err
       print*,'pressure(MBAR) = ',au_to_mbar*press,au_to_mbar*press_err
c       print*,'nrun_reject: ',nrun_reject

        do i=1,nrun_reject
           write(fno_e,'(2e20.10)') e2,err2
          write(fno_p,'(2e20.10)') au_to_mbar*press,au_to_mbar*press_err
        enddo

        endif  ! root

        nrun_reject = 1  

30      continue  ! pre-rejected (also fall through from above)
        if (pre_reject) then
c        if (.false.) then
           do i=1,nvp
              vp1(i) = vp2(i)
           enddo
           do i=1,nnuclei
              do j=1,ndim
                 npos1(j,i) = npos2(j,i)
              enddo
           enddo
        endif
        
       

          enddo  !  loop over movers

          if (root) then
             do i=1,2*npair
                write(39,'(3f10.5)') (npos2(j,i),j=1,ndim)
             enddo
             write(39,'('''')')
             do i=1,nvp
                write(16,*) vp1(i)
             enddo
             write(16,'("")')
             call flush(39)
             call flush(16)
             call flush(6)
          endif

c with ediff
c          t_ar = t_ar + (nac1+nac2)/
c     >          real(2*nsteps*nelec*vmc_nblocks*npair)
c with ts_diff
          t_ar = t_ar + (nac1+nac2)/
     >          real(2*80*nsteps*nelec*vmc_nblocks*npair)


       enddo
c -----------------------------------------------
c  end of classical loop
c -----------------------------------------------

c      sum_en = 0.d0
c      nacc = 0
c      do nb=1,nblocks
c         do ns=1,nsteps
c            call metropolis(mup,mdown,npos,epos,centers,nac)
c            nacc = nacc + nac
c         enddo
c         call local_energy(npos,epos,mup,mdown,centers,en)
c         sum_en = sum_en + en
c         write(40,'(2e20.10)') en+nuc_pot,en
cc         write(41,'(6e14.5)') epos(1,1),epos(2,1),epos(3,1),
cc     >       epos(1,2),epos(2,2),epos(3,2)
c      enddo
c

c      print*,'ave energy = ',sum_en/nblocks + nuc_pot

      t_ar = nmover*t_ar/cl_nsteps
c w /prerejection
      t_ar = t_ar*real(cl_nsteps*npair/nmover)/real(cl_pre_acc)
c      print*,'proc, t_ar',myrank,t_ar
      call sum_reduce(t_ar)
      if (root) then
      print*,'QMC acceptance ratio',t_ar/nproc
      print*,'CL acceptance ratio',real(cl_nac)/
     >          real(cl_nsteps*npair/nmover)
      print*,'CL pre accept reatio',real(cl_pre_acc)/
     >          real(cl_nsteps*npair/nmover)
      print*,'CL post accept reatio',real(cl_nac)/real(cl_pre_acc)

      print*,'n_add_rej ',n_add_rej, real(n_add_rej)/real(cl_pre_acc)
      print*,'cl_pre_acc,cl_nac',cl_pre_acc,cl_nac
      print*,'attempts',cl_nsteps*npair/nmover
      print*,'acc - CM move:',nac_type(1),npreac_type(1),ntype(1)
      print*,'acc - rot:',nac_type(2),npreac_type(2),ntype(2)
      print*,'acc - bond:',nac_type(3),npreac_type(3),ntype(3)
      endif

      if (root) then
         open(20,file=vp_out)
         do i=1,nvp
            write(20,*) vp2(i)
         enddo
         write(20,'("")')
         close(20)

         open(21,file=pos_out)
         do i=1,2*npair
            write(21,'(3f10.5)') (npos2(j,i),j=1,ndim)
         enddo
         write(21,'('''')')
         close(21)

      endif

      call parallel_end()
      stop

911   continue
      if (root) print*,'file not found: ',curr_file
c      call parallel_end()

      end
      
