
c code to do density sampling
      subroutine density_start()
        implicit none
        include 'param.h'
        include 'dens.h'
        dens_dx  = box_len/n_dens_samp
        print*,'dens_dx = ',dens_dx
      end

      subroutine density_sample(epos)
        implicit none
        include 'param.h'
        include 'dens.h'
        double precision epos(ndim,nelec)
      
        integer i,ix,iy,iz
        do i=1,nelec
           ix = int(epos(1,i)/dens_dx)+1
           if (ix.gt.n_dens_samp) then
              ix = n_dens_samp
              print*,'ix too big = ',ix
           endif 
           iy = int(epos(2,i)/dens_dx)+1
           if (iy.gt.n_dens_samp) then
              iy = n_dens_samp
              print*,'iy too big = ',iy
           endif 
           iz = int(epos(3,i)/dens_dx)+1
           if (iz.gt.n_dens_samp) then
              iz = n_dens_samp
              print*,'iz too big = ',iz
           endif 
           dens_norm = dens_norm + 1
           dens_hist(ix,iy,iz) = dens_hist(ix,iy,iz) + 1
        enddo
      end 

      subroutine density_write(file)
        implicit none
        include 'param.h'
        include 'dens.h'
        character*40 file
        integer ix,iy,iz
        print*,'dens_dx = ',dens_dx
        print*,'dens_norm = ',dens_norm
        open(60,file=file)
        do ix=1,n_dens_samp
           do iy=1,n_dens_samp
              do iz=1,n_dens_samp
                 write(60,'(4d15.7,i11)') 
     >              (dble(ix)-.5d0)*dens_dx,
     >              (dble(iy)-.5d0)*dens_dx,
     >              (dble(iz)-.5d0)*dens_dx,
     >               dens_hist(ix,iy,iz)/dble(dens_norm),
     >               dens_hist(ix,iy,iz)
 
              enddo
           enddo
        enddo

        close(60)
      end
