
c determines interparticle distances
c w/ pbc
 
       subroutine dist_init()
          print*,'-- Periodic boundary conditions in dist'
       end

       subroutine ee_dist(indx,pos,vec,pv,pv3)
          implicit none
          include 'param.h'
          integer indx
          real*8 pos(ndim,nelec)
          real*8 vec(ndim)
          real*8 pv(nelec)
          real*8 pv3(ndim,nelec)
          

          integer i,j,ii
          real*8 sum

          do i=1,indx-1
             do j=1,ndim 
                pv3(j,i) =  vec(j) - pos(j,i)
             enddo
             do j=1,ndim 
                pv3(j,i) =  pv3(j,i) - 
     >                       box_len*anint(pv3(j,i)*recip_box_len)
             enddo
             sum = 0.d0
             do j=1,ndim
                sum = sum + pv3(j,i)*pv3(j,i) 
             enddo

             pv(i) = sqrt(sum)
          enddo

          do i=indx+1,nelec
             ii = i-1
             do j=1,ndim 
                pv3(j,ii) =  vec(j) - pos(j,i)
             enddo
             do j=1,ndim 
                pv3(j,ii) =  pv3(j,ii) - 
     >                       box_len*anint(pv3(j,ii)*recip_box_len)
             enddo
             sum = 0.d0
             do j=1,ndim
                sum = sum + pv3(j,ii)*pv3(j,ii) 
             enddo

             pv(ii) = sqrt(sum)
          enddo

       end 



       subroutine en_dist(pos,vec,pv,pv3)
          implicit none
          include 'param.h'
          real*8 pos(ndim,nnuclei)
          real*8 vec(ndim)
          real*8 pv(nelec)
          real*8 pv3(ndim,nelec)
          

          integer i,j
          real*8 sum

          do i=1,nelec
             do j=1,ndim 
                pv3(j,i) =  vec(j) - pos(j,i)
             enddo
             do j=1,ndim 
                pv3(j,i) =  pv3(j,i) - 
     >                       box_len*anint(pv3(j,i)*recip_box_len)
             enddo
             sum = 0.d0
             do j=1,ndim
                sum = sum + pv3(j,i)*pv3(j,i) 
             enddo

             pv(i) = sqrt(sum)
          enddo

       end 



       subroutine nn_dist(indx,pos,vec,pv,pv3)
          implicit none
          include 'param.h'
          integer indx
          real*8 pos(ndim,nnuclei)
          real*8 vec(ndim)
          real*8 pv(nnuclei)
          real*8 pv3(ndim,nnuclei)
          

          integer i,j,ii
          real*8 sum

          do i=1,indx-1
             do j=1,ndim 
                pv3(j,i) =  vec(j) - pos(j,i)
             enddo
             do j=1,ndim 
                pv3(j,i) =  pv3(j,i) - 
     >                       box_len*anint(pv3(j,i)*recip_box_len)
             enddo
             sum = 0.d0
             do j=1,ndim
                sum = sum + pv3(j,i)*pv3(j,i) 
             enddo

             pv(i) = sqrt(sum)
c             print*,'i,dist',i,pv(i)
          enddo

          do i=indx+1,nnuclei
             ii=i-1
             do j=1,ndim 
                pv3(j,ii) =  vec(j) - pos(j,i)
             enddo
             do j=1,ndim 
                pv3(j,ii) =  pv3(j,ii) - 
     >                       box_len*anint(pv3(j,ii)*recip_box_len)
             enddo
             sum = 0.d0
             do j=1,ndim
                sum = sum + pv3(j,ii)*pv3(j,ii) 
             enddo

             pv(ii) = sqrt(sum)
c             print*,'i,dist',i,ii,pv(ii)
          enddo

       end 

 
       subroutine orb_dist(pos,vec,pv,pv3)
          implicit none
          include 'param.h'
          real*8 pos(ndim,npair)
          real*8 vec(ndim)
          real*8 pv(npair)
          real*8 pv3(ndim,npair)
          

          integer i,j
          real*8 sum

          do i=1,npair
             do j=1,ndim 
                pv3(j,i) =  vec(j) - pos(j,i)
             enddo
             do j=1,ndim 
                pv3(j,i) =  pv3(j,i) - 
     >                       box_len*anint(pv3(j,i)*recip_box_len)
             enddo
             sum = 0.d0
             do j=1,ndim
                sum = sum + pv3(j,i)*pv3(j,i) 
             enddo

             pv(i) = sqrt(sum)
          enddo

       end 

       subroutine box_dist(v1,v2,pv,pv3)
          implicit none
          include 'param.h'
          real*8 v1(ndim)
          real*8 v2(ndim)
          real*8 pv
          real*8 pv3(ndim)

          integer j
          real*8 sum

          sum = 0.d0
          do j=1,ndim
             pv3(j) = v1(j)-v2(j)
             pv3(j) =  pv3(j) - box_len*anint(pv3(j)*recip_box_len)
             sum= sum + pv3(j)*pv3(j)
          enddo
          pv = sqrt(sum)

       end 

       subroutine box_move(v1,v2)
         implicit none
         include 'param.h'
         real*8 v1(ndim),v2(ndim)
 
         integer j

         do j=1,ndim
            v2(j) = v1(j) - box_len*int(2.0d0*v1(j)*recip_box_len-1.d0)
         enddo
 
       end 
      



