
c Diep-Johnson potential

      subroutine dj_pot(npos,pot)
         implicit none 
         include 'param.h'
         real*8 npos(ndim,nnuclei)
         real*8 pot
         real*8 rgrid(27),v000(27),v022(27),v224(27)

         integer np,i,j,index
         real*8 cmdist,cmd(3),cm(3),cm2(3),cm1(3),v1(3),v2(3)
         real*8 cm3(3),cm4(3)
         real*8 r,sin_1,sin_2,cos_1,cos_2,cross,cos_phi,cos_2phi
         real*8 len1,len2,pt,vzero(3),len3
         real*8 g202,g022,g224,p0,p2,p4
         real*8 rmax,rmin,rspace1,rspace2,rcut
         real*8 K_to_au,A_to_au
         integer ifirst
         save ifirst,rgrid,v000,v022,v224,rcut,rspace1,rspace2
         save rmin,rmax

         parameter (K_to_au = 3.16670d-6, A_to_au = 1.88973d0)


         data ifirst/0/
         data (rgrid(j),j=1,6)/2.00, 2.25, 2.50, 2.75, 3.00, 3.25/
         data (rgrid(j),j=7,12)/3.50, 3.75, 4.00, 4.25, 4.50, 4.75/
         data (rgrid(j),j=13,18)/5.00, 5.25, 5.50, 5.75, 6.00, 6.25/
         data (rgrid(j),j=19,24)/6.50, 6.75, 7.00, 7.50, 8.00, 8.50/
         data (rgrid(j),j=25,27)/9.00, 9.50, 10.00 /

         data (v000(j),j=1,4)/3765.99, 1474.07, 533.08, 158.79/
         data (v000(j),j=5,8)/19.85, -24.30, -32.61, -29.03/
         data (v000(j),j=9,12)/-22.75, -16.97, -12.45, -9.10/
         data (v000(j),j=13,16)/-6.68, -4.94, -3.70, -2.80/
         data (v000(j),j=17,20)/-2.14, -1.66, -1.29, -1.02/
         data (v000(j),j=21,24)/-0.81, -0.53, -0.36, -0.24/
         data (v000(j),j=25,27)/-0.17, -0.12, -0.09 /

         data (v022(j),j=1,3)/1.1871e+02, 5.1890e+01, 2.0660e+01/
         data (v022(j),j=4,6)/6.9400e+00, 1.4200e+00, -4.8000e-01/
         data (v022(j),j=7,9)/-9.3000e-01, -8.7000e-01, -6.8000e-01/
         data (v022(j),j=10,12)/-5.0000e-01, -3.5000e-01, -2.5000e-01/
         data (v022(j),j=13,15)/-1.8000e-01, -1.3000e-01, -9.6100e-02/
         data (v022(j),j=16,18)/-7.1800e-02, -5.4500e-02, -4.1900e-02/
         data (v022(j),j=19,21)/-3.2500e-02, -2.5600e-02, -2.0300e-02/
         data (v022(j),j=22,24)/-1.3100e-02, -8.7700e-03, -6.0100e-03/
         data (v022(j),j=25,27)/-4.2200e-03, -3.0200e-03, -2.2700e-03/

         data (v224(j),j=1,3)/5.5440e+01, 3.0760e+01, 1.8170e+01/
         data (v224(j),j=4,6)/1.1280e+01, 7.3000e+00, 4.8900e+00/
         data (v224(j),j=7,9)/3.3800e+00, 2.3900e+00, 1.7300e+00/
         data (v224(j),j=10,12)/1.2800e+00, 9.6000e-01, 7.3000e-01/
         data (v224(j),j=13,15)/5.7000e-01, 4.4000e-01, 3.5000e-01/
         data (v224(j),j=16,18)/2.8000e-01, 2.3000e-01, 1.9000e-01/
         data (v224(j),j=19,21)/1.5000e-01, 1.3000e-01, 1.1000e-01/
         data (v224(j),j=22,24)/7.4800e-02, 5.4100e-02, 4.0000e-02/
         data (v224(j),j=25,27)/3.0000e-02, 2.2900e-02, 1.8200e-02/


          
         if (ifirst.eq.0) then
            rmin =  2.0d0*A_to_au
            rmax =  10.0d0*A_to_au
            rcut = 7.d0*A_to_au
            rspace1 = .25d0*A_to_au
            rspace2 = .5d0*A_to_au
            do j=1,27
               rgrid(j) = rgrid(j)*A_to_au
               v000(j) = v000(j)*K_to_au
               v022(j) = v022(j)*K_to_au
               v224(j) = v224(j)*K_to_au
            enddo
         endif
         ifirst = 1


c         vzero(1) = 0.d0
c         vzero(2) = 0.d0
c         vzero(3) = 0.d0


         pot = 0.d0
         do np=2,npair
            call box_dist(npos(1,2*np-1),npos(1,2*np),len1,v1)
            do j=1,ndim
               cm1(j) = npos(j,2*np) + .5d0*v1(j) 
            enddo
            call box_move(cm1,cm3)
            do i=1,np-1
               call box_dist(npos(1,2*i-1),npos(1,2*i),len2,v2)
               do j=1,ndim
                  cm2(j) = npos(j,2*i) + .5d0*v2(j) 
               enddo
               call box_move(cm2,cm4)
               call box_dist(cm3,cm4,r,cmd)

               cos_1 = 0.d0
               cos_2 = 0.d0
               do j=1,ndim
                  cos_1 = cos_1 + v1(j)*cmd(j)
                  cos_2 = cos_2 + v2(j)*cmd(j)
               enddo

               cos_1 = cos_1/(r*len1)
               cos_2 = cos_2/(r*len2)

               sin_1 = sqrt(1.d0-cos_1**2)
               sin_2 = sqrt(1.d0-cos_2**2)

               g202 = 2.5d0*(3*cos_1**2 - 1.d0)
               g022 = 2.5d0*(3*cos_2**2 - 1.d0)

               cross= 0.d0
               do j=1,ndim
                  cross= cross + v1(j)*v2(j)
               enddo
               cross = cross/(len1*len2)
               if (abs(sin_1*sin_2).lt.1.d-7) then
                  cos_phi = 1.d0
               else
                  cos_phi = (cross-cos_1*cos_2)/(sin_1*sin_2) 
               endif
               cos_2phi = 2*cos_phi**2 - 1.d0

               g224 = 45.d0/(4.d0*sqrt(70.d0))*( 2*(3*cos_1**2 - 1.d0)*
     >           (3*cos_2**2-1.d0)-16*sin_1*cos_1*sin_2*cos_2*cos_phi+
     >           sin_1**2*sin_2**2*cos_2phi)
                 
               if (r.lt.rmin) then
c                   print*,'r.lt.rmin',np,i,r
                   r = rmin
               endif
               if (r.gt.rmax) then 
c                  print*,'r.lt.rmin',np,i,r
                  pt = 0.d0
                  goto 20
               endif

               if (r.lt.rcut) then
                  index = (r-rmin)/rspace1 + 1
                  p0 = (v000(index+1)-v000(index))*
     >                  (r-rgrid(index))/rspace1 + v000(index)
                  p2 = (v022(index+1)-v022(index))*
     >                  (r-rgrid(index))/rspace1 + v022(index)
                  p4 = (v224(index+1)-v224(index))*
     >                  (r-rgrid(index))/rspace1 + v224(index)
               else
                  index = (r-rcut)/rspace2 + 21
                  p0 = (v000(index+1)-v000(index))*
     >                  (r-rgrid(index))/rspace2 + v000(index)
                  p2 = (v022(index+1)-v022(index))*
     >                  (r-rgrid(index))/rspace2 + v022(index)
                  p4 = (v224(index+1)-v224(index))*
     >                  (r-rgrid(index))/rspace2 + v224(index)
               endif
               pt = p0 + g022*p2 + g202*p2 + g224*p4
c               print*,'r',r,p0,p2,p4
c               print*,'r',r,g022,g202,g224
20             continue
               pot = pot  + pt
            enddo
         enddo


      end
   
