
c Main DMC program
      implicit none
      include 'param.h'
      include 'dmc_inc.h'
      

c storage created here
      real*8 epos(ndim,nelec),npos(ndim,nnuclei)
      real*8 centers(ndim,npair),rotmat(ndim,ndim,npair)
      real*8 mup(nup,nup),mdown(ndown,ndown)
      real*8 vp(nvp)

      real*8 dmc_config(ndim,nelec,max_nwalker)
      real*8 dmc_config2(ndim,nelec,max_nwalker)
      real*8 config_en(max_nwalker)
      real*8 config_en2(max_nwalker)

      real*8 pr_list(n_project,max_nwalker)  ! for forward walking 
      real*8 pr_list2(n_project,max_nwalker)  !  the pressure


c local vars
      integer ns,j,np,nac,nacc,nb,i,neb,k,m,ierr
      real*8 det,en,nuc_pot,pt,dr
      real*8 sum_en,ke,pe,lpsi,ssq_en,var,ave
      real*8 tsum_ke,tsum_pe,sum_pr,ssq_pr,pr,sum_ke,sum_pe
      real*8 ssq_ke,ssq_pe
      real*8 xpos,ypos
      real*8 rng
      external rng
      real*8 tv(nnuclei),tv3(ndim,nnuclei),b(nvp),scale(nvp)
      real*8 beta,wk,sca,sb,tsum,pscale,kappa,base_etrial
      real*8 au_to_mbar
      real*8 pr_sum(n_project),pr_ssq(n_project)
      real*8 pr_tot_sum(n_project),pr_tot_ssq(n_project)
      integer pr_norm(n_project)
c simulation variables
      integer nsteps,iseed,nblocks,nerrblocks,itmax,vmc_nblocks
      integer vmc_nerrblocks,minit,ntry,nwalker,ntarget,nw
      character*40 vp_file,pos_file,vp_out_file
      character*40 vp_log_file,grad_log_file,config_file
      character*40 config_file_out,press_file,dmc_en_file
      logical start_vmc

      real*4 etime,tme1(2),tme2(2),tme
      external etime
     
      au_to_mbar = 294.215d0

      iseed = 102
      call read_integer_par(iseed,'iseed')
      call easy_init_rng(iseed)


      call read_integer_par(nsteps,'nsteps')
      call read_integer_par(nblocks,'dmc nblocks')
      call read_integer_par(vmc_nblocks,'vmc nblocks')
      call read_integer_par(vmc_nerrblocks,
     >                      'vmc nerrblocks (number of DMC config)')
      pscale = 1.d0

      start_vmc = .true.
      print*,'input config file'
      read(*,'(a40)') config_file
      if (config_file.ne.'') then
         start_vmc=.false.
         print*,'input config file = ',config_file
      endif

      print*,'output config file'
      read(*,'(a40)') config_file_out

c set vp's and sim parameters

      pi = 4.d0*atan(1.d0)
      rs = 3.d0
c      rs = 2.6465d0
c      rs = 1.66775
c      rs = 2.1d0
c      rs = 1.8d0
      call read_double_par(rs,'rs')
      density = 3.d0/(4.d0*pi*rs**3)
      box_len = ( (2*npair)/density)**(1.d0/3.d0)
      box_len = pscale*box_len
      density = density/pscale**3

c      print*,'*** box_len fixed for h_2 optimization ***'
c      box_len = 20.d0

      recip_box_len = 1.d0/box_len

      print*,'box_len = ',box_len
      box_vol  = box_len**3

      call dist_init()   ! print free or periodic BC's
      call orbital_init()
    

      print*,'nvp = ',nvp

      print*,'vp file'
      read(5,'(a40)') vp_file
      print*,'vp file = ',vp_file

c      print*,'vp log file'
c      read(5,'(a40)') vp_log_file
c      open(16,file=vp_log_file,err=911)

c      print*,'vp out file'
c      read(5,'(a40)') vp_out_file

      open(15,file=vp_file,status='OLD',err=911)
      do i=1,nvp
         read(15,*) vp(i)
      enddo
      close(15)

c some old stuff
c      beta = 9.913d0
c      ee_a = -.5d0
c      ee_b = sqrt(.5d0/beta)
c      en_a = 1.d0
c      en_b = sqrt(1.d0/beta)

c ---------------


c      print*,'scale factor'
c      read*,sca
c      do i=1,nvp
c         scale(i) = sca
c         scale(i) = 0.d0
c      enddo
c      print*,'ien=',ien
c      scale(1) = sca
c      scale(ien) = sca
c      scale(13) = sca
c      scale(14) = sca
c      scale(15) = sca*.1d0
c      scale(1) = .4d0
c      scale(ien) = .4d0

   
c      nerrblocks = 10
c      print*,'nerrblocks'
c      read*,nerrblocks
c      print*,'nerrblocks = ',nerrblocks
      


      tau = 0.02d0
      call read_double_par(tau,'dmc tau')

      delta = 2.00d0
      call read_double_par(delta,'vmc delta')

      kappa = 20.d0


 
c set up intial positions

c      xpos = 1.4d0
c      ypos = 1.4d0
c      do i=1,npair
c         do j=1,ndim
c           npos(j,2*i-1) = 0.d0
c           npos(j,2*i) = 0.d0
c         enddo
c      enddo
c      do j=1,npair
c         npos(1,2*j) = xpos
c         npos(2,2*j-1) = (j-1)*ypos
c         npos(2,2*j) = (j-1)*ypos
c      enddo
      print*,'nuc pos file'
      read(5,'(a40)') pos_file
      print*,'nuc pos file = ',pos_file
      open(10,file=pos_file,status='OLD',err=911)
      do i=1,npair
          read(10,*) (npos(j,2*i-1),j=1,ndim)
          read(10,*) (npos(j,2*i),j=1,ndim)
      enddo
      close(10)
      do i=1,2*npair
         do j=1,ndim
            npos(j,i) = npos(j,i)*pscale
         enddo
      enddo
      

c      print*,'dmc etrial'
c      read*,dmc_etrial
c       print*,'dmc_etrial = ',dmc_etrial
      call read_double_par(dmc_etrial,'dmc etrial')

      print*,'pressure output file'
      read(5,'(a40)') press_file
      print*,'pressure output file = ',press_file

      print*,'dmc energy output file'
      read(5,'(a40)') dmc_en_file
      print*,'dmc energy output file = ',dmc_en_file
      open(41,file=dmc_en_file,err=911)

      call set_centers(npos,centers,rotmat)
 
c      print*,'center',centers(1,1),centers(2,1),centers(3,1)

      if (start_vmc) then
      sb = 2.d0
      do np=1,npair
         do j=1,ndim
c            epos(j,np) = box_len*(rng()-.5d0)
            epos(j,np) = centers(j,np) + sb*(rng()-.5d0)
            epos(j,np+npair) = centers(j,np) + sb*(rng()-.5d0)
         enddo
      enddo
      endif
c      do j=1,ndim
c        epos(j,1) = 0.d0
c        epos(j,2) = 0.d0
c      enddo
c      epos(1,1) = 0.20d0
c      epos(2,2) = 0.50d0


      nuc_pot = 0.d0
      do j=1,nnuclei
         call nn_dist(j,npos,npos(1,j),tv,tv3)
         call nn_potential(tv,pt)
         nuc_pot = nuc_pot + 0.5d0*pt
      enddo
      print*,'Nuclear potential ',nuc_pot

      call total_nuclear_potential(npos,nuc_pot)
      print*,'Alt Nuclear potential ',nuc_pot
c set up fermion matrices

      call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
      call fermion_det(mup,mdown,det)
      print*,'det',det

      call local_energy(npos,epos,mup,mdown,centers,rotmat,vp,en,ke,pe,
     >                  lpsi)
      print*,'local e',en
      dr = 2.0d-4
c      call wf_test(npos,epos,mup,mdown,centers,rotmat,vp,dr)


      sum_en = 0.d0
      ssq_en = 0.d0
      sum_pr = 0.d0
      ssq_pr = 0.d0
      sum_ke = 0.d0
      ssq_ke = 0.d0
      sum_pe = 0.d0
      ssq_pe = 0.d0
      nacc = 0

      if (start_vmc) then
      tme = etime(tme1)
      do neb=1,vmc_nerrblocks
         tsum = 0.d0 
         tsum_ke = 0.d0
         tsum_pe = 0.d0
         do nb=1,vmc_nblocks
            do ns=1,nsteps
               call metropolis(mup,mdown,npos,epos,centers,rotmat,vp,
     >                         det,nac)
               nacc = nacc + nac
            enddo
            call local_energy(npos,epos,mup,mdown,centers,rotmat,vp,en,
     >                        ke,pe,lpsi)
            tsum = tsum + en
            tsum_ke = tsum_ke + ke
            tsum_pe = tsum_pe + pe 
            write(40,'(2e20.10)') en+nuc_pot,en
         enddo
         do k=1,nelec
            do j=1,ndim
               dmc_config(j,k,neb) = epos(j,k)
            enddo
         enddo
         en = tsum/vmc_nblocks
         ke = tsum_ke/vmc_nblocks
         pe = tsum_pe/vmc_nblocks + nuc_pot
         sum_en = sum_en + en
         ssq_en = ssq_en + en**2
         sum_ke = sum_ke + ke
         ssq_ke = ssq_ke + ke**2
         sum_pe = sum_pe + pe
         ssq_pe = ssq_pe + pe**2
         pr =  (2*ke+pe)/(3*box_len**3)
         sum_pr = sum_pr + pr
         ssq_pr = ssq_pr + pr*pr
c         write(41,'(6e14.5)') epos(1,1),epos(2,1),epos(3,1),
c     >       epos(1,2),epos(2,2),epos(3,2)
      enddo
      en = sum_en/vmc_nerrblocks
      var = ssq_en/vmc_nerrblocks-en*en
      print*,'ave VMC energy = ',en+nuc_pot,sqrt(var/(vmc_nerrblocks-1))
      nwalker = vmc_nerrblocks

    !  dmc_etrial = en+nuc_pot

      tme = etime(tme2)
      print*,'vmc time = ',tme2(1)-tme1(1)
      else  ! start_vmc

         nwalker= 0
         open(10,file=config_file,status='OLD',err=911)
         do nw = 1,max_nwalker
            do i=1,nelec
                read(10,*,end=20) (dmc_config(j,i,nw),j=1,ndim)
            enddo
            nwalker = nwalker + 1
            read(10,*,end=20)
         enddo
20       continue
         print*,'initial nwalker',nwalker
         close(10)

      endif ! start_vmc
    


c  okay, we have the VMC configurations, do some DMC
       ntry = 0
       nacc = 0
       ntarget = nwalker
       base_etrial = dmc_etrial

c   set up for forward walking
       i_fw_pos = n_project
       do j=1,max_nwalker
          do i=1,n_project
             pr_list(i,j) = 0.d0
             pr_list2(i,j) = 0.d0
          enddo
       enddo
       do i=1,n_project
          pr_tot_sum(i) = 0.d0
          pr_tot_ssq(i) = 0.d0
          pr_norm(i) = 0
       enddo
       tme = etime(tme1)
       do nb=1,nblocks
          call dmc_advance(dmc_config,dmc_config2,npos,centers,rotmat,
     >                     vp,config_en,config_en2,nwalker,
     >                     nuc_pot,ntry,nacc,pr_list,pr_list2,ierr)

          if (ierr.ne.0) then
             print*,'no of walkers exploded'
             stop
          endif
c          print*,'nwalker',nwalker
          sum_en = 0.d0
          ssq_en = 0.d0
          do i=1,nwalker
             sum_en = sum_en  + config_en2(i)
             ssq_en = ssq_en  + config_en2(i)**2
          enddo
          en = sum_en/nwalker
          var = ssq_en/nwalker-en*en
c          print*,'energy',en,sqrt(var/(nwalker-1))
          write(41,'(2e20.11,i5)') en,sqrt(var/(nwalker-1)),nwalker
          dmc_etrial = base_etrial + 
     >                   kappa*log(dble(ntarget)/dble(nwalker))

          do i=1,n_project
             pr_sum(i) = 0.d0
             pr_ssq(i) = 0.d0
          enddo
          
c          do j=1,nwalker
c             m = n_project - i_fw_pos + 1
c             do i=1,m
c                pr_sum(i) = pr_sum(i) + pr_list2(i+i_fw_pos-1,j)
c                pr_ssq(i) = pr_ssq(i) + pr_list2(i+i_fw_pos-1,j)**2
c             enddo
c             do i=1,i_fw_pos-1
c                pr_sum(i+m) = pr_sum(i+m) + pr_list2(i,j)
c                pr_ssq(i+m) = pr_ssq(i+m) + pr_list2(i,j)**2
c             enddo
cc              do i=1,n_project
cc                pr_sum(i) = pr_sum(i) + pr_list2(i,j)
cc                pr_ssq(i) = pr_ssq(i) + pr_list2(i,j)**2
cc              enddo
c          enddo

c          do i=1,n_project
c             ave = pr_sum(i)/nwalker
c             var = pr_ssq(i)/nwalker - ave*ave
c             write(51,'(i4,2e20.11)') i,au_to_mbar*ave,
c     >                  au_to_mbar*sqrt(var/(nwalker-1))
cc             write(51,'(i4,2e20.11)') i,ave, var
c          enddo
c          write(51,'("")')

c          i_fw_pos = i_fw_pos - 1
c          if (i_fw_pos.lt.1) i_fw_pos = n_project



          call dmc_advance(dmc_config2,dmc_config,npos,centers,rotmat,
     >                     vp,config_en2,config_en,nwalker,
     >                     nuc_pot,ntry,nacc,pr_list2,pr_list,ierr)
c          print*,'nwalker',nwalker
          if (ierr.ne.0) then
             print*,'no of walkers exploded'
             stop
          endif
          sum_en = 0.d0
          ssq_en = 0.d0
          do i=1,nwalker
             sum_en = sum_en  + config_en(i)
             ssq_en = ssq_en  + config_en(i)**2
          enddo
          en = sum_en/nwalker
          var = ssq_en/nwalker-en*en
c          print*,'energy',en,sqrt(var/(nwalker-1))
          write(41,'(2e20.11,i5)') en,sqrt(var/(nwalker-1)),nwalker

          dmc_etrial = base_etrial + 
     >                   kappa*log(dble(ntarget)/dble(nwalker))

          do i=1,n_project
             pr_sum(i) = 0.d0
             pr_ssq(i) = 0.d0
          enddo
          do j=1,nwalker
             m = n_project - i_fw_pos + 1
             do i=1,m
                pr_sum(i) = pr_sum(i) + pr_list(i+i_fw_pos-1,j)
                pr_ssq(i) = pr_ssq(i) + pr_list(i+i_fw_pos-1,j)**2
             enddo
             do i=1,i_fw_pos-1
                pr_sum(i+m) = pr_sum(i+m) + pr_list(i,j)
                pr_ssq(i+m) = pr_ssq(i+m) + pr_list(i,j)**2
             enddo
c             do i=1,n_project
c                pr_sum(i) = pr_sum(i) + pr_list(i,j)
c                pr_ssq(i) = pr_ssq(i) + pr_list(i,j)**2
c             enddo
          enddo

          do i=1,n_project
             ave = pr_sum(i)/nwalker
             var = pr_ssq(i)/nwalker - ave*ave
             pr_tot_sum(i) = pr_tot_sum(i) + ave
             pr_tot_ssq(i) = pr_tot_ssq(i) + ave*ave
             if (ave.ne.0.d0) pr_norm(i) = pr_norm(i) + 1
c             write(51,'(i4,2e20.11)') i,au_to_mbar*ave,
c     >                  au_to_mbar*sqrt(var/(nwalker-1))
c             write(51,'(i4,2e20.11)') i,ave var
          enddo
c          write(51,'("")')

          if (mod(nb,2).eq.0) then
             i_fw_pos = i_fw_pos - 1
             if (i_fw_pos.le.0) i_fw_pos = n_project
          endif
       enddo
       tme = etime(tme2)
       print*,'dmc time = ',tme2(1)-tme1(1)

       print*,'DMC AR',dble(nacc)/dble(ntry)




c      print*,'ave energy = ',sum_en/nblocks + nuc_pot
c      en = sum_en/vmc_nerrblocks
c      var = ssq_en/vmc_nerrblocks-en*en
c      print*,'ave energy = ',en +nuc_pot,sqrt(var/(vmc_nerrblocks-1))
c      ke = sum_ke/vmc_nerrblocks
c      var = ssq_ke/vmc_nerrblocks-ke*ke
c
c      pe = sum_pe/vmc_nerrblocks
c      var = ssq_pe/vmc_nerrblocks-pe*pe
c      print*,'ke',ke,sqrt(var/(vmc_nerrblocks-1))
c      print*,'pe',pe,sqrt(var/(vmc_nerrblocks-1))
c
c      pr = sum_pr/vmc_nerrblocks
c      var = ssq_pr/vmc_nerrblocks-pr*pr
c      print*,'ave pressure = ',pr*au_to_mbar,
c     >            au_to_mbar*sqrt(var/(vmc_nerrblocks-1))

c      open(15,file=vp_out_file,err=911)
c      do i=1,nvp
c         write(15,*) vp(i)
c      enddo
c      close(15)

c dump out configurations
         open(10,file=config_file_out,err=911)
         do nw = 1,nwalker
            do i=1,nelec
                write(10,'(3f10.5)') (dmc_config(j,i,nw),j=1,ndim)
            enddo
            nwalker = nwalker + 1
            write(10,'("")')
         enddo
  
c dump out FW pressure
          open(52,file=press_file,err=911)
          do i=1,n_project
             if (pr_norm(i).ne.0) then
                ave = pr_tot_sum(i)/pr_norm(i)
                var = pr_tot_ssq(i)/pr_norm(i) - ave*ave
                 print*,'i,pr',i, pr_norm(i),ave,var
                if (pr_norm(i).gt.1) then
             write(52,'(i4,2e20.11)') i,au_to_mbar*ave,
     >                  au_to_mbar*sqrt(var/(pr_norm(i)-1))
                endif
             endif
c             write(52,'(i4,2e20.11)') i,ave var
          enddo
          close(52)
      close(41)

      print*,'acceptance ratio',real(nacc)/
     >          real(nsteps*nelec*vmc_nerrblocks*vmc_nblocks)


      stop


911   continue
      print*,'file not found'
      stop

      end
      
