
c  contains high level DMC routines (walker management, etc)

c   advance all the walkers one step
      subroutine dmc_advance(config_old,config_new,npos,centers,rotmat,
     >                       vp,config_old_en,config_new_en,nwalker,
     >                       nuc_pot,ntry,nacc,
     >                       pr_list_old,pr_list_new,ierr)

      implicit none
      include 'param.h'
      include 'dmc_inc.h'
          
      real*8 config_old(ndim,nelec,max_nwalker)
      real*8 config_new(ndim,nelec,max_nwalker)
      real*8 npos(ndim,nnuclei),centers(ndim,npair)
      real*8 rotmat(ndim,ndim,npair),vp(nvp)
      real*8 config_old_en(max_nwalker),config_new_en(max_nwalker)
      integer nwalker,ntry,nacc
      real*8 pr_list_old(n_project,max_nwalker)
      real*8 pr_list_new(n_project,max_nwalker)
      integer ierr
    

      integer nw,ncopy,new_nw,i,j,k
      real*8 new_en,nuc_pot,press,ke,pe

      new_nw = 0

      ierr = 0
c      if (ixplod.ne.0) then
c         print*,'nuc pot',nuc_pot
c      endif

      do nw=1,nwalker
         call drift(npos,config_old(1,1,nw),centers,rotmat,vp,
     >              config_old_en(nw),new_en,ke,pe,nuc_pot,
     >              ncopy,ntry,nacc)

          
c         if (ixplod.ne.0) then
c            print*,'ncopy,en',ncopy,new_en,config_old_en(nw)
c         endif
         press = (2*ke+pe+nuc_pot)/(3.d0*box_vol)
         do k=1,ncopy
            new_nw = new_nw + 1
            if (new_nw.gt.max_nwalker) then
               print*,'No. of walkers exploded',new_nw
               ierr = 1
               return
            endif
            do j=1,nelec
               do i=1,ndim
                  config_new(i,j,new_nw) = config_old(i,j,nw)
               enddo
            enddo
            config_new_en(new_nw) = new_en
            do j=1,n_project
               pr_list_new(j,new_nw) = pr_list_old(j,nw)
            enddo
            pr_list_new(i_fw_pos,new_nw) = press
         enddo

      enddo  ! nwalker

c      i_fw_pos = i_fw_pos - 1
c      if (i_fw_pos.lt.1) i_fw_pos = n_project

      nwalker = new_nw 

      end

