

c handles the drift/diffusion part for a single walker
      subroutine drift(npos,epos,centers,rotmat,vp,old_en,
     >                  new_en,ke,pe,nuc_pot,ncopy,ntry,nacc)

      implicit none
      include 'param.h'
      include 'dmc_inc.h'
      real*8 epos(ndim,nelec),npos(ndim,nnuclei)
      real*8 centers(ndim,npair),rotmat(ndim,ndim,npair),vp(nvp)
      real*8 old_en,new_en,ke,pe,nuc_pot  
      integer ncopy,ntry,nacc

c  nuc_pot is nuclear potential and should be an input
c  if old_en is zero it will be computed, otherwise assumed to be input

      integer np,i
      real*8 mup(nup,nup),mdown(ndown,ndown)
      real*8 stau,r_atm,r_acc,fq(ndim),chi(ndim),xt(ndim),delt(ndim)
      real*8 tpi,lambda,xtt(ndim),rtrial,det_old,det_ratio,prob
      real*8 fqp(ndim),fq_b(ndim),dp1,dp2,arg,gf,ran,ave_en,rnc
      real*8 rn1,rn2,j3(ndim),det_new,xold(ndim)
      real*8 teff,rng,lpsi
      parameter(lambda=0.5d0)


      tpi = 8.d0*atan(1.d0)
      stau = sqrt(tau)
      r_atm = 0.d0
      r_acc = 0.d0

c set up inverse matrix

      call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
      call fermion_det(mup,mdown,det_old)

      if (old_en.eq.0.d0) then
         call local_energy(npos,epos,mup,mdown,centers,rotmat,vp,old_en,
     >                     ke,pe,lpsi)
         old_en = old_en + nuc_pot 
      endif
      

      do np=1,nelec
         ntry = ntry + 1



         call quant_force(npos,epos,mup,mdown,centers,rotmat,vp,np,
     >                    epos(1,np),fq)

         rn1 = rng()
         rn2 = rng()
         chi(3) = sqrt(-2.d0*log(rn1))*cos(tpi*rn2)
         chi(2) = sqrt(-2.d0*log(rn1))*sin(tpi*rn2)
         rn1 = rng()
         rn2 = rng()
         chi(1) = sqrt(-2.d0*log(rn1))*cos(tpi*rn2)
         do i=1,ndim
            xold(i) = epos(i,np)
         enddo

         do i=1,ndim 
            delt(i) = stau*chi(i) + tau*lambda*fq(i)
            xtt(i) = epos(i,np) + delt(i)
         enddo
         call box_move(xtt,xt)

         call box_dist(epos(1,np),xt,rtrial,j3)
         
         r_atm = r_atm + rtrial**2

         call fermion_det_ratio(mup,mdown,np,xt,det_ratio,centers,
     >                          rotmat,vp)
          
c         print*,'det ratio',det_ratio

c Fixed node
  
         if (det_ratio.le.0.d0) then
c            print*,'fixed node',det_ratio
            goto 10
         endif

         call psi_oldnew(np,xt,npos,epos,vp,prob)

         prob = prob*det_ratio**2

         call fermion_inv_update(mup,mdown,np,xt,centers,rotmat,vp,
     >                        det_ratio)
c         do i=1,ndim
c            epos(i,np) = xt(i)
c         enddo
c         call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
c         call fermion_det(mup,mdown,det_new)

         call quant_force(npos,epos,mup,mdown,centers,rotmat,vp,np,xt,
     >                    fqp)

         do i=1,ndim
            fq_b(i) = .5d0*(fq(i) + fqp(i))
         enddo

         dp1 = 0.d0
         dp2 = 0.d0
         do i=1,ndim
            dp1 = dp1 + fq_b(i)*fq_b(i)
            dp2 = dp2 + chi(i)*fq_b(i)
         enddo
         arg = -lambda*tau*dp1 - stau*dp2

         gf = exp(arg)
 
         prob = prob*gf
         if (prob.lt.1.d0) then
            ran = rng()
            if (prob.lt.ran) then   ! reject
               do i=1,ndim
                  epos(i,np) = xold(i)
               enddo
               call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
               call fermion_det(mup,mdown,det_old)
               goto 10
            endif
         endif

c  accept
         do i=1,ndim
            epos(i,np) = xt(i)
         enddo
       

         r_acc = r_acc + rtrial**2
         nacc = nacc + 1

10       continue
      enddo  !  np=1,nelec

      teff = (r_acc/r_atm)
       if (r_atm.eq.0.d0) teff=1.d0
c      teff = 1.d0
      

      call local_energy(npos,epos,mup,mdown,centers,rotmat,vp,new_en,
     >                  ke,pe,lpsi)

      new_en = new_en + nuc_pot

      ave_en =  .5d0*(old_en + new_en)
      rnc = exp(-tau *teff*(ave_en - dmc_etrial))
      ncopy = int(rnc+rng())
c shut off branching
c      ncopy = 1
c      print*,'ncopy',ncopy




      end
