
c compute energy difference between different vp's or nuclear positions
c  using direct (brute force) method

      subroutine ediff(nsteps,nblocks,nerrblocks,
     >                npos1,epos1,centers1,rotmat1,vp1,mup1,mdown1,nac1,
     >                npos2,epos2,centers2,rotmat2,vp2,mup2,mdown2,nac2,
     >                ed,err,e1,err1,e2,err2,
     >                ke2,ke_err2,pe2,pe_err2)
         implicit none
         include 'param.h'
         integer nsteps,nblocks,nerrblocks
         real*8 mup1(nup,nup),mdown1(ndown,ndown)
         real*8 epos1(ndim,nelec),npos1(ndim,nelec)
         real*8 centers1(ndim,ncenter)
         real*8 rotmat1(ndim,ndim,npair),vp1(nvp)
         real*8 mup2(nup,nup),mdown2(ndown,ndown)
         real*8 epos2(ndim,nelec),npos2(ndim,nelec)
         real*8 centers2(ndim,ncenter)
         real*8 rotmat2(ndim,ndim,npair),vp2(nvp)
         integer nac1,nac2
         real*8 ed,err,e1,err1,e2,err2
         real*8 ke2,ke_err2,pe2,pe_err2
         real*8 tke1,tpe1,tke2,tpe2,lpsi,det
      
         

         
         real*8 rng
         external rng

         integer ns,nb,n1,n2,neb
         real*8 en1,en2
         real*8 nuc_e1,nuc_e2

         real*8 sum_e1,sum_e2,ssq_e1,ssq_e2,v1,v2,vk,vp
         real*8 sum_ke2,ssq_ke2,sum_pe2,ssq_pe2,esum,psum,ksum

       
         call total_nuclear_potential(npos1,nuc_e1)
         call total_nuclear_potential(npos2,nuc_e2)

         sum_e1 = 0.d0
         ssq_e1 = 0.d0
         det = 0.d0
         do neb=1,nerrblocks
            esum = 0.d0
            do nb=1,nblocks
               do ns=1,nsteps
                  call metropolis(mup1,mdown1,npos1,epos1,centers1,
     >                            rotmat1,vp1,det,n1)
                  nac1 = nac1 + n1
               enddo
               call local_energy(npos1,epos1,mup1,mdown1,centers1,
     >                           rotmat1,vp1,en1,tke1,tpe1,lpsi)
               esum = esum + en1
            enddo
            en1 = esum/nblocks
            sum_e1 = sum_e1 + en1
            ssq_e1 = ssq_e1 + en1*en1
         enddo

         sum_e2 = 0.d0
         ssq_e2 = 0.d0
         sum_ke2 = 0.d0
         ssq_ke2 = 0.d0
         sum_pe2 = 0.d0
         ssq_pe2 = 0.d0
         do neb=1,nerrblocks
            esum = 0.d0
            psum = 0.d0
            ksum = 0.d0
            do nb=1,nblocks
               do ns=1,nsteps
                  call metropolis(mup2,mdown2,npos2,epos2,centers2,
     >                            rotmat2,vp2,det,n2)
                  nac2 = nac2 + n2
               enddo
               call local_energy(npos2,epos2,mup2,mdown2,centers2,
     >                           rotmat2,vp2,en2,tke2,tpe2,lpsi)
               esum = esum + en2
               psum = psum + tpe2
               ksum = ksum + tke2
            enddo
            en2 = esum/nblocks
            tpe2 = psum/nblocks
            tke2 = ksum/nblocks
            sum_e2 = sum_e2 + en2
            ssq_e2 = ssq_e2 + en2*en2
            sum_ke2 = sum_ke2 + tke2
            ssq_ke2 = ssq_ke2 + tke2*tke2
            sum_pe2 = sum_pe2 + tpe2
            ssq_pe2 = ssq_pe2 + tpe2*tpe2
         enddo

         e1 = sum_e1/real(nerrblocks)
         e2 = sum_e2/real(nerrblocks) 
         ke2 = sum_ke2/real(nerrblocks) 
         pe2 = sum_pe2/real(nerrblocks) 

         v1 = ssq_e1/real(nerrblocks) - e1*e1
         v2 = ssq_e2/real(nerrblocks) - e2*e2
         vk = ssq_ke2/real(nerrblocks) - ke2*ke2
         vp = ssq_pe2/real(nerrblocks) - pe2*pe2

         if (nerrblocks.gt.1) then
            err1 = sqrt(abs(v1)/real(nerrblocks-1))
            err2 = sqrt(abs(v2)/real(nerrblocks-1))
            ke_err2 = sqrt(abs(vk)/real(nerrblocks-1))
            pe_err2 = sqrt(abs(vp)/real(nerrblocks-1))
         endif

         e1 = e1 + nuc_e1
         e2 = e2 + nuc_e2
         pe2 = pe2 + nuc_e2

         ed = e1 - e2
         err = sqrt(err1**2 + err2**2)

      end
