
c Test program for energy difference
      implicit none
      include 'param.h'

c storage created here
      real*8 epos1(ndim,nelec),npos1(ndim,nnuclei)
      real*8 centers1(ndim,npair)
      real*8 mup1(nup,nup),mdown1(ndown,ndown)
      real*8 rotmat1(ndim,ndim,npair),vp1(nvp)

      real*8 epos2(ndim,nelec),npos2(ndim,nnuclei)
      real*8 centers2(ndim,npair)
      real*8 mup2(nup,nup),mdown2(ndown,ndown)
      real*8 rotmat2(ndim,ndim,npair),vp2(nvp)


c local vars
      integer ns,j,np,nac,nacc,nb,i
      real*8 det,en,nuc_pot,pt
      real*8 sum_en
      real*8 xpos,ypos
      real*8 rng
      external rng
      real*8 tv(nnuclei),tv3(ndim,nnuclei)
      real*8 beta,wk
      real*8 ed,err,e1,err1,e2,err2
      real*8 pe,ke,pe_err,ke_err,press,press_err,lpsi,vps
      real*8 au_to_mbar
      integer nac1,nac2
      character*40 vp_file,pos_file
   
 
c simulation variables
      integer nsteps,iseed,nblocks
     
      au_to_mbar = 294.215d0

      iseed = 100
      call easy_init_rng(iseed)
      print*,'initial rng',rng()

      print*,'nsteps'
      read*,nsteps
      print*,'nblocks'
      read*,nblocks

c set vp's and sim parameters

      pi = 4.d0*atan(1.d0)
      rs = 3.d0
      density = 3.d0/(4.d0*pi*rs**3)
      box_len = ( (2*npair)/density)**(1.d0/3.d0)
      recip_box_len = 1.d0/box_len

      print*,'box_len = ',box_len

      print*,'nvp = ',nvp

      print*,'vp file'
      read(5,'(a40)') vp_file
      open(15,file=vp_file,status='OLD',err=911)
      do i=1,nvp
         read(15,*) vp1(i)
         vp2(i) = vp1(i) 
      enddo
      close(15)


      delta = 4.d0
c      print*,'delta'
c      read*,delta

      print*,'CM delta'
      read*,cm_delta

c      theta_max = 0.d0
      print*,'CM theta max'
      read*,theta_max
      beta = 0.8d0
      wk=1.9d0 

 
c set up intial positions

c      xpos = 1.4d0
c      ypos = 1.4d0
c      do i=1,npair
c         do j=1,ndim
c           npos(j,2*i-1) = 0.d0
c           npos(j,2*i) = 0.d0
c         enddo
c      enddo
c      do j=1,npair
c         npos(1,2*j) = xpos
c         npos(2,2*j-1) = (j-1)*ypos
c         npos(2,2*j) = (j-1)*ypos
c      enddo

      print*,'nuc pos file'
      read(5,'(a40)') pos_file
      open(10,file=pos_file,status='OLD',err=911)
      do i=1,npair
          read(10,*) (npos1(j,2*i-1),j=1,ndim)
          read(10,*) (npos1(j,2*i),j=1,ndim)
      enddo
      close(10)

      do i=1,2*npair
         do j=1,ndim 
               npos2(j,i) = npos1(j,i)
         enddo
      enddo
c       npos1(1,1) = npos1(1,1) + cm_delta

c make trial move
      print*,'old pos',npos1(1,1),npos1(2,1),npos1(3,1)
      print*,'old pos',npos1(1,2),npos1(2,2),npos1(3,2)
      call classical_move(npos1,1)
      print*,'new pos',npos1(1,1),npos1(2,1),npos1(3,1)
      print*,'new pos',npos1(1,2),npos1(2,2),npos1(3,2)

      call set_centers(npos1,centers1,rotmat1)
      call set_centers(npos2,centers2,rotmat2)
      print*,'vp(7) shift'
      read*,vps
      vp1(7) = vp1(7) + vps

 
c      print*,'center',centers(1,1),centers(2,1),centers(3,1)

      do np=1,nelec
         do j=1,ndim
c            epos(j,np) = box_len*(rng()-.5d0)
            epos1(j,np) = box_len*rng()
c            epos2(j,np) = box_len*rng()
            epos2(j,np) = epos1(j,np)
         enddo
      enddo

c      nuc_pot = 0.d0
c      do j=1,nnuclei
c         call nn_dist(j,npos,npos(1,j),tv,tv3)
c         call nn_potential(tv,pt)
c         nuc_pot = nuc_pot + 0.5d0*pt
c      enddo
c      print*,'Nuclear potential ',nuc_pot
c set up fermion matrices

      call fermion_fill(mup1,mdown1,centers1,rotmat1,vp1,epos1)
      call fermion_det(mup1,mdown1,det)
      call local_energy(npos1,epos1,mup1,mdown1,centers1,rotmat1,vp1,
     >                  en,ke,pe,lpsi)
      print*,'local energy',en

      call fermion_fill(mup2,mdown2,centers2,rotmat2,vp2,epos2)
      call fermion_det(mup2,mdown2,det)

c      call ediff(nsteps,nblocks,
c     >           npos1,epos1,centers1,rotmat1,vp1,mup1,mdown1,nac1,
c     >           npos2,epos2,centers2,rotmat2,vp2,mup2,mdown2,nac2,
c     >           ed,err,e1,err1,e2,err2,
c     >           ke,ke_err,pe,pe_err)

      call ts_diff(nsteps,nblocks,
     >           npos1,epos1,centers1,rotmat1,vp1,mup1,mdown1,nac1,
     >           npos2,epos2,centers2,rotmat2,vp2,mup2,mdown2,nac2,
     >           ed,err,e1,err1,e2,err2,
     >           ke,ke_err,pe,pe_err)
     

       print*,'energy diff',ed,err
       print*,'e1 = ',e1,err1
       print*,'e2 = ',e2,err2
       print*,'brute de',e1-e2,sqrt(err1**2 + err2**2)
       print*,'ke2 = ',ke,ke_err
       print*,'pe2 = ',pe,pe_err
       press = density/(2.d0*npair)*(2*ke-pe)/3.d0
       press_err = density/(2.d0*npair)*sqrt(4*ke_err**2+pe_err**2)/3.d0
       print*,'pressure = ',press,press_err
       print*,'pressure(MBAR) = ',au_to_mbar*press,au_to_mbar*press_err


c      sum_en = 0.d0
c      nacc = 0
c      do nb=1,nblocks
c         do ns=1,nsteps
c            call metropolis(mup,mdown,npos,epos,centers,nac)
c            nacc = nacc + nac
c         enddo
c         call local_energy(npos,epos,mup,mdown,centers,en)
c         sum_en = sum_en + en
c         write(40,'(2e20.10)') en+nuc_pot,en
cc         write(41,'(6e14.5)') epos(1,1),epos(2,1),epos(3,1),
cc     >       epos(1,2),epos(2,2),epos(3,2)
c      enddo
c

c      print*,'ave energy = ',sum_en/nblocks + nuc_pot

      print*,'acceptance ratio',real(nac1+nac2)/
     >       real(2*nsteps*nelec*nblocks)


      stop

911   continue
      print*,'file not found'
      stop
      end
      
