
      subroutine gr_ee_start(dr)
         implicit none
         include 'param.h'
         include 'gr_ee.h'
         real*8 dr
         gr_ee_dr = dr
         gr_ee_cut = box_len/2.d0
         gr_ee_n = int(gr_ee_cut/gr_ee_dr)+1
         if (gr_ee_n.gt.gr_ee_nmax) then
            print*,'gr n too large',gr_ee_n,gr_ee_nmax
            gr_ee_n = gr_ee_nmax
            gr_ee_cut = gr_ee_n*gr_ee_dr
         endif
      end
      subroutine gr_ee_sample(npos,epos)
         implicit none
         include 'param.h'
         include 'gr_ee.h'
         real*8 npos(ndim,nnuclei),epos(ndim,nelec)
         integer  i,j,idx
         real*8 pv(nelec),pv3(ndim,nelec)
         do i=1,nelec
             call ee_dist(i,epos,epos(1,i),pv,pv3)
             do j=1,nelec-1
                if (pv(j).lt.gr_ee_cut) then
                idx = int(pv(j)/gr_ee_dr) +1
                if (idx.gt.gr_ee_n) then
                   print*,"error, idx too large",idx
                endif
                gr_ee_hist(idx) = gr_ee_hist(idx) + 1
                endif
             enddo
         enddo
         gr_ee_norm = gr_ee_norm + 1

         do i=1,nnuclei
             call en_dist(epos,npos(1,i),pv,pv3)
             do j=1,nelec
                if (pv(j).lt.gr_ee_cut) then
                idx = int(pv(j)/gr_ee_dr) +1
                if (idx.gt.gr_ee_n) then
                   print*,"error, idx too large",idx
                endif
                gr_en_hist(idx) = gr_en_hist(idx) + 1
                endif
             enddo
         enddo
         gr_en_norm = gr_en_norm + 1
      end
      subroutine gr_ee_write(fname)
         implicit none
         include 'param.h'
         include 'gr_ee.h'
         character*40 fname
         real*8 fpio3,r,rlow,rhigh,const,en_const,dv
         integer i

         open(64,file=fname)
         fpio3 = 16.d0*atan(1.d0)/3.d0
         const = fpio3*gr_ee_norm*nelec*nelec/(box_len**3)
         en_const = fpio3*gr_en_norm*nelec*nelec/(box_len**3)
         do i=1,gr_ee_n
            rlow = (i-1)*gr_ee_dr 
            rhigh = rlow + gr_ee_dr 
            dv = rhigh**3 - rlow**3
            r = (i-1)*gr_ee_dr + .5d0*gr_ee_dr
            write(64,'(f10.5,e20.10,i10,e20.10,i10)') r,
     >            gr_ee_hist(i)/(const*dv),
     >            gr_ee_hist(i),
     >            gr_en_hist(i)/(en_const*dv),
     >            gr_en_hist(i)
         enddo
         
      end
