
c compute gradient and hessian wrt variational parameters

      subroutine compute_hessian(npos,epos,mup,mdown,centers,rotmat,
     >                            vp,det,dr,en,grad,de,sderiv)
         implicit none
         include 'param.h'
         real*8 epos(ndim,nelec),npos(ndim,nnuclei)
         real*8 mup(nup,nup),mdown(ndown,ndown)
         real*8 centers(ndim,ncenter),rotmat(ndim,ndim,npair),vp(nvp)
c det is an input 
         real*8 det,dr
         real*8 en,grad(nvp),de(nvp),sderiv(nvp,nvp)


         integer i,j,k
         real*8 ovp,det1,det2,ovp1,gradpdr(nvp),enpdr

         call local_energy_vp(npos,epos,mup,mdown,centers,rotmat,vp,
     >                        en,grad(1),grad(ien))

c for using beta as a vp
c         grad(1) = grad(1) + grad(ien)

         call fermion_vp_deriv(mup,mdown,epos,centers,rotmat,vp,
     >                         grad(id))

c  orbital cutoff parameter needs FD evaluation

         ovp = vp(nvp)

         vp(nvp) = vp(nvp) + dr
         call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
         call fermion_det_only(mup,mdown,det1)

         grad(nvp) = (det1/det-1.d0)/dr
         vp(nvp) = ovp

         do i=1,nvp
              do k=1,nvp
                 gradpdr(k) = 0.d0
              enddo
          
              ovp1 = vp(i)
              vp(i) = vp(i) + dr
              call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
              call fermion_det(mup,mdown,det2)

         call local_energy_vp(npos,epos,mup,mdown,centers,rotmat,vp,
     >                        enpdr,gradpdr(1),gradpdr(ien))

c for using beta as a vp
c         grad(1) = grad(1) + grad(ien)

         call fermion_vp_deriv(mup,mdown,epos,centers,rotmat,vp,
     >                         gradpdr(id))

c  orbital cutoff parameter needs FD evaluation

            ovp = vp(nvp)

            vp(nvp) = vp(nvp) + dr
            call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
            call fermion_det_only(mup,mdown,det1)

            gradpdr(nvp) = (det1/det2-1.d0)/dr
            vp(nvp) = ovp
            vp(i) = ovp1

            do k=1,nvp
               sderiv(k,i) = (gradpdr(k) - grad(k))/dr
            enddo
            de(i) = (enpdr - en)/dr

          enddo ! nvp
  
      end


      subroutine estimate_hessian(npos,epos,mup,mdown,centers,rotmat,
     >                             vp,dr,ns,nb,en,grad,hess)
         implicit none
         include 'param.h'
         real*8 epos(ndim,nelec),npos(ndim,nnuclei)
         real*8 mup(nup,nup),mdown(ndown,ndown)
         real*8 centers(ndim,ncenter),rotmat(ndim,ndim,npair),vp(nvp)
c det is an input 
         real*8 dr 
         integer ns,nb
         real*8 en,grad(nvp),hess(nvp,nvp)
         

         real*8 ave_psi(nvp),ave_en,ave_epsi(nvp),grad1(nvp)
         real*8 sderiv(nvp,nvp),de(nvp)
         real*8 ave_edpsi(nvp,nvp),ave_ddpsi(nvp,nvp)
         real*8 ave_epsipsi(nvp,nvp)
         real*8 ave_psipsi(nvp,nvp),ave_dedpsi(nvp,nvp)
         real*8 det,en1
         integer i,ins,inb,nac,nacc,j

         do i=1,nvp
            ave_psi(i) = 0.d0
            ave_epsi(i) = 0.d0
         enddo
         ave_en = 0.d0
         do i=1,nvp
            do j=1,nvp
               ave_edpsi(j,i) = 0.d0
               ave_ddpsi(j,i) = 0.d0
               ave_epsipsi(j,i) = 0.d0
               ave_psipsi(j,i) = 0.d0
               ave_dedpsi(j,i) = 0.d0
            enddo
         enddo

         nacc = 0

         do inb=1,nb
            call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
            call fermion_det(mup,mdown,det)
            do ins=1,ns
               call metropolis(mup,mdown,npos,epos,centers,rotmat,vp,
     >                         det,nac)
               nacc = nacc + nac
            enddo
            do i=1,nvp
               grad1(i) = 0.d0
            enddo
c            call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
c            call fermion_det(mup,mdown,det)
            call compute_hessian(npos,epos,mup,mdown,centers,rotmat,
     >                            vp,det,dr,en1,grad1,de,sderiv)

            ave_en = ave_en + en1 
            do i=1,nvp
               ave_psi(i) = ave_psi(i) + grad1(i) 
               ave_epsi(i) = ave_epsi(i) + en1*grad1(i) 
            enddo
            do i=1,nvp
               do j=1,nvp
                  ave_ddpsi(j,i) = ave_ddpsi(j,i) +sderiv(j,i)
                  ave_edpsi(j,i) = ave_edpsi(j,i) + en1*sderiv(j,i)
                  ave_epsipsi(j,i) = ave_epsipsi(j,i) + 
     >                                en1*grad1(j)*grad1(i)
                  ave_psipsi(j,i) = ave_psipsi(j,i) + grad1(j)*grad1(i)
                  ave_dedpsi(j,i) = ave_dedpsi(j,i) + de(i)*grad1(j)
                 
               enddo
            enddo
         enddo
         en = ave_en/nb
         do i=1,nvp
            grad(i) = 2.d0*(ave_epsi(i)-en*ave_psi(i))/nb
         enddo
c         print*,'energy = ',en

c         print*,'ave_edpsi',ave_edpsi(1,1)/nb
c         print*,'ave_ddpsi',ave_ddpsi(1,1)/nb
c         print*,'ave_epsipsi',ave_epsipsi(1,1)/nb
c         print*,'ave_psipsi',ave_psipsi(1,1)/nb
c         print*,'ave_dedpsi',ave_dedpsi(1,1)/nb


         
         do i=1,nvp
            do j=1,nvp
               hess(i,j) = 2*(ave_edpsi(i,j) - en*ave_ddpsi(i,j)
     >                      + 2*(ave_epsipsi(i,j) - en*ave_psipsi(i,j))
     >                      - grad(j)*ave_psi(i) - grad(i)*ave_psi(j)
     >                      + ave_dedpsi(i,j) )/nb
              
              if (.false.) then
                 print*,'h',i,j,2*ave_edpsi(i,j)/nb, 
     >           -2*en*ave_ddpsi(i,j)/nb,2*ave_epsipsi(i,j)/nb,
     >           -2*en*ave_psipsi(i,j)/nb,-grad(i)*ave_psi(i)/nb,
     >           -grad(i)*ave_psi(j)/nb, ave_dedpsi(i,j)/nb

              endif
            enddo
         enddo
c         do i=1,nvp
c            print*,'he',i,hess(i,i)
c         enddo

         end
          
