
c simple Pade form, for free space 
c  plus the Boys-Handy terms

       subroutine ee_jastrow(dist,vp,sum)
          implicit none
          include 'param.h'
          real*8 dist(nelec-1)
          real*8 vp(nvp)
          real*8 sum
          
          real*8  den,rbar,ee_c2
          integer i

          ee_b = sqrt(.5d0/vp(1))
c          ee_b = vp(1)
          ee_c2 = vp(2)
          sum = 0.d0
          do i=1,nelec-1
             den = 1.d0 + ee_b*dist(i)
             rbar = dist(i)/(1.d0 + dist(i))
             sum = sum + ee_a*dist(i)/den + ee_c2*rbar**2
          enddo
       end

       subroutine ee_jastrow_d(dist,vp,sum,sum_u2,du)
          implicit none
          include 'param.h'
          real*8 dist(nelec-1)
          real*8 vp(nvp)
          real*8 sum,sum_u2
          real*8 du(nelec-1)

          real*8  den,rbar,ee_c2
          integer i

          sum = 0.d0
          sum_u2 = 0.d0

          ee_b = sqrt(.5d0/vp(1))
c          ee_b = vp(1)
          ee_c2 = vp(2)
          do i=1,nelec-1
             den = 1.d0 + ee_b*dist(i)
             rbar = dist(i)/(1.d0 + dist(i))
             sum = sum + ee_a*dist(i)/den + ee_c2*rbar**2
             du(i) = ee_a/den**2 + 2*ee_c2*dist(i)/(1+dist(i))**3
             sum_u2 = sum_u2 - 2.d0*ee_a*ee_b/den**3 
     >                + 2*ee_c2*(1.d0 - 2.d0*dist(i))/(1.d0+dist(i))**4
          enddo

       end

       subroutine ee_jastrow_d_vp(dist,vp,sum,sum_delsqu,gradu,vp_deriv)
          implicit none
          include 'param.h'
          real*8 dist(nelec)
          real*8 vp(nvp)
          real*8 sum,sum_delsqu
          real*8 gradu(nelec-1)
          real*8 vp_deriv(nvp_ee)

          real*8  den,bd,rbar,ee_c2
          integer i

          sum = 0.d0
          sum_delsqu = 0.d0

          ee_b = sqrt(.5d0/vp(1))
          bd = - ee_b*.5d0/vp(1)
c          ee_b = vp(1)
          ee_c2 = vp(2)
          do i=1,nelec-1
             den = 1.d0 + ee_b*dist(i)
             rbar = dist(i)/(1.d0 + dist(i))
             sum = sum + ee_a*dist(i)/den + ee_c2*rbar**2
             gradu(i) = ee_a/den**2 + 2*ee_c2*dist(i)/(1+dist(i))**3
             sum_delsqu = sum_delsqu - 2.d0*ee_a*ee_b/den**3 
     >                + 2*ee_c2*(1.d0 - 2.d0*dist(i))/(1.d0+dist(i))**4
c with beta
             vp_deriv(1) = vp_deriv(1) - bd*ee_a*dist(i)**2/den**2
c using ee_b directly
c             vp_deriv(1) = vp_deriv(1) - ee_a*dist(i)**2/den**2 
             vp_deriv(2) = vp_deriv(2) + rbar**2
          enddo

       end

       subroutine en_jastrow(dist,vp,sum)
          implicit none
          include 'param.h'
          real*8 dist(nelec)
          real*8 vp(nvp)
          real*8 sum
          
          real*8  den,rbar,en_c2
          integer i

          en_b = sqrt(1.d0/vp(1))
          en_c2 = vp(3)
c          en_b = vp(ien)
c          en_c2 = vp(ien+1)

          sum = 0.d0
          do i=1,nnuclei
             den = 1.d0 + en_b*dist(i)
             rbar = dist(i)/(1.d0 + dist(i))
             sum = sum + en_a*dist(i)/den + en_c2*rbar**2
          enddo
       end

       subroutine en_jastrow_d(dist,vp,sum,sum_u2,du)
          implicit none
          include 'param.h'
          real*8 dist(nelec)
          real*8 vp(nvp)
          real*8 sum,sum_u2
          real*8 du(nnuclei)

          real*8  den,rbar,en_c2
          integer i

          sum = 0.d0
          sum_u2 = 0.d0

          en_b = sqrt(1.d0/vp(1))
          en_c2 = vp(3)
c          en_b = vp(ien)
c          en_c2 = vp(ien+1)
          do i=1,nnuclei
             den = 1.d0 + en_b*dist(i)
             rbar = dist(i)/(1.d0 + dist(i))
             sum = sum + en_a*dist(i)/den + en_c2*rbar**2
             du(i) = en_a/den**2
     >                    + 2*en_c2*dist(i)/(1+dist(i))**3
             sum_u2 = sum_u2 - 2.d0*en_a*en_b/den**3
     >                + 2*en_c2*(1.d0 - 2.d0*dist(i))/(1.d0+dist(i))**4
          enddo

       end

       subroutine en_jastrow_d_vp(dist,vp,sum,sum_delsqu,gradu,vp_deriv)
          implicit none
          include 'param.h'
          real*8 dist(nelec)
          real*8 vp(nvp)
          real*8 sum,sum_delsqu
          real*8 gradu(nelec-1)
          real*8 vp_deriv(nvp_ee)

          real*8  den,bd,rbar,en_c2
          integer i

          sum = 0.d0
          sum_delsqu = 0.d0

          en_b = sqrt(1.d0/vp(1))
          bd = - en_b*.5d0/vp(1)
          en_c2 = vp(3)
 
c          en_b = vp(ien)
c          en_c2 = vp(ien+1)

          do i=1,nnuclei
             den = 1.d0 + en_b*dist(i)
             rbar = dist(i)/(1.d0 + dist(i))
             sum = sum + en_a*dist(i)/den + en_c2*rbar**2
             gradu(i) = en_a/den**2
     >                    + 2*en_c2*dist(i)/(1+dist(i))**3
             sum_delsqu = sum_delsqu - 2.d0*en_a*en_b/den**3
     >                + 2*en_c2*(1.d0 - 2.d0*dist(i))/(1.d0+dist(i))**4
c with beta
             vp_deriv(1) = vp_deriv(1) - bd*en_a*dist(i)**2/den**2
c using b directly
c             vp_deriv(1) = vp_deriv(1) - en_a*dist(i)**2/den**2
             vp_deriv(2) = vp_deriv(2) + rbar**2
          enddo
       end

