
c Kolos-Wolniewicz intra molecular potential, JCP 41,3363

      subroutine kolos_single_pot(bond,pot)
         implicit none
         include 'param.h'

         real*8 bond,pot
         integer npts,j,indx
         parameter (npts = 34)
         real*8 rgrid(npts),vgrid(npts)
         real*8 r,dr
         parameter (dr=0.1d0)

         data (rgrid(j),j=1,6)/0.40, 0.50, 0.60, 0.70, 0.80, 0.90/
         data (rgrid(j),j=7,12)/1.00, 1.10, 1.20, 1.30, 1.40, 1.50/
         data (rgrid(j),j=13,18)/1.60, 1.70, 1.80, 1.90, 2.00, 2.10/
         data (rgrid(j),j=19,24)/2.20, 2.30, 2.40, 2.50, 2.60, 2.70/
         data (rgrid(j),j=25,30)/2.80, 2.90, 3.00, 3.10, 3.20, 3.30/
         data (rgrid(j),j=31,34)/3.40, 3.50, 3.60, 3.70/

         data (vgrid(j),j=1,3)/-0.1202028, -0.5266270, -0.7696253/
         data (vgrid(j),j=4,6)/-0.9220185, -1.0200487, -1.0836362/
         data (vgrid(j),j=7,9)/-1.1245331, -1.1500512, -1.1649294/
         data (vgrid(j),j=10,12)/-1.1723414, -1.1744699, -1.1728492/
         data (vgrid(j),j=13,15)/-1.1685773, -1.1624521, -1.1550616/
         data (vgrid(j),j=16,18)/-1.1468425, -1.1381236, -1.1291528/
         data (vgrid(j),j=19,21)/-1.1201190, -1.1111659, -1.1024035/
         data (vgrid(j),j=22,24)/-1.0939149, -1.0857627, -1.0779927/
         data (vgrid(j),j=25,27)/-1.0706404, -1.0637259, -1.0572607/
         data (vgrid(j),j=28,30)/-1.0512547, -1.0457057, -1.0406020/
         data (vgrid(j),j=31,33)/-1.0359419, -1.0318402, -1.0278471/
         data (vgrid(j),j=34,34)/-1.0243742/

         r = bond
         if (bond.lt.rgrid(1)) then
            r= rgrid(1)
         endif
         if (bond.ge.rgrid(npts)) then
            r= rgrid(npts)-.0001d0
         endif
         indx = int((r-rgrid(1))/dr) + 1
         pot = (vgrid(indx+1)-vgrid(indx))*(r-rgrid(indx))/dr 
     >            +  vgrid(indx) 
      
      end

      subroutine kolos_pot(npos,pot)
         implicit none
         include 'param.h'

         real*8 npos(ndim,nnuclei)
         real*8 pot
         integer i,np,j
         real*8 r,v1(3),p

         pot = 0.d0
         do np=1,npair
            call box_dist(npos(1,2*np-1),npos(1,2*np),r,v1)
            call kolos_single_pot(r,p)
            pot = pot + p
         enddo
         
      end 
