

      subroutine metropolis(mup,mdown,npos,epos,centers,rotmat,vp,det,
     >                      nacc)
         implicit none
         include 'param.h'
         real*8 mup(nup,nup),mdown(ndown,ndown)
         real*8 epos(ndim,nelec),npos(ndim,nelec)
         real*8 centers(ndim,ncenter),rotmat(ndim,ndim,npair),vp(nvp)
         real*8 det

         real*8 rng
         external rng

         integer ntry,nacc,ndetacc
         integer np,i
         real*8 rnew(ndim),rtmp(ndim)
         real*8 det_ratio,wv_ratio,prob,ran

         real*4 etime,tme1,tme2,tme(2)
         real*4 tb_tme,sb_tme
         external etime
         save tb_tme,sb_tme
         data tb_tme/0.0/,sb_tme/0.0/
         
         real*8 rdist
         integer indx

         


         ntry = 0
         nacc = 0
         ndetacc = 0


         do np=1,nelec
            ntry = ntry + 1
            do i=1,ndim
               rtmp(i) = epos(i,np) + delta*(rng()-.5d0)
            enddo
            

c  histogram of AR vs delta
            if (.false.) then
            rdist = 0.d0
            do i=1,ndim
               rdist = rdist + (rtmp(i)-epos(i,np)+0.5d0*delta)**2
            enddo
            rdist = sqrt(rdist)
            indx = int(nhist_acc*rdist/(delta*2.d0)) + 1
            if (indx.gt.nhist_acc) indx=nhist_acc
            if (indx.lt.1) indx=1
            acc_norm(indx) = acc_norm(indx) + 1
            endif
            
            call box_move(rtmp,rnew)

c            tme1 = etime(tme)

            call fermion_det_ratio(mup,mdown,np,rnew,det_ratio,centers,
     >                             rotmat,vp)

c  twolevel sampling
            prob = det_ratio**2
            if (prob.lt.1.d0) then
                ran = rng()
                if (prob.lt.ran) goto 20
            endif

            ndetacc = ndetacc + 1
            call psi_oldnew(np,rnew,npos,epos,vp,wv_ratio)

c            tme2 = etime(tme)
c            tb_tme = tb_tme + tme2-tme1



c            tme1 = etime(tme)
c            sb_tme = sb_tme + tme1-tme2
c            print*,'wv,det',wv_ratio,det_ratio

c regular
c            prob = wv_ratio*(det_ratio**2)
c with prerejection
            prob = wv_ratio


            if (prob.lt.1.d0) then
                ran = rng()
                if (prob.lt.ran) goto 20
            endif

            if (.false.) then
            acc_hits(indx) = acc_hits(indx) + 1
            endif
            do i=1,ndim
               epos(i,np) = rnew(i)
            enddo
            call fermion_inv_update(mup,mdown,np,rnew,centers,rotmat,vp,
     >                              det_ratio)
            nacc = nacc + 1
            det = det * det_ratio

20          continue  
         enddo

c         print*,'sb time',sb_tme, 'tb time',tb_tme
c          print*,'ntry',ntry,'  ndetacc',ndetacc,'   nacc',nacc
 

      end
