
! optimize using full Newton method with classical regularization
      subroutine newton(nsteps,nblocks,nerrblocks,itmax,
     >                    npos1,epos1,mup1,mdown1,centers1,rotmat1,vp1,
     >                    scale)

      implicit none
      include 'param.h'
      integer nsteps,nerrblocks,nblocks,itmax
      real*8 epos1(ndim,nelec),npos1(ndim,nnuclei)
      real*8 mup1(nup,nup),mdown1(ndown,ndown)
      real*8 centers1(ndim,ncenter),rotmat1(ndim,ndim,npair),vp1(nvp)
      real*8 scale(nvp)

      real*8 epos2(ndim,nelec)
      real*8 mup2(nup,nup),mdown2(ndown,ndown)

      real*8 sum_b(nvp),ssq_b(nvp),b(nvp),err_b(nvp),newvp(nvp)
      real*8 en,v,dr,r,ed,err,e1,err1,e2,err2,ke,kerr,pe,perr
      real*8 gs,norm_b,nm_rel_b,sum_en,ssq_en,nuc_e
      real*8 rstep(nvp),old_b(nvp),tsvd(nvp),db(nvp)
      real*8 hess(nvp,nvp),sum_h(nvp,nvp),ssq_h(nvp,nvp),err_h(nvp,nvp)
      real*8 junk,eval(nvp),evec(nvp,nvp),tol,sval(nvp),dot
c      real*8 l_svd(nvp,nvp),r_svd(nvp,nvp)
      integer i,j,neb,its,nac1,nac2,n_min_acc,ivp,igs_count(nvp)
      integer ipiv(nvp),lwork,info,ijunk,iwork(5*nvp)
      parameter (lwork = 8*nvp + nvp*(nvp+4) + 1)
      real*8 work(lwork)

      real*4 etime,tme1(2),tme2(2),tme,grad_time,de_time
      external etime
      real*8 rng
      external rng
      logical do_energy_diff

      dr = 1.0d-6
      gs = 1.d0
      do_energy_diff = .false.

      n_min_acc = 0

      do i=1,nelec
         do j=1,ndim
            epos2(j,i) = epos1(j,i)
         enddo
      enddo
 
      call total_nuclear_potential(npos1,nuc_e)

      grad_time = 0.0
      de_time = 0.0
      ivp = 0

 

      do its=1,itmax


c  compute gradient,hessian, and their errors
         do i=1,nvp
            sum_b(i) = 0.d0 
            ssq_b(i) = 0.d0 
         enddo
         do i=1,nvp
            do j=1,nvp
               sum_h(j,i) = 0.d0 
               ssq_h(j,i) = 0.d0 
            enddo
         enddo
         sum_en = 0.d0
         ssq_en = 0.d0
         tme = etime(tme1)
         do neb=1,nerrblocks
            call estimate_hessian(npos1,epos1,mup1,mdown1,centers1,
     >             rotmat1,vp1,dr,nsteps,nblocks,en,b,hess)
            do i=1,nvp
               sum_b(i) = sum_b(i) + b(i)
               ssq_b(i) = ssq_b(i) + b(i)**2
            enddo
            sum_en = sum_en + en
            ssq_en = ssq_en + en*en
            do i=1,nvp
               do j=1,nvp
               sum_h(j,i) = sum_h(j,i) + hess(j,i)
               ssq_h(j,i) = ssq_h(j,i) + hess(j,i)**2
               enddo
            enddo
         enddo
         do i=1,nvp
            b(i) =  sum_b(i)/nerrblocks
            v = ssq_b(i)/nerrblocks - b(i)*b(i)
            if (nerrblocks.gt.1) err_b(i) = sqrt(v/(nerrblocks-1))
         enddo
         do i=1,nvp
            do j=1,nvp
               hess(j,i) =  sum_h(j,i)/nerrblocks
               v = ssq_h(j,i)/nerrblocks - hess(j,i)*hess(j,i)
               if (nerrblocks.gt.1) err_h(j,i) = sqrt(v/(nerrblocks-1))
            enddo
         enddo
         tme = etime(tme2)
         grad_time = grad_time + tme2(1)-tme1(1)

         en = sum_en/nerrblocks
         v = ssq_en/nerrblocks - en*en
         if (nerrblocks.gt.1) err1 = sqrt(v/(nerrblocks-1))
         write(*,*) 'ave e',en+nuc_e,err1

         norm_b = 0.d0
         nm_rel_b = 0.d0
         do i=1,nvp
           if (scale(i).ne.0.d0) then
            norm_b = norm_b + abs(b(i))
            nm_rel_b = nm_rel_b + abs(b(i)/err_b(i))
            write(17,'(i4,3e20.10)') i,b(i),err_b(i),
     >                abs(b(i)/err_b(i))
           endif 
         enddo
         write(*,*) 'grad norm',norm_b/nvp,nm_rel_b/nvp

           
      do i=1,nelec
         do j=1,ndim
            epos2(j,i) = epos1(j,i)
         enddo
      enddo

      do i=1,nvp
         print*,'b',i,b(i),err_b(i)
      enddo
      do i=1,nvp
         print*,'hess',i,hess(i,i),err_h(i,i)
      enddo
c  Do regularization here
 

c  Solve Newton equations in usual manner (Ax=-b)
      do i=1,nvp
         b(i) = -b(i)
      enddo

c      call dsysv('L',nvp,1,hess,nvp,ipiv,b,nvp,work,lwork,info)
c      if (info.ne.0) print*,'dsysv info = ',info

c  compute eigenvalues/singular values

      tol = 1.0d-8
      call dsyevx('V','A','L',nvp,hess,nvp,junk,junk,ijunk,ijunk,tol,
     >           i,eval,evec,nvp,work,lwork,iwork,ipiv,info)
      if (info.ne.0) print*,'dsysvx info = ',info

      do i=1,nvp
         print*,'eval ',i,eval(i)
      enddo

c  zero out small and negative eigenvalues

      tol = 1.0d-4
      do i=1,nvp
         if (eval(i).lt.tol) then
            sval(i) = 0.d0
         else
            sval(i) = 1.d0/eval(i)
         endif
      enddo

c  put the inverse back together and solve
 
      do i=1,nvp
         dot = 0.d0
         do j=1,nvp
            dot =  dot +  evec(j,i)*b(j)
         enddo
         tsvd(i) = sval(i)*dot
      enddo

      do i=1,nvp
         dot = 0.d0
         do j=1,nvp
            dot = dot + evec(i,j)*tsvd(j)
         enddo
         db(i) = dot
      enddo

c  update VP's
      do i=1,nvp
c         vp1(i) = vp1(i) + b(i)
         vp1(i) = vp1(i) + db(i)
      enddo
     


c  compute energy difference
       if (do_energy_diff) then
         tme = etime(tme1)
         call ts_diff(nsteps,nerrblocks,
     >                 npos1,epos1,centers1,rotmat1,newvp,mup1,mdown1,
     >                 nac1,
     >                 npos1,epos2,centers1,rotmat1,vp1,mup2,mdown2,
     >                 nac2,
     >                 ed,err,e1,err1,e2,err2,
     >                 ke,kerr,pe,perr)
         tme = etime(tme2)

         write(*,*) 'ts ediff',ed,err
         write(*,'(''ts brute'',f12.6,e12.4,f12.6,3e12.4)') 
     >             e1,err1,e2,err2,e1-e2,sqrt(err1**2+err2**2)
         de_time = de_time + tme2(1)-tme1(1)
        endif ! do_energy_diff


         do i=1,nvp
            write(16,*) i,vp1(i)
         enddo
         write(16,*)

c         do i=1,nvp
c            write(22,*) i,scale(i)
c         enddo
c         write(22,*)

         call flush(6)
c         call flush(22)
c         call flush(16)
         write(17,*)
      enddo !itmax

c      write(*,*) 'min acc ratio',real(n_min_acc)/itmax

      write(*,*) 'grad time',grad_time/itmax,' de time',de_time/itmax


      end
