
      subroutine optimize(nsteps,nblocks,nerrblocks,itmax,
     >                    npos1,epos1,mup1,mdown1,centers1,rotmat1,vp1,
     >                    scale)

      implicit none
      include 'param.h'
      integer nsteps,nerrblocks,nblocks,itmax
      real*8 epos1(ndim,nelec),npos1(ndim,nnuclei)
      real*8 mup1(nup,nup),mdown1(ndown,ndown)
      real*8 centers1(ndim,ncenter),rotmat1(ndim,ndim,npair),vp1(nvp)
      real*8 scale(nvp)

      real*8 epos2(ndim,nelec)
      real*8 mup2(nup,nup),mdown2(ndown,ndown)

      real*8 sum_b(nvp),ssq_b(nvp),b(nvp),err_b(nvp),newvp(nvp)
      real*8 en,v,dr,r,ed,err,e1,err1,e2,err2,ke,kerr,pe,perr
      real*8 gs,norm_b,nm_rel_b,sum_en,ssq_en,nuc_e
      real*8 rstep(nvp),old_b(nvp)
      integer i,j,neb,its,nac1,nac2,n_min_acc,ivp,igs_count(nvp)

      real*4 etime,tme1(2),tme2(2),tme,grad_time,de_time
      external etime
      real*8 rng
      external rng
      logical do_grad,do_sga,do_sga_accel

      dr = 1.0d-3
      gs = 1.d0
c compute gradient (needed for sga)
c if false, does random walk 
      do_grad = .true.
c sga or gradient biased random walk
      do_sga = .false.
      do_sga_accel = .true.

      n_min_acc = 0

      do i=1,nelec
         do j=1,ndim
            epos2(j,i) = epos1(j,i)
         enddo
      enddo
 
      call total_nuclear_potential(npos1,nuc_e)

      grad_time = 0.0
      de_time = 0.0
      ivp = 0

      if (do_sga.and.do_sga_accel) then
      if (sga_in_chk_file.eq.'none') then
         do i=1,nvp
            igs_count(i) = 1
            old_b(i) = 0.d0
         enddo
      else
        open(22,file=sga_in_chk_file,status='OLD')
        do i=1,nvp
           read(22,*) old_b(i),igs_count(i)
        enddo
        close(22)
      endif
      endif
 

      do its=1,itmax


       if (do_grad) then
c  compute gradient and its error
         do i=1,nvp
            sum_b(i) = 0.d0 
            ssq_b(i) = 0.d0 
         enddo
         sum_en = 0.d0
         ssq_en = 0.d0
         tme = etime(tme1)
         do neb=1,nerrblocks
            call estimate_gradient(npos1,epos1,mup1,mdown1,centers1,
     >             rotmat1,vp1,dr,nsteps,nblocks,en,b)
            do i=1,nvp
               sum_b(i) = sum_b(i) + b(i)
               ssq_b(i) = ssq_b(i) + b(i)**2
            enddo
            sum_en = sum_en + en
            ssq_en = ssq_en + en*en
         enddo
         do i=1,nvp
            b(i) =  sum_b(i)/nerrblocks
            v = ssq_b(i)/nerrblocks - b(i)*b(i)
            if (nerrblocks.gt.1) err_b(i) = sqrt(v/(nerrblocks-1))
         enddo
         tme = etime(tme2)
         grad_time = grad_time + tme2(1)-tme1(1)

         en = sum_en/nerrblocks
         v = ssq_en/nerrblocks - en*en
         if (nerrblocks.gt.1) err1 = sqrt(v/(nerrblocks-1))
         write(*,*) 'ave e',en+nuc_e,err1

         norm_b = 0.d0
         nm_rel_b = 0.d0
         do i=1,nvp
           if (scale(i).ne.0.d0) then
c            print*,'b',i,b(i)
            norm_b = norm_b + abs(b(i))
            nm_rel_b = nm_rel_b + abs(b(i)/err_b(i))
            write(17,'(i4,3e20.10)') i,b(i),err_b(i),
     >                abs(b(i)/err_b(i))
           endif 
         enddo
         write(*,*) 'grad norm',norm_b/nvp,nm_rel_b/nvp

c  make a random, downhill-ish move

      if (do_sga) then
        if (.not.do_sga_accel) then 
         gs = 1.d0/sqrt(dble(istart+its))
c         gs = 1.d0/dble(istart+its)
         do i=1,nvp
            newvp(i) = vp1(i) - scale(i)*b(i)*gs
         enddo
        else  ! .not.do_sga_accel
         do i=1,nvp
           if (old_b(i)*b(i).le.0.d0) igs_count(i) = igs_count(i) + 1
         enddo
         print*,'igs count',igs_count(1)
         do i=1,nvp
            gs = 1.d0/dble(istart+igs_count(i))
            newvp(i) = vp1(i) - scale(i)*b(i)*gs
         enddo
         do i=1,nvp
            old_b(i) = b(i)
         enddo
       endif
      else
c         r = rng()
         do i=1,nvp
c            if (i.ge.13) then 
c               newvp(i) = vp1(i) - gs*scale(i)*b(i)*r
               newvp(i) = vp1(i) - gs*scale(i)*b(i)*rng()
c            else
c               newvp(i) = vp1(i)
c            endif
         enddo
      endif ! do_sga

      else  ! do_grad 
c just a random walk
         do i=1,nvp
            newvp(i) = vp1(i)
         enddo
c         do i=1,nvp
            ivp = ivp + 1
            if (ivp.gt.nvp) ivp  = 1  
            i = ivp
            rstep(i) = rng()-.5d0
            newvp(i) = vp1(i) + scale(i)*rstep(i)
c            newvp(i) = vp1(i) + gs*scale(i)*(rng()-0.5d0)
c         enddo
           
      endif  ! do_grad 

      do i=1,nelec
         do j=1,ndim
            epos2(j,i) = epos1(j,i)
         enddo
      enddo


c  compute energy difference
       if (.not.do_sga) then
         tme = etime(tme1)
         call ts_diff(nsteps,nerrblocks,
     >                 npos1,epos1,centers1,rotmat1,newvp,mup1,mdown1,
     >                 nac1,
     >                 npos1,epos2,centers1,rotmat1,vp1,mup2,mdown2,
     >                 nac2,
     >                 ed,err,e1,err1,e2,err2,
     >                 ke,kerr,pe,perr)
         tme = etime(tme2)

         write(*,*) 'ts ediff',ed,err
         write(*,'(''ts brute'',f12.6,e12.4,f12.6,3e12.4)') 
     >             e1,err1,e2,err2,e1-e2,sqrt(err1**2+err2**2)
         de_time = de_time + tme2(1)-tme1(1)
        endif

         if (do_sga) then
            do i=1,nvp
               vp1(i) = newvp(i)
            enddo
            n_min_acc = n_min_acc + 1
         else
c  accept/reject
         if (ed.lt.0.d0) then
            gs = gs/0.5d0
            write(*,*) '-------accept------',gs
c             print*,'i before',ivp,scale(ivp)
c            do i=1,nvp
c               if (abs(rstep(i)).gt.0.3d0) then
c                  scale(i) = scale(i)/0.5d0
c               endif
c            enddo
c            scale(ivp) = scale(ivp)/.5d0
            do i=1,nvp
               vp1(i) = newvp(i)
            enddo
            n_min_acc = n_min_acc + 1
c             print*,'i after',ivp,scale(ivp)
         else
            gs = gs*0.5d0
c            do i=1,nvp
c               if (abs(rstep(i)).gt.0.3d0) then
c                  scale(i) = scale(i)*0.5d0
c               endif
c            enddo
            write(*,*) '-------reject------',gs
c             print*,'i before',ivp,scale(ivp)
c             scale(ivp) = scale(ivp)*.5d0
c             print*,'i after',ivp,scale(ivp)
         endif

         endif ! do_sga

         do i=1,nvp
            write(16,*) i,vp1(i)
         enddo
         write(16,*)

c         do i=1,nvp
c            write(22,*) i,scale(i)
c         enddo
c         write(22,*)

         call flush(6)
c         call flush(22)
c         call flush(16)
         write(17,*)
      enddo !itmax

      write(*,*) 'min acc ratio',real(n_min_acc)/itmax

      write(*,*) 'grad time',grad_time/itmax,' de time',de_time/itmax

      if (do_sga.and.do_sga_accel) then
         open(22,file=sga_out_chk_file)
         do i=1,nvp
            write(22,*) old_b(i),igs_count(i)
         enddo
         close(22)
      endif
    

 

      end
