
       subroutine orbital_init()
          print*,
     > '-- Periodic boundary conditions in hydrogen atomic orbitals '
       end
       subroutine orbital(dist3,centers,rotmat,vp,ob,ispin)
          implicit none 
          include 'param.h'
          
          real*8 dist3(ndim)
c change def of centers to be ndim,ncenter .  In this file the centers are
c the atomic postitions
          real*8 centers(ndim,ncenter)
          real*8 rotmat(ndim,ndim,npair),vp(nvp)
          real*8 ob(npair)
          integer ispin

          real*8 tv(npair),tv3(ndim,npair)

          integer i,j,ib
          real*8 arg
          real*8 g11,g33,cd,aa,newr(3)
          real*8 gc,fc,fcexp,rm


          gc = 1.d0/vp(nvp_per*npair+id)**2
          call orb_dist(centers(1,(ispin-1)*npair+1),dist3,tv,tv3)
c          call en_dist(centers,dist3,tv,tv3)
          rm = 0.5d0*box_len


          do i=1,npair
             if (tv(i).lt.rm) then
                ib = id + nvp_per*(i-1)
                g11 = 1.d0/vp(ib)**2
                arg = g11*tv(i)

                fcexp = exp(-gc*(tv(i)-rm)**2)
                fc = 1.d0-fcexp
                ob(i) = exp(-arg)*fc
             else
                ob(i) = 0.d0
             endif

             
             
          enddo
          
       end

       subroutine orbital_d(dist3,centers,rotmat,vp,ob,ob_d,ob_dd,ispin)
          implicit none 
          include 'param.h'
          
          real*8 dist3(ndim)
          real*8 centers(ndim,ncenter)
          real*8 rotmat(ndim,ndim,npair),vp(nvp)
          real*8 ob(npair),ob_d(ndim,npair),ob_dd(npair)
          integer ispin
          real*8 tv(npair),tv3(ndim,npair)

          integer i,j,k,ib
          real*8 arg
          real*8 g11,g33,cd,aa,newr(3),gam(3)
          real*8 gc,fc,fcexp,rm,fcp,fcpp
          real*8 ga(3),gaga,gagb,grada(3),dot,dela


          gc = 1.d0/vp(nvp_per*npair+id)**2
          call orb_dist(centers(1,(ispin-1)*npair+1),dist3,tv,tv3)
c          call en_dist(centers,dist3,tv,tv3)
          rm = 0.5d0*box_len

          do i=1,npair
             if (tv(i).lt.rm) then
                ib = id + nvp_per*(i-1)
                g11 = 1.d0/vp(ib)**2

                arg = g11*tv(i)
                fcexp = exp(-gc*(tv(i)-rm)**2)
                fc = 1.d0-fcexp

                ob(i) = exp(-arg)*fc


                fcp = 2*gc*(tv(i)-rm)*fcexp
                fcpp = gc*(6.d0-4*gc*(tv(i)-rm)**2 - 4*rm/tv(i))*fcexp



                do j=1,ndim
                   grada(j) = -g11*tv3(j,i)*exp(-arg)/tv(i)
                enddo

                dela = (g11**2 - 2*g11/tv(i))*exp(-arg) 

                dot = grada(1)*tv3(1,i) + grada(2)*tv3(2,i) + 
     >                 grada(3)*tv3(3,i)

                ob_dd(i) = dela*fc + exp(-arg)*fcpp + 
     >                   2*fcp*dot/tv(i)

                do j=1,ndim
                  ob_d(j,i) = grada(j)*fc + 
     >                        exp(-arg)*fcp*tv3(j,i)/tv(i)
                enddo



             else
                ob(i) = 0.d0
                ob_dd(i) = 0.d0
                ob_d(1,i) = 0.d0
                ob_d(2,i) = 0.d0
                ob_d(3,i) = 0.d0
             endif
          enddo
          
       end

       subroutine set_centers(npos,centers,rotmat)
          implicit none 
          include 'param.h'
          real*8 npos(ndim,nnuclei)
          real*8 centers(ndim,ncenter)
          real*8 rotmat(ndim,ndim,npair)

          integer i,j,k
          real*8 tmp(3),td,tmp2(3)


          do i=1,npair
             do j=1,ndim
                centers(j,i) = npos(j,2*i-1)
                centers(j,i+npair) = npos(j,2*i)
             enddo
          enddo

    
       end

c compute 1st derivative terms (wrt vp's)
       subroutine orbital_vp(np,idx,dist3,center,rotmat,vp,vp_deriv,
     >                       ispin)
          implicit none 
          include 'param.h'
          
          integer np,idx
          real*8 dist3(ndim,np)
          real*8 center(ndim)
          real*8 rotmat(ndim,ndim,npair),vp(nvp)
          real*8 vp_deriv(npair,nvp_per)
          integer ispin
          real*8 tv(npair),tv3(ndim,npair)
           

          integer i,j,ib
          real*8 arg
          real*8 g11,g33,cd,aa,newr(3)
          real*8 gc,fc,fcexp,rm,ob


          gc = 1.d0/vp(nvp_per*npair+id)**2
          call orb_dist(dist3,center,tv,tv3)
c          call en_dist(dist3,center,tv,tv3)
          rm = 0.5d0*box_len
          ib = id + nvp_per*(idx-1)
          g11 = 1.d0/vp(ib)**2

          do i=1,np
             if (tv(i).lt.rm) then
 
                arg = g11*tv(i)
                fcexp = exp(-gc*(tv(i)-rm)**2)
                fc = 1.d0-fcexp
                ob = exp(-arg)*fc
                vp_deriv(i,1) = -tv(i)*ob 
             else
                vp_deriv(i,1) = 0.d0
             endif
             
          enddo
          
       end

c also compute diagonal 2nd derivative term
       subroutine orbital_vp_diag(np,idx,dist3,center,rotmat,vp,
     >                            vp_deriv,ispin)
          implicit none 
          include 'param.h'
          
          integer np,idx
          real*8 dist3(ndim,np)
          real*8 center(ndim)
          real*8 rotmat(ndim,ndim,npair),vp(nvp)
          real*8 vp_deriv(npair,nvp_per)
          integer ispin
          real*8 tv(npair),tv3(ndim,npair)
           

          integer i,j,ib
          real*8 arg
          real*8 g11,g33,cd,aa,newr(3)
          real*8 gc,fc,fcexp,rm,ob


          gc = 1.d0/vp(nvp_per*npair+id)**2
          call orb_dist(dist3,center,tv,tv3)
c          call en_dist(dist3,center,tv,tv3)
          rm = 0.5d0*box_len
          ib = id + nvp_per*(idx-1)
          g11 = 1.d0/vp(ib)**2

          do i=1,np
             if (tv(i).lt.rm) then
 
                arg = g11*tv(i)
                fcexp = exp(-gc*(tv(i)-rm)**2)
                fc = 1.d0-fcexp
                ob = exp(-arg)*fc
                vp_deriv(i,1) =  tv(i)**2*ob 
             else
                vp_deriv(i,1) = 0.d0
             endif
             
          enddo
          
       end
