
c parameters that determine the size of matrices and vectors

      integer ndim
      parameter (ndim=3)

c number of H_2 molecules
      integer npair
      parameter (npair=7)

c number of electrons
      integer nelec
      parameter (nelec=2*npair)

c number of nuclei
      integer nnuclei
      parameter (nnuclei=2*npair)

c number of up and down spin electrons
      integer nup,ndown,nspinmax
      parameter (nup=npair,ndown=npair,nspinmax=npair)

c nuclear positions, centers, etc for orbitals
      integer ncenter
      parameter (ncenter = npair)



c physical parameters
c      real*8 box_len 
c      parameter (box_len = 3.d0)


c quantity of variational parameters
      integer n_chby,n_chby_max
      parameter (n_chby = 5,n_chby_max=5)
c      parameter (n_chby = 0,n_chby_max=5)
      integer nvp,nvp_ee,nvp_en,nvp_d,nvp_per
c nvp - total number of variational parameters
c nvp_ee - # of electron-electron parameters
c nvp_en - # of electron-nuclear parameters
c nvp_per - # of parameters for each molecule
c nvp_d - total # of orbital parameters

c ----------------------------------------------
c  with cubic and Tschyshev polys
      parameter(nvp_ee=n_chby+1,nvp_en=n_chby+1)
c ----------------------------------------------

c ----------------------------------------------
c with simple jastrow + Boys-Handy terms
c  also orbitals for an isolated H_2.
c      parameter(nvp_ee=2,nvp_en=2,nvp_per=3)
c ----------------------------------------------


c ----------------------------------------------
c  FSG (H_2) molecular orbitals
      parameter (nvp_per=3)
c periodic BC's
      parameter(nvp_d = nvp_per*npair + 1, nvp = nvp_ee+nvp_en+nvp_d)
c free BC's
c      parameter(nvp_d = nvp_per*npair, nvp = nvp_ee+nvp_en+nvp_d)
c ----------------------------------------------

c ----------------------------------------------
c atomic orbitals in box
c      parameter (nvp_per=1)
c      parameter(nvp_d = nvp_per*npair + 1, nvp = nvp_ee+nvp_en+nvp_d)
c ----------------------------------------------

      integer ien,id
      parameter (ien = nvp_ee+1, id = nvp_ee + nvp_en+1)
      

     

c simulation parameters

c      real*8 delta
c      parameter (delta=1.d0)

       real*8 rs,box_len,pi,density,recip_box_len,box_vol
       real*8 delta,cm_delta,theta_max,scale_max
        
c       real*8 vp(nvp)

       real*8 ee_a,ee_b,en_a,en_b
       common /var_param/ ee_a,ee_b,en_a,en_b
       common /box_param/ rs,box_len,pi,density,recip_box_len,box_vol
       common /sim_param/ delta
       common /cm_sim_param/ cm_delta,theta_max,scale_max

       logical pme
       common /printme/ pme
       integer istart
       common /sga/ istart

       real*4 det_time,jas_time
       common /timing/det_time,jas_time

c  optimization parameters
       character*40 sga_in_chk_file,sga_out_chk_file
       common /sga_file/ sga_in_chk_file, sga_out_chk_file

       integer nhist_acc
       parameter (nhist_acc=100)
       integer acc_norm(nhist_acc),acc_hits(nhist_acc)
       common /ar_hist/ acc_norm,acc_hits

       integer myrank,nproc
       logical root
       common /par_common/ myrank,nproc,root
