
c compute energy difference between different vp's or nuclear positions
c  using two-sided method

      subroutine ts_diff(nsteps,nerrblocks,
     >                npos1,epos1,centers1,rotmat1,vp1,mup1,mdown1,nac1,
     >                npos2,epos2,centers2,rotmat2,vp2,mup2,mdown2,nac2,
     >                ed,err,e1,err1,e2,err2,
     >                ke2,ke_err2,pe2,pe_err2)
         implicit none
         include 'param.h'
         integer nsteps,nerrblocks,nblocks
         parameter (nblocks=320)
         real*8 mup1(nup,nup),mdown1(ndown,ndown)
         real*8 epos1(ndim,nelec),npos1(ndim,nelec)
         real*8 centers1(ndim,ncenter)
         real*8 rotmat1(ndim,ndim,npair),vp1(nvp)
         real*8 mup2(nup,nup),mdown2(ndown,ndown)
         real*8 epos2(ndim,nelec),npos2(ndim,nelec)
         real*8 centers2(ndim,ncenter)
         real*8 rotmat2(ndim,ndim,npair),vp2(nvp)
         integer nac1,nac2
         real*8 ed,err,e1,err1,e2,err2
         real*8 ke2,ke_err2,pe2,pe_err2
         real*8 tke1,tpe1,tke2,tpe2,lpsi,det1,det2
         real*8 arg_x,arg_y

         real*8 lpsi_x1(nblocks),lpsi_x2(nblocks)  ! log of psi squared
         real*8 lpsi_y1(nblocks),lpsi_y2(nblocks)
         real*8 en_x1(nblocks),en_x2(nblocks)
         real*8 en_y1(nblocks),en_y2(nblocks)
         real*8 wt_x(nblocks),wt_y(nblocks)
         integer novfl_x,novfl_y
         logical ovfl_x(nblocks),ovfl_y(nblocks),ovfl 
      
         real*8 norm1,norm2

         real*8 rng
         external rng

         integer ns,nb,n1,n2,neb,it
         real*8 en1,en2
         real*8 nuc_e1,nuc_e2

         real*8 sum_e1,sum_e2,ssq_e1,ssq_e2,v1,v2
         real*8 a,b,q,en3,en4,te1
         real*8 sum_tse,ssq_tse,tv


         call total_nuclear_potential(npos1,nuc_e1)
         call total_nuclear_potential(npos2,nuc_e2)
         sum_tse = 0.d0
         ssq_tse = 0.d0
         sum_e1 = 0.d0
         ssq_e1 = 0.d0
         sum_e2 = 0.d0
         ssq_e2 = 0.d0

         do neb=1,nerrblocks

            norm1 = 0.d0
            norm2 = 0.d0

            call fermion_fill(mup2,mdown2,centers2,rotmat2,vp2,epos2)
            call fermion_det(mup2,mdown2,det2)
            do nb=1,nblocks
               do ns=1,nsteps
                  call metropolis(mup2,mdown2,npos2,epos2,centers2,
     >                            rotmat2,vp2,det2,n2)
                  nac2 = nac2 + n2
               enddo
               call local_energy(npos2,epos2,mup2,mdown2,centers2,
     >                           rotmat2,vp2,en2,tke2,tpe2,lpsi)
               en_y2(nb) = en2 + nuc_e2
               lpsi_y2(nb) = -lpsi + 2.d0*log(abs(det2))
               norm2 = norm2 + lpsi_y2(nb)

               call fermion_fill(mup1,mdown1,centers1,rotmat1,vp1,epos2)
               call fermion_det(mup1,mdown1,det1)
               call local_energy(npos1,epos2,mup1,mdown1,centers1,
     >                           rotmat1,vp1,en1,tke1,tpe1,lpsi)
               en_y1(nb) = en1 + nuc_e1
               lpsi_y1(nb) = -lpsi + 2.d0*log(abs(det1))

               sum_e2 = sum_e2 + en2
               ssq_e2 = ssq_e2 + en2*en2
            enddo

            call fermion_fill(mup1,mdown1,centers1,rotmat1,vp1,epos1)
            call fermion_det(mup1,mdown1,det1)
            do nb=1,nblocks
               do ns=1,nsteps
                  call metropolis(mup1,mdown1,npos1,epos1,centers1,
     >                            rotmat1,vp1,det1,n1)
                  nac1 = nac1 + n1
               enddo
               call local_energy(npos1,epos1,mup1,mdown1,centers1,
     >                           rotmat1,vp1,en1,tke1,tpe1,lpsi)
               en_x1(nb) = en1 + nuc_e1
               lpsi_x1(nb) = -lpsi + 2.d0*log(abs(det1)) 
               norm1 = norm1 + lpsi_x1(nb)

               call fermion_fill(mup2,mdown2,centers2,rotmat2,vp2,epos1)
               call fermion_det(mup2,mdown2,det2)
               call local_energy(npos2,epos1,mup2,mdown2,centers2,
     >                           rotmat2,vp2,en2,tke2,tpe2,lpsi)
               en_x2(nb) = en2 + nuc_e2
               lpsi_x2(nb) = -lpsi + 2.d0*log(abs(det2))

               sum_e1 = sum_e1 + en1
               ssq_e1 = ssq_e1 + en1*en1
            enddo

           novfl_x = 0
           novfl_y = 0
           norm2 = norm2/(nblocks)
           norm1 = norm1/(nblocks)
           ovfl = .false.
           do nb=1,nblocks
c              print*,'wt x',nb,lpsi_x1(nb)-lpsi_x2(nb)
c              print*,'wt y',nb,lpsi_y2(nb)-lpsi_y1(nb)
c              print*,'wt x',nb,lpsi_x1(nb)-lpsi_x2(nb)-norm1+norm2
c              print*,'wt y',nb,lpsi_y2(nb)-lpsi_y1(nb)+norm1-norm2
              ovfl_y(nb) = .false.
              ovfl_x(nb) = .false.
              arg_y = lpsi_y2(nb)-lpsi_y1(nb)+norm1-norm2
              arg_x = lpsi_x1(nb)-lpsi_x2(nb)-norm1+norm2
              if (arg_y.gt.709.7d0) then
                 ovfl_y(nb) = .true.
                 ovfl = .true.
                 novfl_y = novfl_y + 1
              endif
              if (arg_x.gt.709.7d0) then
                 ovfl_x(nb) = .true.
                 ovfl = .true.
                 novfl_x = novfl_x + 1
              endif
             
              wt_y(nb) = exp(lpsi_y2(nb)-lpsi_y1(nb)+norm1-norm2)
              wt_x(nb) = exp(lpsi_x1(nb)-lpsi_x2(nb)-norm1+norm2)
c              wt_y(nb) = exp(lpsi_y2(nb)-lpsi_y1(nb))
c              wt_x(nb) = exp(lpsi_x1(nb)-lpsi_x2(nb))
           enddo
           

c  Iterate Bennett's eqn to find Q
            if (.not.ovfl) then
            q = 1.d0
            do it=1,100
               a = 0.d0
               b = 0.d0
               do nb=1,nblocks
                  a = a + 1.d0/(1.d0 + wt_y(nb)*q)
                  b = b + 1.d0/(1.d0 + wt_x(nb)/q)
               enddo
               q = q*a/b
               if (abs(1.d0-a/b).lt.1.d-7) goto 10
            enddo
10          continue

            endif
c            print*,'it,q',it,q

c   Now compute energy difference
            if (.not.ovfl) then
             te1 = 0.d0
             do nb=1,nblocks
                en1 = wt_x(nb)*en_x1(nb)/(.5d0*(wt_x(nb) + q))
                en2 = en_x2(nb)/(.5d0*(wt_x(nb)/q + 1.d0))
                en3 = en_y1(nb)/(.5d0*(1.d0+q*wt_y(nb)))
                en4 = wt_y(nb)*en_y2(nb)/(.5d0*(1.d0/q + wt_y(nb)))
                te1 = te1 + en1-en2 + en3-en4
             enddo
 
            else
               te1 = 0.d0
               do nb=1,nblocks
                 te1 = te1 + 2.d0*(en_x1(nb)-en_y2(nb))
               enddo
            endif  ! .not.ovlf

            sum_tse = sum_tse + te1/(2.d0*nblocks)
            ssq_tse = ssq_tse + (te1/(2.d0*nblocks))**2

         enddo ! nerrblocks

         nb = nblocks*nerrblocks
         e1 = sum_e1/real(nb)
         e2 = sum_e2/real(nb) 

         v1 = ssq_e1/real(nb) - e1*e1
         v2 = ssq_e2/real(nb) - e2*e2

         if (nblocks.gt.1) then
            err1 = sqrt(abs(v1)/real(nb-1))
            err2 = sqrt(abs(v2)/real(nb-1))
         endif

         e1 = e1 + nuc_e1
         e2 = e2 + nuc_e2

         ed = sum_tse/real(nerrblocks)
         tv = ssq_tse/real(nerrblocks) - ed*ed
         if (nerrblocks.gt.1) then 
            err = sqrt(abs(tv)/real(nerrblocks-1))
         endif

c         ed = e1 - e2
c         err = sqrt(err1**2 + err2**2)


      end
