
c Main VMC program
c  go back and compute energies (and gradients?) for opt. runs
      implicit none
      include 'param.h'
      include 'configs.h'

c storage created here
      real*8 epos(ndim,nelec),npos(ndim,nnuclei)
      real*8 centers(ndim,ncenter),rotmat(ndim,ndim,npair)
      real*8 mup(nup,nup),mdown(ndown,ndown)
      real*8 vp(nvp)

      integer max_vp_set
      parameter (max_vp_set = 40000)
      real*8 vp_set(nvp,max_vp_set)
      real*8 ave_vp(nvp)


c local vars
      integer ns,j,np,nac,nacc,nb,i,neb,iphase,iskip
      integer nvpset,ivp
      real*8 det,en,nuc_pot,pt,dr
      real*8 sum_en,ke,pe,lpsi,ssq_en,var,err,ave1,err1
      real*8 tsum_ke,tsum_pe,sum_pr,ssq_pr,pr,sum_ke,sum_pe
      real*8 ssq_ke,ssq_pe
      real*8 xpos,ypos
      real*8 rng
      external rng
      real*8 tv(nnuclei),tv3(ndim,nnuclei),b(nvp),scale(nvp)
      real*8 beta,wk,sca,sb,tsum,pscale
      real*8 au_to_mbar
c simulation variables
      integer nsteps,iseed,nblocks,nerrblocks,itmax,vmc_nblocks
      integer vmc_nerrblocks,minit
      integer iminz
      character*40 vp_file,pos_file,vp_out_file
      character*40 vp_log_file,grad_log_file,junk

      logical do_min,do_grad,do_energy,do_rew
      real*4 tme,tme1(2),tme2(2),etime
      external etime
     
      au_to_mbar = 294.215d0

      pme = .false.
      do_min = .false.
      do_grad = .false.
      do_rew = .false.
      do_energy = .true.
      iseed = 102
c      print*,'iminimize  1-yes, 0-no 2-rew'
c      read*,iminz
      iminz =0
      if (iminz.eq.1) do_min = .true.
      if (iminz.eq.2) do_rew = .true.
      print*,'iseed'
      read*,iseed
      call easy_init_rng(iseed)

      print*,'nsteps'
      read*,nsteps
      print*,'nblocks'
      read*,nblocks
      print*,'vmc nblocks'
      read*,vmc_nblocks
      print*,'vmc nerrblocks'
      read*,vmc_nerrblocks
      pscale = 1.d0
c      print*,'pressure scale factor'
c      read*,pscale

c set vp's and sim parameters

      pi = 4.d0*atan(1.d0)
      rs = 3.d0
c      rs = 2.6465d0
c      rs = 1.66775
c      rs = 2.1d0
c      rs = 1.8d0
      density = 3.d0/(4.d0*pi*rs**3)
      box_len = ( (2*npair)/density)**(1.d0/3.d0)
      box_len = pscale*box_len
      density = density/pscale**3

c      print*,'*** box_len fixed for h_2 optimization ***'
c      box_len = 20.d0

      recip_box_len = 1.d0/box_len

      print*,'box_len = ',box_len

      call dist_init()   ! print free or periodic BC's
      call orbital_init()
    

      print*,'nvp = ',nvp

c      print*,'vp file'
c      read(5,'(a40)') vp_file

      print*,'vp log file'
      read(5,'(a40)') vp_log_file
c      open(16,file=vp_log_file,err=911)

      print*,'number of vp sets in log file'
      read*,nvpset
      if (nvpset.gt.max_vp_set) then
         print*,'*** nvpset .gt. max_vp_set',max_vp_set
         stop
      endif

      open(16,file=vp_log_file,status='OLD',err=911)
      do ivp=1,nvpset
         do i=1,nvp
            read(16,*) j,vp_set(i,ivp)
c            if (i.ne.j) then
c               print*,'error reading ',vp_log_file
c               print*,'set number = ',ivp
c               print*,'internal :',i,'  file: ',j
c            endif
         enddo
         read(16,'(a40)') junk
      enddo
      do i=1,nvp
         vp(i) =  vp_set(i,1)
      enddo

      print*,'energy results out file'
      read(5,'(a40)') vp_out_file
      open(20,file=vp_out_file,err=911)
c      do i=1,nvp
c         read(15,*) vp(i)
c      enddo
c      close(15)

c      print*,'grad log file'
c      read(5,'(a40)') grad_log_file
c      open(17,file=grad_log_file,err=911)

c some old stuff
      beta = 9.913d0
      ee_a = -.5d0
      ee_b = sqrt(.5d0/beta)
      en_a = 1.d0
      en_b = sqrt(1.d0/beta)

c ---------------


      print*,'scale factor'
      read*,sca
      do i=1,nvp
         scale(i) = sca
c         scale(i) = 0.d0
      enddo
      print*,'ien=',ien
c      scale(1) = sca
c      scale(ien) = sca
c      scale(13) = sca
c      scale(14) = sca
c      scale(15) = sca*.1d0
c      scale(1) = .4d0
c      scale(ien) = .4d0

   
      nerrblocks = 10
c      print*,'nerrblocks'
c      read*,nerrblocks
c      print*,'nerrblocks = ',nerrblocks
      print*,'iskip'
      read*,iskip
      print*,'iskip = ',iskip
      
      itmax = 2
c      print*,'itmax'
c      read*,itmax

c for SGA
      print*,'istart'
      read*,istart
      print*,'istart = ',istart

      print*,'iphase (1-instantaneous vp 2- average vp)'
      read*,iphase
      print*,'iphase = ',iphase

      if (do_rew) then
         minit = 10
         print*,'minit'
         read*,minit
      endif

      delta = 1.d0
      print*,'delta'
      read*,delta


 
c set up intial positions

c      xpos = 1.4d0
c      ypos = 1.4d0
c      do i=1,npair
c         do j=1,ndim
c           npos(j,2*i-1) = 0.d0
c           npos(j,2*i) = 0.d0
c         enddo
c      enddo
c      do j=1,npair
c         npos(1,2*j) = xpos
c         npos(2,2*j-1) = (j-1)*ypos
c         npos(2,2*j) = (j-1)*ypos
c      enddo
      print*,'nuc pos file'
      read(5,'(a40)') pos_file
      open(10,file=pos_file,status='OLD',err=911)
      do i=1,npair
          read(10,*) (npos(j,2*i-1),j=1,ndim)
          read(10,*) (npos(j,2*i),j=1,ndim)
      enddo
      close(10)
      do i=1,2*npair
         do j=1,ndim
            npos(j,i) = npos(j,i)*pscale
         enddo
      enddo
      

      if (do_rew) then
         print*,'etrial'
         read*,e_trial
         print*,'e_trial = ',e_trial
      endif

      call set_centers(npos,centers,rotmat)
 
c      print*,'center',centers(1,1),centers(2,1),centers(3,1)

      sb = 2.d0
      do np=1,npair
         do j=1,ndim
c            epos(j,np) = box_len*(rng()-.5d0)
            epos(j,np) = centers(j,np) + sb*(rng()-.5d0)
            epos(j,np+npair) = centers(j,np) + sb*(rng()-.5d0)
         enddo
      enddo
c      do j=1,ndim
c        epos(j,1) = 0.d0
c        epos(j,2) = 0.d0
c      enddo
c      epos(1,1) = 0.20d0
c      epos(2,2) = 0.50d0


      nuc_pot = 0.d0
      do j=1,nnuclei
         call nn_dist(j,npos,npos(1,j),tv,tv3)
         call nn_potential(tv,pt)
         nuc_pot = nuc_pot + 0.5d0*pt
      enddo
      print*,'Nuclear potential ',nuc_pot

      call total_nuclear_potential(npos,nuc_pot)
      print*,'Alt Nuclear potential ',nuc_pot
c set up fermion matrices

      call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
      call fermion_det(mup,mdown,det)
c      print*,'det',det

      call local_energy(npos,epos,mup,mdown,centers,rotmat,vp,en,ke,pe,
     >                  lpsi)
      print*,'local e',en
      dr = 2.0d-4
c      call wf_test(npos,epos,mup,mdown,centers,rotmat,vp,dr)

      if (do_min) then
         call optimize(nsteps,nblocks,nerrblocks,itmax,
     >                 npos,epos,mup,mdown,centers,rotmat,vp,scale)
      endif
      if (do_rew) then
         call rew_min(nsteps,nblocks,itmax,minit,
     >                 npos,epos,mup,mdown,centers,rotmat,vp,scale)
      endif

      nacc = 0

      if (do_energy) then
      do i=1,nvp
         ave_vp(i) = 0.d0
      enddo

      tme = etime(tme1)
      do ivp=1,nvpset

      do i=1,nvp
         ave_vp(i) = ave_vp(i) - (ave_vp(i) - vp_set(i,ivp))/dble(ivp)
      enddo
      if (mod(ivp,iskip).eq.0) then
c      do iphase = 1,2
      sum_en = 0.d0
      ssq_en = 0.d0
      sum_pr = 0.d0
      ssq_pr = 0.d0
      sum_ke = 0.d0
      ssq_ke = 0.d0
      sum_pe = 0.d0
      ssq_pe = 0.d0

         do i=1,nvp
           if (iphase.eq.1) then
              vp(i) = vp_set(i,ivp)
           else
              vp(i) = ave_vp(i)
           endif
         enddo

      call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
      call fermion_det(mup,mdown,det)
      do neb=1,vmc_nerrblocks
         tsum = 0.d0 
         tsum_ke = 0.d0
         tsum_pe = 0.d0
         do nb=1,vmc_nblocks
            do ns=1,nsteps
               call metropolis(mup,mdown,npos,epos,centers,rotmat,vp,
     >                         det,nac)
               nacc = nacc + nac
            enddo
            call local_energy(npos,epos,mup,mdown,centers,rotmat,vp,en,
     >                        ke,pe,lpsi)
            tsum = tsum + en
            tsum_ke = tsum_ke + ke
            tsum_pe = tsum_pe + pe 
c            write(40,'(2e20.10)') en+nuc_pot,en
         enddo
         en = tsum/vmc_nblocks
         ke = tsum_ke/vmc_nblocks
         pe = tsum_pe/vmc_nblocks + nuc_pot
         sum_en = sum_en + en
         ssq_en = ssq_en + en**2
         sum_ke = sum_ke + ke
         ssq_ke = ssq_ke + ke**2
         sum_pe = sum_pe + pe
         ssq_pe = ssq_pe + pe**2
         pr =  (2*ke+pe)/(3*box_len**3)
         sum_pr = sum_pr + pr
         ssq_pr = ssq_pr + pr*pr
c         write(41,'(6e14.5)') epos(1,1),epos(2,1),epos(3,1),
c     >       epos(1,2),epos(2,2),epos(3,2)
      enddo
      en = sum_en/vmc_nerrblocks
      var = ssq_en/vmc_nerrblocks-en*en
      err = sqrt(var/(vmc_nerrblocks-1))
c      if (iphase.eq.1) then
c         ave1 = en + nuc_pot
c         err1 = err
c      endif
c      enddo ! iphase
c      write(20,'(i7,4e18.9)') ivp+istart,ave1,err1,en+nuc_pot,err
      write(20,'(i7,2e18.9)') ivp+istart,en+nuc_pot,err
      call flush(20)
      endif  !mod

      enddo ! nvpset
      tme = etime(tme2)
      tme = tme2(1)-tme1(1)
      print*,'total time, per step',tme,tme/(nvpset/iskip)

      endif

      if (do_grad) then
      dr = 1.0d-3
      call estimate_gradient(npos,epos,mup,mdown,centers,rotmat,vp,dr,
     >                       nsteps,nblocks,en,b)
c      call compute_gradient(npos,epos,mup,mdown,centers,rotmat,vp,det,
c     >                       dr,en,b)
      do i=1,nvp
         print*,'b:',i,b(i)
      enddo
   
      endif
     


c      print*,'ave energy = ',sum_en/nblocks + nuc_pot
      en = sum_en/vmc_nerrblocks
      var = ssq_en/vmc_nerrblocks-en*en
      print*,'ave energy = ',en +nuc_pot,sqrt(var/(vmc_nerrblocks-1))
      ke = sum_ke/vmc_nerrblocks
      var = ssq_ke/vmc_nerrblocks-ke*ke

      pe = sum_pe/vmc_nerrblocks
      var = ssq_pe/vmc_nerrblocks-pe*pe
      print*,'ke',ke,sqrt(var/(vmc_nerrblocks-1))
      print*,'pe',pe,sqrt(var/(vmc_nerrblocks-1))

      pr = sum_pr/vmc_nerrblocks
      var = ssq_pr/vmc_nerrblocks-pr*pr
      print*,'ave pressure = ',pr*au_to_mbar,
     >            au_to_mbar*sqrt(var/(vmc_nerrblocks-1))

c      open(15,file=vp_out_file,err=911)
c      do i=1,nvp
c         write(15,*) vp(i)
c      enddo
c      close(15)
  

      print*,'acceptance ratio',real(nacc)/
     >          real(nsteps*nelec*vmc_nerrblocks*vmc_nblocks*nvpset)


      stop


911   continue
      print*,'file not found'
      stop

      end
      
