
c Main VMC program
      implicit none
      include 'param.h'
      include 'configs.h'

c storage created here
      real*8 epos(ndim,nelec),npos(ndim,nnuclei)
      real*8 centers(ndim,ncenter),rotmat(ndim,ndim,npair)
      real*8 mup(nup,nup),mdown(ndown,ndown)
      real*8 vp(nvp)


c local vars
      integer ns,j,np,nac,nacc,nb,i,neb
      real*8 det,en,nuc_pot,pt,dr
      real*8 sum_en,ke,pe,lpsi,ssq_en,var
      real*8 tsum_ke,tsum_pe,sum_pr,ssq_pr,pr,sum_ke,sum_pe
      real*8 ssq_ke,ssq_pe
      real*8 xpos,ypos
      real*8 rng
      external rng
      real*8 tv(nnuclei),tv3(ndim,nnuclei),b(nvp),scale(nvp)
      real*8 beta,wk,sca,sb,tsum,pscale,mintol
      real*8 au_to_mbar,gr_dr
c simulation variables
      integer nsteps,iseed,nblocks,nerrblocks,itmax,vmc_nblocks
      integer vmc_nerrblocks,minit
      integer iminz
      character*40 vp_file,pos_file,vp_out_file
      character*40 vp_log_file,grad_log_file,density_file
      character*40 gr_file
      logical do_min,do_grad,do_energy,do_rew,do_newton
      logical sample_dens,sample_gr
c
      integer inorm,ihits
      real*8 ar
      real*4 etime,tme1(2),tme2(2),tme
      external etime

     
      au_to_mbar = 294.215d0

      pme = .false.
c do gradient or random walk minimizations
      do_min = .false.
c compute the average gradient after the optimization
      do_grad = .false.
c do fixed sample reweighting minimization
      do_rew = .false.
c do newton minimization
      do_newton = .false.
c computer average energy after the optimization
      do_energy = .true.
      sample_dens = .false.
      sample_gr = .false.
      iseed = 102
      print*,'iminimize  1-yes, 0-no 2-rew 3-newton'
      read*,iminz
      if (iminz.eq.1) do_min = .true.
      if (iminz.eq.2) do_rew = .true.
      if (iminz.eq.3) do_newton = .true.
      print*,'iseed'
      read*,iseed
      call easy_init_rng(iseed)

c      print*,'nsteps'
c      read*,nsteps
      call read_integer_par(nsteps,"nsteps = ")
c      print*,'nblocks'
c      read*,nblocks
      call read_integer_par(nblocks,"nblocks = ")
c      print*,'vmc nblocks'
c      read*,vmc_nblocks
      call read_integer_par(vmc_nblocks,"vmc_nblocks = ")
c      print*,'vmc nerrblocks'
c      read*,vmc_nerrblocks
      call read_integer_par(vmc_nerrblocks,"vmc_nerrblocks = ")
      pscale = 1.d0
c can change box size to compute pressure the hard way
      print*,'pressure scale factor'
      read*,pscale

c set vp's and sim parameters

      pi = 4.d0*atan(1.d0)
      rs = 3.d0
c      rs = 2.6465d0
c      rs = 1.66775
c      rs = 2.1d0
      call read_double_par(rs,"rs = ")
      density = 3.d0/(4.d0*pi*rs**3)
      box_len = ( (2*npair)/density)**(1.d0/3.d0)
      box_len = pscale*box_len
      density = density/pscale**3

      if (npair.eq.1) then
      print*,'*** box_len fixed for h_2 optimization ***'
      box_len = 20.d0
      endif

      recip_box_len = 1.d0/box_len

      print*,'box_len = ',box_len

      call dist_init()   ! print free or periodic BC's
      call orbital_init()
    

      print*,'nvp = ',nvp

      print*,'vp file'
      read(5,'(a40)') vp_file

      print*,'vp log file'
      read(5,'(a40)') vp_log_file
      open(16,file=vp_log_file,err=911)

      print*,'vp out file'
      read(5,'(a40)') vp_out_file
      open(15,file=vp_file,status='OLD',err=911)
      do i=1,nvp
         read(15,*) vp(i)
      enddo
      close(15)

      print*,'grad log file'
      read(5,'(a40)') grad_log_file
      open(17,file=grad_log_file,err=911)

c some old stuff
      beta = 9.913d0
      ee_a = -.5d0
      ee_b = sqrt(.5d0/beta)
      en_a = 1.d0
      en_b = sqrt(1.d0/beta)

c ---------------


      print*,'scale factor'
      read*,sca
      do i=1,nvp
         scale(i) = sca
c         scale(i) = 0.d0
      enddo
      print*,'ien=',ien
c      scale(1) = sca
c      scale(ien) = sca
c      scale(13) = sca
c      scale(14) = sca
c      scale(15) = sca*.1d0
c      scale(1) = .4d0
c      scale(ien) = .4d0

   
      nerrblocks = 10
      print*,'nerrblocks'
      read*,nerrblocks
      
      itmax = 2
      print*,'itmax'
      read*,itmax

c for SGA
c      call read_integer_par(istart,'istart')
      if (do_min) then
      print*,'istart'
      read*,istart
      endif

      if (do_rew) then
         minit = 10
         print*,'minit'
         read*,minit
         print*,'minit = ',minit
         print*,'minimization tolerance'
         read*,mintol
         print*,'mintol = ',mintol
      endif

      delta = 1.d0
      print*,'delta'
      read*,delta


 
c AR vs delta
      if (.false.) then
      do i=1,nhist_acc
         acc_hits(i) = 0
         acc_norm(i) = 0
      enddo
      endif

c density sampling
      print*,'density file'
      read(*,'(a40)') density_file
      if (density_file.ne.'') sample_dens=.true.
      print*,'density file = ',density_file
      if (sample_dens) then
         call density_start()
      endif

c gr sampling (e-e and e-n)
      print*,'gr file'
      read(*,'(a40)') gr_file
      if (gr_file.ne.'') sample_gr=.true.
      print*,'gr file = ',gr_file
      if (sample_gr) then
         call read_double_par(gr_dr,"gr dr = ")
         call gr_ee_start(gr_dr)
      endif

c set up intial positions

c      xpos = 1.4d0
c      ypos = 1.4d0
c      do i=1,npair
c         do j=1,ndim
c           npos(j,2*i-1) = 0.d0
c           npos(j,2*i) = 0.d0
c         enddo
c      enddo
c      do j=1,npair
c         npos(1,2*j) = xpos
c         npos(2,2*j-1) = (j-1)*ypos
c         npos(2,2*j) = (j-1)*ypos
c      enddo
      print*,'nuc pos file'
      read(5,'(a40)') pos_file
      open(10,file=pos_file,status='OLD',err=911)
      do i=1,npair
          read(10,*) (npos(j,2*i-1),j=1,ndim)
          read(10,*) (npos(j,2*i),j=1,ndim)
      enddo
      close(10)
      do i=1,2*npair
         do j=1,ndim
            npos(j,i) = npos(j,i)*pscale
         enddo
      enddo
      

      if (do_rew) then
         print*,'etrial'
         read*,e_trial
         print*,'e_trial = ',e_trial
      else if (do_min) then
c for SGA
         print*,'SGA chk input file (none for none)'
         read(5,'(a40)') sga_in_chk_file
         print*,'SGA in = ',sga_in_chk_file
         print*,'SGA chk output file'
         read(5,'(a40)') sga_out_chk_file
         print*,'SGA out = ',sga_out_chk_file
      endif

      call set_centers(npos,centers,rotmat)
 
c      print*,'center',centers(1,1),centers(2,1),centers(3,1)

      sb = 1.d0
c molecular
      do np=1,npair
         do j=1,ndim
c            epos(j,np) = box_len*(rng()-.5d0)
            epos(j,np) = abs(centers(j,np) + sb*(rng()-.5d0))
            epos(j,np+npair) = abs(centers(j,np) + sb*(rng()-.5d0))
         enddo
      enddo
c atomic
c      do np=1,nnuclei
c         do j=1,ndim
c            epos(j,np) = npos(j,np) + sb*(rng()-.5d0)
c         enddo
c      enddo
c      do j=1,ndim
c        epos(j,1) = 0.d0
c        epos(j,2) = 0.d0
c      enddo
c      epos(1,1) = 0.20d0
c      epos(2,2) = 0.50d0


      nuc_pot = 0.d0
      do j=1,nnuclei
         call nn_dist(j,npos,npos(1,j),tv,tv3)
         call nn_potential(tv,pt)
         nuc_pot = nuc_pot + 0.5d0*pt
      enddo
      print*,'Nuclear potential ',nuc_pot

      call total_nuclear_potential(npos,nuc_pot)
      print*,'Alt Nuclear potential ',nuc_pot
c set up fermion matrices

      call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
      call fermion_det(mup,mdown,det)
      print*,'det',det

      call local_energy(npos,epos,mup,mdown,centers,rotmat,vp,en,ke,pe,
     >                  lpsi)
      print*,'local e',en+ nuc_pot
      dr = 1.0d-3
      call wf_test(npos,epos,mup,mdown,centers,rotmat,vp,dr)

      if (do_min) then
         call optimize(nsteps,nblocks,nerrblocks,itmax,
     >                 npos,epos,mup,mdown,centers,rotmat,vp,scale)
      endif
      if (do_rew) then
         call rew_min(nsteps,nblocks,itmax,minit,
     >                 npos,epos,mup,mdown,centers,rotmat,vp,scale,  
     >                 mintol)
      endif
      if (do_newton) then
         call newton(nsteps,nblocks,nerrblocks,itmax,
     >                 npos,epos,mup,mdown,centers,rotmat,vp,scale)
      endif

      sum_en = 0.d0
      ssq_en = 0.d0
      sum_pr = 0.d0
      ssq_pr = 0.d0
      sum_ke = 0.d0
      ssq_ke = 0.d0
      sum_pe = 0.d0
      ssq_pe = 0.d0
      nacc = 0
      if (do_energy) then
      tme  = etime(tme1)
      call fermion_fill(mup,mdown,centers,rotmat,vp,epos)
      call fermion_det(mup,mdown,det)
      do neb=1,vmc_nerrblocks
         tsum = 0.d0 
         tsum_ke = 0.d0
         tsum_pe = 0.d0
         do nb=1,vmc_nblocks
            do ns=1,nsteps
               call metropolis(mup,mdown,npos,epos,centers,rotmat,vp,
     >                         det,nac)
               nacc = nacc + nac
            enddo
            call local_energy(npos,epos,mup,mdown,centers,rotmat,vp,en,
     >                        ke,pe,lpsi)
            tsum = tsum + en
            tsum_ke = tsum_ke + ke
            tsum_pe = tsum_pe + pe 
            write(40,'(2e20.10)') en+nuc_pot,en
            if (sample_dens) call density_sample(epos)
            if (sample_gr) call gr_ee_sample(npos,epos)
         enddo
         en = tsum/vmc_nblocks
         ke = tsum_ke/vmc_nblocks
         pe = tsum_pe/vmc_nblocks + nuc_pot
         sum_en = sum_en + en
         ssq_en = ssq_en + en**2
         sum_ke = sum_ke + ke
         ssq_ke = ssq_ke + ke**2
         sum_pe = sum_pe + pe
         ssq_pe = ssq_pe + pe**2
         pr =  (2*ke+pe)/(3*box_len**3)
         sum_pr = sum_pr + pr
         ssq_pr = ssq_pr + pr*pr
c         write(41,'(6e14.5)') epos(1,1),epos(2,1),epos(3,1),
c     >       epos(1,2),epos(2,2),epos(3,2)
      enddo
      tme  = etime(tme2)
      endif

      if (do_grad) then
      dr = 1.0d-3
      call estimate_gradient(npos,epos,mup,mdown,centers,rotmat,vp,dr,
     >                       nsteps,nblocks,en,b)
c      call compute_gradient(npos,epos,mup,mdown,centers,rotmat,vp,det,
c     >                       dr,en,b)
      do i=1,nvp
         print*,'b:',i,b(i)
      enddo
      endif
     


c      print*,'ave energy = ',sum_en/nblocks + nuc_pot
      en = sum_en/vmc_nerrblocks
      var = ssq_en/vmc_nerrblocks-en*en
      print*,'ave energy = ',en +nuc_pot,sqrt(var/(vmc_nerrblocks-1))
      ke = sum_ke/vmc_nerrblocks
      var = ssq_ke/vmc_nerrblocks-ke*ke

      pe = sum_pe/vmc_nerrblocks
      var = ssq_pe/vmc_nerrblocks-pe*pe
      print*,'ke',ke,sqrt(var/(vmc_nerrblocks-1))
      print*,'pe',pe,sqrt(var/(vmc_nerrblocks-1))

      pr = sum_pr/vmc_nerrblocks
      var = ssq_pr/vmc_nerrblocks-pr*pr
      print*,'ave pressure = ',pr*au_to_mbar,
     >            au_to_mbar*sqrt(var/(vmc_nerrblocks-1))

      open(15,file=vp_out_file,err=911)
      do i=1,nvp
         write(15,*) vp(i)
      enddo
      close(15)
  

      print*,'acceptance ratio',real(nacc)/
     >          real(nsteps*nelec*vmc_nerrblocks*vmc_nblocks)

      print*,'VMC time = ',tme2(1)-tme1(1)

      if (.false.) then
c AR vs delta 
      open(50,file="ar.dat")
      inorm = 0
      do i=1,nhist_acc
         inorm = inorm + acc_norm(i)
         ihits = ihits + acc_hits(i)
      enddo
      print*,'sanity ar',ihits,inorm,dble(ihits)/dble(inorm)
      do i=1,nhist_acc
         if (acc_norm(i).eq.0)  then
            ar = 0.d0
         else
            ar = acc_hits(i)/dble(acc_norm(i))
         endif
         write(50,*) i,(i*delta)/nhist_acc,acc_hits(i),acc_norm(i),
     >               ar,acc_hits(i)/dble(inorm)
      enddo
      close(50)
      endif

c Density sampling
      if (sample_dens) call density_write(density_file)
      if (sample_gr) call gr_ee_write(gr_file)

      stop


911   continue
      print*,'file not found'
      stop

      end
      
