

       subroutine psi_oldnew(indx,rnew,npos,epos,vp,p)
          implicit none
          include 'param.h'
          integer indx
          real*8 rnew(ndim)
          real*8 epos(ndim,nelec),npos(ndim,nnuclei),vp(nvp)
          real*8 p

          real*8 tv(nelec),tv3(ndim,nelec)
          real*8 eej_old,een_old,eej_new,een_new
          real*8 sum

          call ee_dist(indx,epos,epos(1,indx),tv,tv3)
          call ee_jastrow(tv,vp,eej_old)

          call en_dist(npos,epos(1,indx),tv,tv3)
          call en_jastrow(tv,vp,een_old)

          call ee_dist(indx,epos,rnew,tv,tv3)
          call ee_jastrow(tv,vp,eej_new)

          call en_dist(npos,rnew,tv,tv3)
          call en_jastrow(tv,vp,een_new)
          
          sum = eej_new + een_new - eej_old - een_old
 
          p = exp(-2.d0*sum)

       end

       subroutine local_energy(npos,epos,mup,mdown,centers,rotmat,vp,en,
     >                         kin_e,pot_e,lpsi)
          implicit none
          include 'param.h'
          real*8 epos(ndim,nelec),npos(ndim,nnuclei)
          real*8 mup(nup,nup),mdown(ndown,ndown) 
          real*8 centers(ndim,ncenter),rotmat(ndim,ndim,npair),vp(nvp)
          real*8 en,kin_e,pot_e,lpsi

          integer i,j,k
          real*8 sum_ddf,dgrad3(ndim,nelec)
          real*8 tve(nelec),tve3(ndim,nelec)
          real*8 tvn(nnuclei),tvn3(ndim,nnuclei)
          real*8 eej,ee_dd,ee_du(nelec)
          real*8 enj,en_dd,en_du(nelec)
          real*8 ke,g(ndim),pf,ff,df,dot,pot,pt

          real*4 etime,tme,tme1(2),tme2(2)
          external etime

c          tme = etime(tme1)
          call fermion_grad(mup,mdown,epos,centers,rotmat,vp,dgrad3,
     >                      sum_ddf)
c          tme = etime(tme2)
c          det_time = det_time + tme2(1)-tme1(1)
          ke = 0.d0
          pf = 0.d0
          ff = 0.d0
          df = 0.d0
          pot = 0.d0
          lpsi = 0.d0
          do i=1,nelec
             call ee_dist(i,epos,epos(1,i),tve,tve3)
             call ee_jastrow_d(tve,vp,eej,ee_dd,ee_du)

             call en_dist(npos,epos(1,i),tvn,tvn3)
             call en_jastrow_d(tvn,vp,enj,en_dd,en_du)
             ke = ke + ee_dd + en_dd
             lpsi = lpsi + eej + 2*enj
             do j=1,nelec-1
                ke = ke + 2.d0*ee_du(j)/tve(j)
             enddo
             do j=1,nnuclei
                ke = ke + 2.d0*en_du(j)/tvn(j)
             enddo
             do k=1,ndim
                g(k) = 0.d0
             enddo
             do j=1,nelec-1
                do k=1,ndim
                   g(k) = g(k) + ee_du(j)*tve3(k,j)/tve(j)
                enddo
             enddo
             do j=1,nnuclei
                do k=1,ndim
                   g(k) = g(k) + en_du(j)*tvn3(k,j)/tvn(j)
                enddo
             enddo

             dot = 0.d0
             do k=1,ndim
                dot = dot + g(k) * g(k)
             enddo
             pf = pf + dot

             dot = 0.d0
             do k=1,ndim
                dot = dot + g(k) * dgrad3(k,i)
             enddo
             ff = ff + dot

c             dot = 0.d0
c             do k=1,ndim
c                dot = dot + dgrad3(k,i) * dgrad3(k,i)
c             enddo
c             df = df + dot

             call ee_potential(tve,pt)
             pot = pot + .5d0*pt

             call en_potential(tvn,pt)
             pot = pot + pt
             
          enddo
c          tme = etime(tme1)
c          jas_time = jas_time + tme1(1)-tme2(1)

c          print*,'ke,pf',ke,pf
c          print*,'ff,ddf',ff,sum_ddf
c          print*,'pot',pot
c          write(42,'(5e14.5)') ke,pf,ff,sum_ddf,pot
          en = .5d0*(ke-pf) + ff - .5d0*sum_ddf + pot 
          kin_e = .5d0*(ke-pf) + ff - .5d0*sum_ddf
          pot_e = pot

       end

       subroutine local_energy_vp(npos,epos,mup,mdown,centers,rotmat,vp,
     >                        en,ee_deriv,en_deriv)
          implicit none
          include 'param.h'
          real*8 epos(ndim,nelec),npos(ndim,nnuclei)
          real*8 mup(nup,nup),mdown(ndown,ndown) 
          real*8 centers(ndim,ncenter),rotmat(ndim,ndim,npair),vp(nvp)
          real*8 en,ee_deriv(nvp_ee),en_deriv(nvp_en)

          integer i,j,k
          real*8 sum_ddf,dgrad3(ndim,nelec)
          real*8 tve(nelec),tve3(ndim,nelec)
          real*8 tvn(nnuclei),tvn3(ndim,nnuclei)
          real*8 eej,ee_dd,ee_du(nelec)
          real*8 enj,en_dd,en_du(nelec)
          real*8 ke,g(ndim),pf,ff,df,dot,pot,pt

          call fermion_grad(mup,mdown,epos,centers,rotmat,vp,dgrad3,
     >                      sum_ddf)
          ke = 0.d0
          pf = 0.d0
          ff = 0.d0
          df = 0.d0
          pot = 0.d0
          do i=1,nelec
             call ee_dist(i,epos,epos(1,i),tve,tve3)
             call ee_jastrow_d_vp(tve,vp,eej,ee_dd,ee_du,ee_deriv)

             call en_dist(npos,epos(1,i),tvn,tvn3)
             call en_jastrow_d_vp(tvn,vp,enj,en_dd,en_du,en_deriv)
             ke = ke + ee_dd + en_dd
             do j=1,nelec-1
                ke = ke + 2.d0*ee_du(j)/tve(j)
             enddo
             do j=1,nnuclei
                ke = ke + 2.d0*en_du(j)/tvn(j)
             enddo
             do k=1,ndim
                g(k) = 0.d0
             enddo
             do j=1,nelec-1
                do k=1,ndim
                   g(k) = g(k) + ee_du(j)*tve3(k,j)/tve(j)
                enddo
             enddo
             do j=1,nnuclei
                do k=1,ndim
                   g(k) = g(k) + en_du(j)*tvn3(k,j)/tvn(j)
                enddo
             enddo

             dot = 0.d0
             do k=1,ndim
                dot = dot + g(k) * g(k)
             enddo
             pf = pf + dot

             dot = 0.d0
             do k=1,ndim
                dot = dot + g(k) * dgrad3(k,i)
             enddo
             ff = ff + dot

c             dot = 0.d0
c             do k=1,ndim
c                dot = dot + dgrad3(k,i) * dgrad3(k,i)
c             enddo
c             df = df + dot

             call ee_potential(tve,pt)
             pot = pot + .5d0*pt

             call en_potential(tvn,pt)
             pot = pot + pt
             
          enddo

c          print*,'ke,pf',ke,pf
c          print*,'ff,ddf',ff,sum_ddf
c          print*,'pot',pot
c          write(42,'(5e14.5)') ke,pf,ff,sum_ddf,pot
          en = .5d0*(ke-pf) + ff - .5d0*sum_ddf + pot 
c          kin_e = .5d0*(ke-pf) + ff - .5d0*sum_ddf
c          pot_e = pot

       end


       subroutine quant_force(npos,epos,mup,mdown,centers,rotmat,vp,
     >                        indx,xt,fq)
          implicit none
          include 'param.h'
          real*8 epos(ndim,nelec),npos(ndim,nnuclei)
          real*8 mup(nup,nup),mdown(ndown,ndown) 
          real*8 centers(ndim,npair),rotmat(ndim,ndim,npair),vp(nvp)
          real*8 xt(ndim),fq(ndim)
          integer indx

          real*8 gd(ndim),sum_gdd,g(ndim)
          real*8 tve(nelec),tve3(ndim,nelec)
          real*8 tvn(nnuclei),tvn3(ndim,nnuclei)
          real*8 eej,ee_dd,ee_du(nelec)
          real*8 enj,en_dd,en_du(nelec)
          integer i,j

          call fermion_grad_one(mup,mdown,centers,rotmat,vp,gd,sum_gdd,
     >                     indx,xt)
         
          call ee_dist(indx,epos,xt,tve,tve3)
          call ee_jastrow_d(tve,vp,eej,ee_dd,ee_du)

          call en_dist(npos,xt,tvn,tvn3)
          call en_jastrow_d(tvn,vp,enj,en_dd,en_du)

          do i=1,ndim
             g(i) = 0.d0
          enddo

          do j=1,nelec-1
             do i=1,ndim
                g(i) = g(i) + ee_du(j)*tve3(i,j)/tve(j)
             enddo
          enddo
        
          do j=1,nnuclei
             do i=1,ndim
                g(i) = g(i) + en_du(j)*tvn3(i,j)/tvn(j)
             enddo
          enddo

          do i=1,ndim
             fq(i) = 2.d0*(gd(i)-g(i))
          enddo
           


       end



